# Releases (2013)

Here is the list of official releases made during the year 2013. A similar list for 2012 is also available.

It is also possible to just use the GIT version or snapshot, contact the mailing list and check the GIT log to gauge progress.

### 1.2.0: Dec 02 2013

- Features:
  Add support for gluster pool (Eric Blake),
  Separation of python binding (Daniel P. Berrange),
  vbox: add support for 4.3 APIs (Ryota Ozaki)
- Documentation:
  fix typos in libvirt.h.in (Chen Hanxiao),
  Link libvirt-sandbox from apps page (Daniel P. Berrange),
  Add docs about audit subsystem logging (Daniel P. Berrange),
  virsh: fix doc typos (Nehal J Wani),
  Fix typos in various docs (Nehal J Wani),
  LXC: add securetty related note in Device nodes (Gao feng),
  Fix three minor typos (Yuri Chornoivan),
  storage: fix typo in previous patch (Eric Blake),
  storage: document gluster pool (Eric Blake),
  virDomainReboot: Document that migration might be unsafe (Michal Privoznik),
  delete extra character (Wangyufei (A)),
  maint: fix comment typos. (Eric Blake),
  improve job info details (Eric Blake),
  fix a typo in formatnwfilter.html.in (Chen Hanxiao),
  Improve cgroups docs to cover systemd integration (Daniel P. Berrange),
  fix typos in libvirt.h.in (Chen Hanxiao),
  fix virDomainRestoreFlags description bug (Wang Yufei),
  grammar fixes (Eric Blake),
  add SystemTap to apps using libvirt (Jonathan Lebon),
  fix a typo in formatnwfilter (Chen Hanxiao),
  caps: Fix function docs for virCapabilitiesAddHostNUMACell (Peter Krempa)
- Portability:
  tests: fix virpcitest with read-only srcdir (Eric Blake),
  tests: guarantee abs_srcdir in all C tests (Eric Blake),
  look for numad in /usr/sbin (Jim Fehlig),
  build: Don't fail on '&lt;' or '&gt;' with old xmllint (Martin Kletzander),
  spec: fix libvirt-docs subpackage on RHEL-6 (Michael Chapman),
  Don't depend on syslog.service (Guido Günther),
  qemuMonitorJSONGetCPUx86Data: Don't fail on ancient qemus (Michal Privoznik),
  build: work around super-old readline.h (Ryota Ozaki),
  Fix migration with QEMU 1.6 (Michael Avdienko),
  nodeinfo: fix build on non-Linux (Eric Blake)
- Bug Fixes:
  vbox: handle errors of virDomainHostdevDefAlloc correctly (Ryota Ozaki),
  vbox: fix incorrect loop condition in vboxHostDeviceGetXMLDesc (Ryota Ozaki),
  Fix memory leak in virNWFilterDefParseXML() (Nehal J Wani),
  Fix memory leak in virDomainDefParseXML() (Nehal J Wani),
  LXC: Ensure security context is set when mounting images (Daniel P. Berrange),
  network: properly update iptables rules during net-update (Laine Stump),
  Fix bug in identifying sub-mounts (Daniel P. Berrange),
  storage: skip selinux cleanup when fd not available (Eric Blake),
  qemu: preserve netdev MAC address during 'domxml-to-native' (Bing Bu Cao),
  storage: don't read storage volumes in nonblock mode (Eric Blake),
  LXC: don't unmount mounts for shared root (Gao feng),
  LXC: fix the problem that libvirt lxc fail to start on latest kernel (Gao feng),
  sasl: Fix authentication when using PLAIN mechanism (Christophe Fergeau),
  Fix invalid read in virNetSASLSessionClientStep debug log (Christophe Fergeau),
  Tie SASL callbacks lifecycle to virNetSessionSASLContext (Christophe Fergeau),
  remote: Don't leak priv->tls object on connection failure (Christophe Fergeau),
  spec: Don't save/restore running VMs on libvirt-client update (Jiri Denemark),
  virsh domxml-from-native to treat SCSI as the bus type for pseries by default (Shivaprasad G Bhat),
  Don't start a nested job in qemuMigrationPrepareAny (Ján Tomko),
  spec: Don't save/restore running VMs on libvirt-client update (Cole Robinson),
  spec: Restrict virt-login-shell usage (Jiri Denemark),
  storage: use valid XML for awkward volume names (Eric Blake),
  storage: Returns earlier if source adapter of the scsi pool is a HBA (Osier Yang),
  libvirt-guests: Run only after libvirtd (Cole Robinson),
  Fix off-by-1 in default SELinux MCS range (Daniel P. Berrange),
  vbox: fix segfault on virsh dumpxml with the existence of USB filters (Ryota Ozaki),
  Add missing 'return 0;' in stub lxcStartFuse() method impl. (Daniel P. Berrange),
  Avoid async signal safety problem in glibc's setxid (Daniel P. Berrange),
  Don't release spice port twice when no TLS port is available (Ján Tomko),
  Properly unref a connection with a close callback (Ján Tomko),
  qemu: Call qemuSetupHostdevCGroup later during hotplug (Jiri Denemark),
  qemuMonitorIO: Don't use @mon after it's unrefed (Michal Privoznik),
  qemuProcessReconnectHelper: Don't create joinable thread (Michal Privoznik),
  virDomainEventCallbackListFree: Don't leak @list->callbacks (Michal Privoznik),
  networkBuildDhcpDaemonCommandLine: Don't leak @configstr and @configfile (Michal Privoznik),
  Disable nwfilter driver when running unprivileged (Ján Tomko),
  libxl: Fix Xen 4.4 libxlVmStart logic (Jason Andryuk),
  qemu: Check for presence of device and properities when getting CPUID (Peter Krempa),
  Fix busy wait loop in LXC container I/O handling (Daniel P. Berrange),
  Don't expose 'none' machine type to capabilities (Daniel P. Berrange),
  Fix mem leak in virQEMUCapsProbeQMPMachineTypes on OOM (Daniel P. Berrange),
  virSecurityLabelDefParseXML: Don't parse label on model='none' (Michal Privoznik),
  virsh-domain: Mark --live and --config mutually exclusive in vcpucount (Peter Krempa),
  qemu: Fix SCSI hotplug on pseries guests (Vitor de Lima),
  pci: properly handle out-of-order SRIOV virtual functions (Laine Stump),
  util: use -w flag when calling iptables (Serge Hallyn),
  storage: Fix a vol-clone bug on ppc64 (Li Zhang),
  qemu: Don't access vm->priv on unlocked domain (Michal Privoznik),
  qemu: Avoid double free of VM (Michal Privoznik),
  Allow root directory in filesystem source dir schema (Ján Tomko),
  qemuMigrationBeginPhase: Check for 'drive-mirror' for NBD (Michal Privoznik),
  conf: fix incorrect error log in virCPUDefIsEqual (Chen Hanxiao),
  qemuMonitorDispose: Reset lastError (Michal Privoznik),
  qemu: clean up migration ports when migration cancelled (Zeng Junliang),
  network: fix connections count in case of allocate failure (Laine Stump),
  virpcitest: Fix variable arguments using in pci_driver_new (Michal Privoznik),
  virpci: Don't error on unbinded devices (Michal Privoznik)
- Improvements:
  Pull lxcContainerGetSubtree out into shared virfile module (Daniel P. Berrange),
  Introduce standard methods for sorting strings with qsort (Daniel P. Berrange),
  conf: Export virStorageVolType enum helper functions (Peter Krempa),
  sasl: Replace 'restep' label with 'continue' (Christophe Fergeau),
  storage: probe qcow2 volumes in gluster pool (Eric Blake),
  storage: improve handling of symlinks in gluster (Eric Blake),
  storage: improve allocation stats reported on gluster files (Eric Blake),
  storage: improve directory support in gluster pool (Eric Blake),
  storage: add network-dir as new storage volume type (Eric Blake),
  storage: implement rudimentary glusterfs pool refresh (Eric Blake),
  storage: initial support for linking with libgfapi (Eric Blake),
  storage: expose volume meta-type in XML (Eric Blake),
  storage: allow interleave in volume XML (Eric Blake),
  maint: next release is 1.2.0 (Eric Blake),
  vbox: import vbox_CAPI_v4_3.h from SDK (Ryota Ozaki),
  vbox: pull vboxHostDeviceGetXMLDesc out from vboxDomainGetXMLDesc (Ryota Ozaki),
  vbox: cleanup vboxAttachUSB (Ryota Ozaki),
  lxc: don't do duplicate work when getting pagesize (Chen Hanxiao),
  maint: update to latest gnulib (Eric Blake),
  python: remove virConnectGetCPUModelNames from globals (Doug Goldstein),
  python: remove virConnectGetCPUModelNames from globals (Doug Goldstein),
  qemu: Auto-generate controller for hotplugged hostdev (Eric Farman),
  qemu: Separate calls based on controller bus type (Eric Farman),
  qemu: Rename controller hotplug functions to not be PCI-specific (Eric Farman),
  qemu: Add support for virt machine type with virtio-mmio devices on armv7 (Clark Laughlin),
  maint: enforce comma style usage (Eric Blake),
  maint: fix comma style issues: remaining code (Eric Blake),
  maint: fix comma style issues: remaining drivers (Eric Blake),
  maint: fix comma style issues: vbox (Eric Blake),
  maint: fix comma style issues: python (Eric Blake),
  maint: fix comma style issues: util (Eric Blake),
  maint: fix comma style issues: tests, tools (Eric Blake),
  maint: fix comma style issues: qemu (Eric Blake),
  maint: fix comma style issues: xen (Eric Blake),
  maint: fix comma style issues: conf (Eric Blake),
  maint: fix comma style issues: nwfilter (Eric Blake),
  Error out on unterminated arrays and objects in JSON parser (Ján Tomko),
  Test if JSON parser fails on invalid input (Ján Tomko),
  maint: ship .pl scripts as executables (Eric Blake),
  Fix virsh net-info output for consistency (Hao Liu),
  Add missing break to switch-case block (Doug Goldstein),
  qemumonitorjsontest: Introduce GetNonExistingCPUData test (Michal Privoznik),
  Macro for testing the version you are compiling with (Doug Goldstein),
  Return -1 in virPortAllocatorAcquire if all ports are used (Ján Tomko),
  Add a name to virPortAllocator (Ján Tomko),
  storage: fix RNG validation of gluster via netfs (Eric Blake),
  virsh-secret: Unify list column alignment (Peter Krempa),
  virsh-interface: Unify list column alignment (Peter Krempa),
  virsh-nwfilter: Unify list command column alignment (Peter Krempa),
  virsh-pool: Unify spacing of listing function (Peter Krempa),
  qemu: Change return type of qemuMonitorGetGuestCPU() (Peter Krempa),
  virsh-volume: Unify strigification of volume type (Peter Krempa),
  virsh-volume: Unify alignment of vol-list output columns (Peter Krempa),
  conf: Refactor virDomainDiskSourceDefParse (Peter Krempa),
  conf: Rename virDomainDiskHostDefFree to virDomainDiskHostDefClear (Peter Krempa),
  conf: Split out code to parse the source of a disk definition (Peter Krempa),
  qemuDomainObjStart: Warn on corrupted image (Michal Privoznik),
  util: use size_t instead of unsigned int for num_virtual_functions (Laine Stump),
  qemu: assign PCI address to primary video card (Vitor de Lima),
  qemu: process: Validate specific CPUID flags of a guest (Peter Krempa),
  qemu: Add support for paravirtual spinlocks in the guest (Peter Krempa),
  conf: Refactor storing and usage of feature flags (Peter Krempa),
  cpu: x86: Add internal CPUID features support and KVM feature bits (Peter Krempa),
  qemu: Add monitor APIs to fetch CPUID data from QEMU (Jiri Denemark),
  cpu_x86: Refactor storage of CPUID data to add support for KVM features (Peter Krempa),
  tests: Distribute virpcitestdata (Michal Privoznik),
  tests: Fix virtpcitest in VPATH (Jiri Denemark),
  conf: Refactor virDomainDiskSourcePoolDefParse (Peter Krempa),
  storage: always probe type with buffer (Eric Blake),
  storage: refactor backing chain division of labor (Eric Blake),
  storage: reduce number of stat calls (Eric Blake),
  storage: avoid short reads while chasing backing chain (Eric Blake),
  storage: use simpler 'char *' (Eric Blake),
  test driver: add support for .connectBaselineCPU (Giuseppe Scrivano),
  virpcitest: Introduce testVirPCIDeviceReset (Michal Privoznik),
  virt-login-shell: also build virAtomic.h (Guido Günther),
  storage: recognize gluster as networked file (Eric Blake),
  qemu: don't use deprecated -no-kvm-pit-reinjection (Ján Tomko),
  Resolve Coverity issue regarding not checking return value (John Ferlan),
  Skip any files which are not mounted on the host (Daniel P. Berrange),
  Add flag to lxcBasicMounts to control use in user namespaces (Daniel P. Berrange),
  Remove duplicate entries in lxcBasicMounts array (Daniel P. Berrange),
  Remove pointless 'srcpath' variable in lxcContainerMountBasicFS (Daniel P. Berrange),
  Remove unused 'opts' field from LXC basic mounts struct (Daniel P. Berrange),
  Add virFileIsMountPoint function (Daniel P. Berrange),
  virpcitest: Introduce check for unbinded devices (Michal Privoznik),
  virpcitest: Introduce testVirPCIDeviceReattach (Michal Privoznik),
  virpcitest: Test virPCIDeviceDetach (Michal Privoznik),
  tests: Introduce virpcitest (Michal Privoznik),
  cpu: x86: Parse the CPU feature map only once (Peter Krempa),
  cpu: Export few x86-specific APIs (Jiri Denemark),
  nodeinfo: Remove libnuma include (Peter Krempa),
  numa: Add wrapper of numa_node_to_cpus and use it (Peter Krempa),
  numa: Replace NUMA_MAX_N_CPUS macro with virNumaGetMaxCPUs() (Peter Krempa),
  nodeinfo: Get rid of nodeGetCellMemory (Peter Krempa),
  numa: Introduce virNumaGetNodeMemory and use it instead of numa_node_size64 (Peter Krempa),
  numa: Introduce virNumaGetMaxNode and use it instead of numa_max_node (Peter Krempa),
  nodeinfo: Avoid forward declarations of static functions (Peter Krempa),
  numa: Introduce virNumaIsAvailable and use it instead of numa_available (Peter Krempa)
- Cleanups:
  Remove obsolete 'tests' makefile target (Daniel P. Berrange),
  Mostly revert "python: remove virConnectGetCPUModelNames from globals" (Daniel P. Berrange),
  Remove redundant braces (Ján Tomko),
  virPCIDeviceBindToStub: Remove unused @oldDriverPath and @oldDriverName (Michal Privoznik)

### 1.1.4: Nov 04 2013

- Features:
  Add support for AArch64 architecture (Pranavkumar Sawargaonkar),
  Various improvements on test code and test driver (many people)
- Security:
  Don't link virt-login-shell against libvirt.so (CVE-2013-4400) (Daniel P. Berrange),
  Close all non-stdio FDs in virt-login-shell (CVE-2013-4400) (Daniel P. Berrange),
  Only allow 'stderr' log output when running setuid (CVE-2013-4400) (Daniel P. Berrange),
  Fix perms for virConnectDomainXML{To,From}Native (CVE-2013-4401) (Daniel P. Berrange)
- Documentation:
  generate links from plain text documentation (Claudio Bley),
  define style of code blocks inside descriptions (Claudio Bley),
  add class "description" to div's containing descriptions (Claudio Bley),
  process code blocks similar to Markdown (Claudio Bley),
  fix typos in formatnwfilter (Chen Hanxiao),
  fix a typo in formatdomain (Chen Hanxiao),
  virsh: fix doc typos (Eric Blake),
  maint: typo fixes (Eric Blake),
  fix some typos about 'informations' (Chen Hanxiao),
  fix a typo in formatdomain (Chen Hanxiao),
  Expand description of host-model CPU mode (Jiri Denemark),
  virsh: fix a typo in virsh-domain (Chen Hanxiao),
  storage: document existing pools (Eric Blake),
  remote-driver: Fix 'leav' typo in comment (Christophe Fergeau),
  change the minimum weight description for blkio (Chen Hanxiao),
  Add some notes about secure usage of libvirt (Daniel P. Berrange),
  lxc: Fix an improper comment in lxc_process.c (Chen Hanxiao),
  nwfilter: fix a typo in nwfilter_gentech_driver.c (Hongwei Bi),
  cgroup: fix a comment typo in vircgroup.c (Chen Hanxiao),
  fix typo in HACKING (Chen Hanxiao),
  aclpolkit: Fix a heading typo (Cole Robinson)
- Portability:
  virnetsocket: fix getsockopt on FreeBSD (Ryota Ozaki),
  MacOS: Handle changes to xdrproc_t definition (Doug Goldstein),
  fix api changes in xen restore (Bamvor Jian Zhang),
  MacOS: Re-add support for QEMU backend (Doug Goldstein),
  rpc: Retrieve peer PID via new getsockopt() for Mac (Doug Goldstein),
  build: fix build of virt-login-shell on systems with older gnutls (Jim Fehlig),
  build: fix linking virt-login-shell (Jim Fehlig),
  nodeinfo: fix physical memory size on Mac OS X (Ryota Ozaki),
  Add stub getegid impl for platforms lacking it (Daniel P. Berrange),
  better error checking for LOCAL_PEERCRED (Brian Candler),
  Add support for detecting PPC little endian arches (Daniel P. Berrange),
  xenapi: Fix build after const correctnes changes (Peter Krempa),
  rpc: Fix getsockopt on Snow Leopard and lower (Doug Goldstein),
  build: fix linker error on FreeBSD (Giuseppe Scrivano),
  tests: avoid compile failure on linux kernels older than 2.6.19 (Giuseppe Scrivano),
  nodeinfo: make freebsdNodeGetCPUCount work on Mac OS X (Ryota Ozaki),
  rpc: fix getsockopt for LOCAL_PEERCRED on Mac OS X (Ryota Ozaki),
  build: fix build on 32-bit platforms (Eric Blake),
  build: fix build on RHEL 5 (Eric Blake),
  build: fix build --without-remote (Eric Blake)
- Bug Fixes:
  Fix race in starting transient VMs (Daniel P. Berrange),
  Use a port from the migration range for NBD as well (Ján Tomko),
  nodedev_hal: fix segfault when virDBusGetSystemBus fails (Ryota Ozaki),
  Fix race condition reconnecting to vms & loading configs (Daniel P. Berrange),
  Don't update dom->persistent without lock held (Daniel P. Berrange),
  storage: fix incorrect typedef (Eric Blake),
  apparmor: Fix typo in function name in driver struct initialization (Peter Krempa),
  qemu: fix well-formed migration URI formatting (Michael Chapman),
  LXC: don't free tty before using it in lxcContainerSetupDevices (Gao feng),
  python: Fix Create*WithFiles filefd passing (Marian Neagul),
  networkStartDhcpDaemon: Check for dnsmasqCapsRefresh failure (Hongwei Bi),
  virsh: Fix job watching when STDIN is not a tty (Peter Krempa),
  qemu: fix removal of <interface type='hostdev'> (Laine Stump),
  Fix a problem introduced by commit 99889012 (Geoff Hickey),
  qemu: Avoid assigning unavailable migration ports (Wang Yufei),
  viralloc.h: Fix typo in VIR_APPEND_ELEMENT_COPY_QUIT (Michal Privoznik),
  remote: fix regression in event deregistration (Zhou Yimin),
  daemon: don't free domain if it's null (Chen Hanxiao),
  Remove ATTRIBUTE_NONNULL(3) from qemuMonitorJSONDrivePivot (John Ferlan),
  rpc: Correct the wrong payload size checking (Osier Yang),
  Fix typo breaking cgroups for NBD backed filesystems (Daniel P. Berrange),
  Ignore thin pool LVM devices. (Dusty Mabe),
  domain_conf.c: Initialize arrVar and cntVar (Michal Privoznik),
  vbox: handle 'saved' state of VMs (Ryota Ozaki),
  esx: Fix floppy.fileName handling in the vmx file parser (Geoff Hickey),
  Convert uuid to a string before printing it (Ján Tomko),
  Initialize threading & error layer in LXC controller (Daniel P. Berrange),
  Don't ignore all dbus connection errors (Daniel P. Berrange),
  Fix exit status of lxc controller (Daniel P. Berrange),
  Fix flaw in detecting log format (Daniel P. Berrange),
  qemu_migration: Avoid crashing if domain dies too quickly (Michal Privoznik),
  util: fix two virCompareLimitUlong bugs (Bing Bu Cao),
  storage_backend: Fix issue with allocation of 0 length volume (John Ferlan),
  qemu: Init @pcidevs in qemuPrepareHostdevPCIDevices (Michal Privoznik),
  LXC: Fix handling of RAM filesystem size units (Ján Tomko),
  Don't clobber 'ret' variable in testCompareXMLToXMLHelper (Daniel P. Berrange),
  Adjust legacy max payload size to account for header information (Claudio Bley),
  storage: fix file allocation behavior in file cloning (Oskari Saarenmaa),
  virfile: safezero: fix buffer allocation max size (Oskari Saarenmaa),
  test: Fix coverity warnings (Cole Robinson),
  nodedev: Resolve Relax-NG validity error (John Ferlan),
  Free cmd in virNetDevVethCreate (Gao feng),
  Free cmd in virNetDevVethDelete (Gao feng),
  qemu: check actual netdev type rather than config netdev type during init (Laine Stump),
  qemuMonitorTestFree: Join worker thread (Michal Privoznik),
  Avoid deleting NULL veth device name (Daniel P. Berrange),
  qemuMonitorJSONSendKey: Avoid double free (Michal Privoznik),
  qemuMonitorJSONGetVirtType: Fix error message (Michal Privoznik),
  qemu: cgroup: Fix crash if starting nographics guest (Cole Robinson),
  selinux: Only close the selabel_handle once (Ján Tomko),
  Fix handling of IPv6 listen addresses in cmdDomDisplay (Ján Tomko),
  util: recognize SMB/CIFS filesystems as shared (Laine Stump),
  Fix leak of objects when reconnecting to QEMU instances (Daniel P. Berrange)
- Improvements:
  libxl: fix dubious cpumask handling in libxlDomainSetVcpuAffinities (Jeremy Fitzhardinge),
  Improve debugging of QEMU start/stop (Daniel P. Berrange),
  Improve debugging of job enter/exit code (Daniel P. Berrange),
  storage: use correct type for array count (Eric Blake),
  maint: avoid further typedef accidents (Eric Blake),
  libvirt.c: indent code of virDomainGetMemoryParameters's documentation (Claudio Bley),
  libvirt.c: add 2 spaces of indentation to example code of virStreamSend (Claudio Bley),
  Add '+' to uid/gid printing for label processing (John Ferlan),
  Push RPM deps down into libvirt-daemon-driver-XXXX sub-RPMs (Daniel P. Berrange),
  capabilities: add baselabel per sec driver/virt type to secmodel (Giuseppe Scrivano),
  security: add new internal function "virSecurityManagerGetBaseLabel" (Giuseppe Scrivano),
  security: use a single function to set DAC user and group (Giuseppe Scrivano),
  virsh: new environment variable VIRSH_HISTSIZE (Pavel Raiskup),
  maint: update to latest gnulib (Eric Blake),
  Skip debug message in lxcContainerSetID if no map is set. (Chen Hanxiao),
  Avoid Coverity DEADCODE warning (John Ferlan),
  virsh: allow alias to expand to opt=value pair (Eric Blake),
  Ignore GNU Global tag files (Martin Kletzander),
  build: Fix prohibit_int_ijk (and iijjkk) on RHEL 5 (Martin Kletzander),
  Get rid of shadowed booleans (Michal Privoznik),
  vircgroupmock: Mock access() to some more files (Michal Privoznik),
  tests: Use lv_abs_top_builddir instead of bare abs_top_builddir (Michal Privoznik),
  qemu: move qemuDomainRemoveNetDevice to avoid forward reference (Laine Stump),
  qemu: simplify calling qemuDomainHostdevNetConfigRestore (Laine Stump),
  Move virt-login-shell into libvirt-login-shell sub-RPM (Daniel P. Berrange),
  Block all use of libvirt.so in setuid programs (Daniel P. Berrange),
  Remove (nearly) all use of getuid()/getgid() (Daniel P. Berrange),
  Don't allow remote driver daemon autostart when running setuid (Daniel P. Berrange),
  Only allow the UNIX transport in remote driver when setuid (Daniel P. Berrange),
  Block all use of getenv with syntax-check (Daniel P. Berrange),
  Remove all direct use of getenv (Daniel P. Berrange),
  Make virCommand env handling robust in setuid env (Daniel P. Berrange),
  Set a sane $PATH for virt-login-shell (Daniel P. Berrange),
  Add helpers for getting env vars in a setuid environment (Daniel P. Berrange),
  qemu: Fix augeas support for migration ports (Michal Privoznik),
  qemu: Make migration port range configurable (Jiri Denemark),
  netcf: Don't complain when cleanup is called before init (Christophe Fergeau),
  virsh: improve usability of '--print-xml' flag for attach-disk command (Chen Hanxiao),
  esx: Remove unnecessary NULL comparisons (3/3) (Geoff Hickey),
  esx: Remove unnecessary NULL comparisons (2/3) (Geoff Hickey),
  esx: Remove unnecessary NULL comparisons (1/3) (Geoff Hickey),
  Add support for enabling SASL for SPICE guests (Daniel P. Berrange),
  qemuDomainCleanupRemove: s/memmove/VIR_DELETE_ELEMENT_INPLACE/ (Michal Privoznik),
  build: use the gnulib version of the .m4 files when present (Giuseppe Scrivano),
  storage: allow interleave in pool XML (Eric Blake),
  Add some logging to LXC disk/fs nbd/loop setup (Daniel P. Berrange),
  Add logging to LXC cgroup devices setup (Daniel P. Berrange),
  Add log statement when NBD device is setup (Daniel P. Berrange),
  AArch64: Add qemu capabilities schemeta for test. (Pranavkumar Sawargaonkar),
  Implement minimal sysinfo for AArch64 platforms. (Pranavkumar Sawargaonkar),
  AArch64: Parse cputopology from /proc/cpuinfo. (Pranavkumar Sawargaonkar),
  AArch64: CPU Support for AArch64 (ARMv8 64bit). (Pranavkumar Sawargaonkar),
  AArch64: Add AArch64 architecture to list of valid arches. (Pranavkumar Sawargaonkar),
  cpu: x86: Clean up error messages in x86VendorLoad() (Peter Krempa),
  cpu: x86: Use whitespace to clarify context and use consistent labels (Peter Krempa),
  cpu: x86: Fix function header formatting and whitespace (Peter Krempa),
  cpu: x86: Fix return types of x86cpuidMatch and x86cpuidMatchMasked (Peter Krempa),
  cpu: x86: Rename data_iterator and DATA_ITERATOR_INIT (Peter Krempa),
  cpu: x86: Rename x86DataAddCpuid as virCPUx86DataAddCPUID (Jiri Denemark),
  cpu: x86: Rename x86MakeCPUData as virCPUx86MakeData (Jiri Denemark),
  cpu: x86: Rename x86DataFree() as virCPUx86DataFree() (Jiri Denemark),
  cpu: x86: Rename struct cpuX86Data as virCPUx86Data (Jiri Denemark),
  cpu: x86: Rename struct cpuX86cpuid as virCPUx86CPUID (Jiri Denemark),
  cpu: Add support for loading and storing CPU data (Jiri Denemark),
  qemu: command: Fix macro indentation (Peter Krempa),
  conf: Mark user provided strings in error messages when parsing XML (Peter Krempa),
  schema: Rename option 'hypervtristate' to 'featurestate' (Peter Krempa),
  fix typo in lxc_driver.c and virsh-nodedev.c (Hongwei Bi),
  build: Add lxc testcase to dist list (Daniel Hansel),
  cgroup: leave blkio cgroup value checking to kernel (Chen Hanxiao),
  cgroup: show error when EINVAL is returned (Chen Hanxiao),
  vbox: merge duplicate state conversions (Ryota Ozaki),
  build: syntax check to avoid 'const fooPtr' (Eric Blake),
  maint: avoid 'const fooPtr' in all remaining places (Eric Blake),
  maint: avoid 'const fooPtr' in qemu (Eric Blake),
  maint: avoid 'const fooPtr' in security (Eric Blake),
  maint: avoid 'const fooPtr' in conf (Eric Blake),
  maint: avoid 'const fooPtr' in domain_conf (Eric Blake),
  maint: fix awkward typing of virDomainChrGetDomainPtrs (Eric Blake),
  maint: avoid 'const fooPtr' in python bindings (Eric Blake),
  maint: avoid 'const fooPtr' in tests (Eric Blake),
  maint: avoid 'const fooPtr' in nwfilter files (Eric Blake),
  maint: avoid 'const fooPtr' in cpu files (Eric Blake),
  maint: avoid 'const fooPtr' in virnet files (Eric Blake),
  maint: avoid 'const fooPtr' in several util files (Eric Blake),
  maint: avoid 'const fooPtr' in hashes (Eric Blake),
  maint: avoid 'const fooPtr' in public API (Eric Blake),
  Improve log filtering in virLXCProcessReadLogOutputData (Daniel P. Berrange),
  Ensure lxcContainerResolveSymlinks reports errors (Daniel P. Berrange),
  Ensure lxcContainerMain reports errors on stderr (Daniel P. Berrange),
  VMX: Serial devices don't have to be attached (Doug Goldstein),
  Revert "VMX: Some serial ports are not actually connected" (Doug Goldstein),
  qemu: snapshot: Add support for compressing external snapshot memory (Peter Krempa),
  qemu: managedsave: Add support for compressing managed save images (Peter Krempa),
  Improve error reporting with LXC controller (Daniel P. Berrange),
  Make LXC controller use a private dbus connection & close it (Daniel P. Berrange),
  Add a method for closing the dbus system bus connection (Daniel P. Berrange),
  Allow use of a private dbus bus connection (Daniel P. Berrange),
  VMware: Do version detection earlier (Doug Goldstein),
  VMware: Simplify array walk for driver type (Doug Goldstein),
  qemu: Include listenAddress in debug prints (Michal Privoznik),
  Move virNetDevVPort enum impl into virnetdevvportprofile.c (Daniel P. Berrange),
  qemu_conf: Introduce "migration_address" (Michal Privoznik),
  qemu: Implement support for VIR_MIGRATE_PARAM_LISTEN_ADDRESS (Michal Privoznik),
  virsocket: Introduce virSocketAddrIsWildcard (Michal Privoznik),
  Migration: Introduce VIR_MIGRATE_PARAM_LISTEN_ADDRESS (Michal Privoznik),
  qemu: Introduce qemuDomainDefCheckABIStability (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONSendKey (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetVirtType (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetCPUInfo (Michal Privoznik),
  qemumonitorjsontest: Extend the test for yet another monitor commands (Michal Privoznik),
  qemu: Prefer VFIO for PCI device passthrough (Peter Krempa),
  qemu: hostdev: Add checks if PCI passthrough is available in the host (Peter Krempa),
  qemu: hostdev: Fix function spacing and header formatting (Peter Krempa),
  qemu: refactor qemuCompressProgramAvailable() (Peter Krempa),
  qemu: Fix coding style in qemuDomainSaveFlags() (Peter Krempa),
  storage: Use bool instead of int (Ján Tomko),
  tests: Add qemu test for multiple timers (Cole Robinson),
  qemu: hostdev: Refactor PCI passhrough handling (Peter Krempa),
  virerror: s/VIR_ERR_STORAGE_VOL_EXISTS/VIR_ERR_STORAGE_VOL_EXISTS/ (Michal Privoznik),
  fix a ambiguous output of the command:'virsh vol-create-as' (Hongwei Bi),
  build: add configure --without-readline (Eric Blake),
  build: move readline check into its own macro (Eric Blake),
  build: kill maintainer mode, always rebuild by default (Eric Blake),
  Remove use of virConnectPtr from all remaining nwfilter code (Daniel P. Berrange),
  Don't pass virConnectPtr in nwfilter 'struct domUpdateCBStruct' (Daniel P. Berrange),
  Remove virConnectPtr arg from virNWFilterDefParse* (Daniel P. Berrange),
  qemu: Use maximum guest memory size when getting NUMA placement advice (Peter Krempa),
  virfile: safezero: fall back to writing block by block if mmap fails (Oskari Saarenmaa),
  test: snapshot: Add REDEFINE support (Cole Robinson),
  qemu: snapshot: Break out redefine preparation to shared function (Cole Robinson),
  test: Implement snapshot create/delete/revert APIs (Cole Robinson),
  test: Allow specifying domainsnapshot XML (Cole Robinson),
  qemu: snapshots: Simplify REDEFINE flag check (Cole Robinson),
  qemucapabilitiesdata: Add qemu-1.6.50 data (Michal Privoznik),
  qemucapabilitiesdata: Add qemu-1.6.0 data (Michal Privoznik),
  qemucapabilitiesdata: Add qemu-1.4.2 data (Michal Privoznik),
  qemucapabilitiesdata: Add qemu-1.3.1 data (Michal Privoznik),
  qemucapabilitiesdata: Add qemu-1.2.2 data (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONSystemPowerdown (Michal Privoznik),
  Use 'vnet' as prefix for veth devices (Daniel P. Berrange),
  Retry veth device creation on failure (Daniel P. Berrange),
  Avoid reporting an error if veth device is already deleted (Daniel P. Berrange),
  Don't set netdev offline in container cleanup (Daniel P. Berrange),
  qemumonitorjsontest: Test qemuMonitorJSONGetMigrationCapability (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetTargetArch (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONSetBlockIoThrottle (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetPtyPaths (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetSpiceMigrationStatus (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetMigrationStatus (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetMigrationCacheSize (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetBlockStatsInfo (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetBlockInfo (Michal Privoznik),
  qemumonitorjsontest: Test qemuMonitorJSONGetBalloonInfo (Michal Privoznik),
  qemu_hotplug: Allow QoS update in qemuDomainChangeNet (Michal Privoznik),
  virNetDevBandwidthEqual: Make it more robust (Michal Privoznik),
  test: Implement readonly snapshot APIs (Cole Robinson),
  test: Wire up managed save APIs (Cole Robinson),
  test: Allow specifying object transient state in driver XML (Cole Robinson),
  tests: Introduce qemucapabilitiestest (Michal Privoznik),
  qemuMonitorTest: Make check for monitor command match optional (Michal Privoznik),
  tests: Learn qemuMonitorTestNew optional greeting (Michal Privoznik),
  qemu_capabilities: Introduce virQEMUCapsInitQMPMonitor (Michal Privoznik)
- Cleanups:
  xenapi: fix coding style in xenapi_driver.c (Hongwei Bi),
  virsh: undocument --shareable (--mode already covers it) (Eric Blake),
  Remove test case average timing (Daniel P. Berrange),
  Remove existing OOM test impl (Daniel P. Berrange)

### 1.1.3: Oct 01 2013

- Features:
  VMware: Initial VMware Fusion support and various improvements (Doug Goldstein),
  libvirt: add new public API virConnectGetCPUModelNames (Giuseppe Scrivano),
  various libxl driver improvements (Jim Fehlig),
  LXC many container driver improvement (Chen Hanxiao, Gao Feng, Daniel P. Berrange),
  ARM cpu improvements (Cole Robinson)
- Security:
  Fix crash in remoteDispatchDomainMemoryStats (CVE-2013-4296) (Daniel P. Berrange),
  Add support for using 3-arg pkcheck syntax for process (CVE-2013-4311) (Daniel P. Berrange),
  virFileNBDDeviceAssociate: Avoid use of uninitialized variable (Michal Privoznik)
- Documentation:
  python: Document virNodeGetInfo bug (Michal Privoznik),
  maint: fix comment typos (Eric Blake),
  conf: Fix virNetworkAssignDef's comment. (lawrancejing),
  fix virEventAddHandle return details (Jonathan Lebon),
  fix XML for the RNG device example (Giuseppe Scrivano),
  mention hostname subtlety (Eric Blake),
  Add some notes about security considerations when using LXC (Daniel P. Berrange),
  Repair the search on libvirt.org (Daniel Veillard),
  api-docs: Fix description of virConnectGetType() API function (Michal Novotny),
  Update docs about user namespace for LXC (Daniel P. Berrange),
  docs, comments: minor typo fixes (Oskari Saarenmaa),
  LXC: fix typos in lxc_container.c (Chen Hanxiao),
  fix a typo in virt-login-shell.pod (Alex Jia),
  Fix a typo in network XML docs (Ján Tomko),
  Add OpenStack into references (Martin Kletzander),
  examples: Add script to parse topology from capabilities output (Peter Krempa)
- Portability:
  build: fix build --without-lxc (Eric Blake),
  build: tweak vpath builds of net_rpc (Eric Blake),
  fchosttest: Run the test only under linux (Michal Privoznik),
  genprotocol.pl: Fix code on FreeBSD too (Michal Privoznik),
  BSD: Ensure process creation timestamp is init'd (Doug Goldstein),
  BSD: Ensure UNIX socket credentials are valid (Doug Goldstein),
  build: fix testsuite building under cygwin (Eric Blake),
  build: Fix VPATH build error for locking daemon (Viktor Mihajlovski),
  build: fix use of rpc.h on cygwin (Eric Blake),
  build: skip ld_preload tests on non-Linux systems (Eric Blake),
  build: hoist system-specific checks before library checks (Eric Blake),
  virsh: Don't shadow global variable "remove" in cmdMetadata (Peter Krempa),
  conf: Avoid false positive of uninitialized variable use (Peter Krempa),
  build: fix VPATH build of remote driver (Eric Blake),
  build: make autobuild require rpm build deps (Eric Blake),
  build: fix build with latest rawhide kernel headers (Eric Blake),
  Explicitly link libvirt_net_rpc against SELINUX_LIBS (Guido Günther),
  build: require libnl-3 if netcf uses it (Eric Blake),
  build: fix regression in requiring yajl for new enough qemu (Eric Blake),
  build: avoid obsolete AC_HELP_STRING (Eric Blake),
  virsh: fix build on mingw, which lacks termios stuff (Eric Blake),
  build: avoid stranded polkit file in client-only build (Eric Blake),
  spec: fix rpm build when lxc disabled (Eric Blake)
- Bug Fixes:
  lxc: do cleanup when failed to bind fs as read-only (Chen Hanxiao),
  Fix max stream packet size for old clients (Daniel P. Berrange),
  LXC: workaround machined uncleaned data with containers running systemd. (Cédric Bosdonnat),
  virfile: safezero: align mmap offset to page size (Oskari Saarenmaa),
  virscsi: hostdev SCSI AdapterId retrieval fix (Boris Fiuczynski),
  virsh-volume: Add missing check when calling virStreamNew (Hongwei Bi),
  virsh-domain: Free dom before return false in cmdDump (Hongwei Bi),
  qemu: process: Silence coverity warning when rewinding log file (Peter Krempa),
  Fix crash in libvirtd when events are registered & ACLs active (Daniel P. Berrange),
  virsh: Fix domdisplay when domain only uses TLS (Christophe Fergeau),
  qemu: Free all driver data in qemuStateCleanup (Jiri Denemark),
  qemu: Don't leak reference to virQEMUDriverConfigPtr (Jiri Denemark),
  rpc: Increase bound limit for virDomainGetJobStats (Jiri Denemark),
  LXC: free dst before lxcDomainAttachDeviceDiskLive returns (Chen Hanxiao),
  qemu: virDomainControllerFind may return 0 if controller found (Chen Hanxiao),
  conf: Don't crash on invalid chardev source definition of RNGs and other (Peter Krempa),
  Avoid use of uninitialized data in virnetmessagetest (Daniel P. Berrange),
  Avoid crash on OOM in virnetmessagetest (Daniel P. Berrange),
  Avoid crash on OOM in virportallocatortest (Daniel P. Berrange),
  Avoid crash on OOM in virlockspacetest (Daniel P. Berrange),
  Avoid crash on OOM in virbuftest (Daniel P. Berrange),
  Avoid uninitialized data in qemuMonitorTestNew (Daniel P. Berrange),
  Avoid double free in qemuMonitorCommonTestInit on OOM (Daniel P. Berrange),
  Fix leak on OOM in qemuMonitorCommonTestNew (Daniel P. Berrange),
  Don't ignore errors parsing nwfilter rules (Daniel P. Berrange),
  Fix leak in virLockSpaceResourceFree (Daniel P. Berrange),
  Fix leak of parser state in virJSONValueFromString (Daniel P. Berrange),
  Fix double-free in virJSONParserHandleStartMap on OOM (Daniel P. Berrange),
  Fix leak of iterators in virDBusMessageIterEncode (Daniel P. Berrange),
  Fix leak of comment string if virConfAddEntry fails on OOM (Daniel P. Berrange),
  Add missing check for OOM with virVMXEscapeHexPipe (Daniel P. Berrange),
  Fix crash on OOM parsing storage pool XML (Daniel P. Berrange),
  Fix double free of hostdev on OOM in xenParseSxprPCI (Daniel P. Berrange),
  Don't clobber 'ret' in LXC XML test case (Daniel P. Berrange),
  Fix crash on OOM in virDomainSnapshotDefParse (Daniel P. Berrange),
  Don't clobber return value in virInterfaceDefParseProtoIPv6 (Daniel P. Berrange),
  Fix handling of OOM when getting Xen dom ID (Daniel P. Berrange),
  Fix crash on OOM in xenParseSxpr (Daniel P. Berrange),
  virsh-domain: Add a missing check and fix leak in cmdScreenshot (Hongwei Bi),
  Fix leak of serial value in xenFormatXM on OOM (Daniel P. Berrange),
  Fix broken formatting on OOM in xenFormatXM (Daniel P. Berrange),
  Fix crash on OOM in xenParseXM handling consoles (Daniel P. Berrange),
  Fix leak of char device in xenParseXM (Daniel P. Berrange),
  Fix leak of command line args in qemuParseCommandLine (Daniel P. Berrange),
  Fix leak in qemuParseCommandLine on OOM (Daniel P. Berrange),
  Fix leak in qemuStringToArgvEnv upon OOM (Daniel P. Berrange),
  Fix missing jump to error cleanup in qemuParseCommandLineDisk (Daniel P. Berrange),
  Fix leak in qemuParseCommandLineDisk on OOM (Daniel P. Berrange),
  Fix leak on OOM in qemuBuildCommandLine dealing with sound card (Daniel P. Berrange),
  Fix failure to honour OOM status in qemuParseNBDString (Daniel P. Berrange),
  Avoid leak in qemuParseRBDString on failure of qemuAddRBDHost (Daniel P. Berrange),
  Fix leak of address string in qemuDomainPCIAddressGetNextSlot (Daniel P. Berrange),
  Fix leak in virDomainDefParseXML parsing vcpupin (Daniel P. Berrange),
  Fix leak in virDomainVcpuPinDefParseXML parsing cpumask (Daniel P. Berrange),
  Avoid leak if virDomainSoundCodecDefParseXML return error (Daniel P. Berrange),
  Fix leak in virDomainVcpuPinDefArrayFree (Daniel P. Berrange),
  Check return value of virDomainControllerInsert when parsing QEMU args (Daniel P. Berrange),
  Honour error returned by virBitmapFormat (Daniel P. Berrange),
  Add missing check for OOM when building boot menu args (Daniel P. Berrange),
  Fix format specifier for OOM test fprintfs (Daniel P. Berrange),
  Always open files in binary mode in virFDStreamOpenFileInternal (Claudio Bley),
  Don't ignore allocation failure in virCommandAddEnvPassCommon (Daniel P. Berrange),
  Fix reporting of errors in OOM injection code (Daniel P. Berrange),
  Fix missing OOM check in qemuParseCommandLine when splitting strings (Daniel P. Berrange),
  Fix error checking of qemuParseKeywords return status (Daniel P. Berrange),
  Fix allocation of arglist in qemuStringToArgvEnv (Daniel P. Berrange),
  Fix crash on OOM in qemuAddRBDHost (Daniel P. Berrange),
  Fix crash on OOM in qemuDomainCCWAddressSetCreate() (Daniel P. Berrange),
  Fix crash if OOM occurs when creating virConnectPtr (Daniel P. Berrange),
  Fix crash on OOM in parsing CPU mask in domain XML (Daniel P. Berrange),
  Fix crash on OOM when parsing disk security label (Daniel P. Berrange),
  Fix typo in identity code which is pre-requisite for CVE-2013-4311 (Daniel P. Berrange),
  Fix potential use of uninitialized value in virDomainGetVcpuPinInfo (Daniel P. Berrange),
  qemu: Fix seamless SPICE migration (Martin Kletzander),
  Don't dereference NULL in qemumonitorjsontest (Ján Tomko),
  Add checking of dbus_message_iter_append_basic return value (Daniel P. Berrange),
  qemu: use "ide" as device name for implicit SATA controller on Q35 (Laine Stump),
  qemu: Avoid dangling job in qemuDomainSetBlockIoTune (Jiri Denemark),
  conf: Don't corrupt metadata on OOM (Peter Krempa),
  qemu: Fix memleak after commit 59898a88ce8431bd3ea249b8789edc2ef9985827 (Peter Krempa),
  qemu: Use "migratable" XML definition when doing external checkpoints (Peter Krempa),
  qemu: Fix checking of ABI stability when restoring external checkpoints (Peter Krempa),
  virsh: Fix a wrong check in cmdEcho() (Hongwei Bi),
  Always free network and graphics cookies (Ján Tomko),
  Free slicename in virSystemdCreateMachine (Ján Tomko),
  Fix naming of permission for detecting storage pools (Daniel P. Berrange),
  qemu: Fix checking of guest ABI compatibility when reverting snapshots (Peter Krempa),
  netcf driver: use a single netcf handle for all connections (Laine Stump),
  Fix launching of VMs on when only logind part of systemd is present (Daniel P. Berrange),
  Fix polkit permission names for storage pools, vols & node devices (Daniel P. Berrange),
  virsh domjobinfo: Do not return 1 if job is NONE (Jiri Denemark),
  virDomainDefParseXML: set the argument of virBitmapFree to NULL after calling virBitmapFree (Liuji (Jeremy)),
  cpu: Cleanup ppcCompute to avoid memory leak (Li Zhang),
  qemu: don't leak vm on failure (Eric Blake),
  LXC: Free variable vroot in lxcDomainDetachDeviceHostdevUSBLive() (Hongwei Bi),
  qemu: don't leave shutdown inhibited on attach failure (Eric Blake),
  libxl: Compile regular expression where it is used (Jim Fehlig),
  Don't call regfree() if regcomp() fails (Jim Fehlig),
  Use loop-control to allocate loop device. (Ian Main),
  LXC: Don't mount securityfs when user namespace enabled (Gao feng),
  Stop free'ing 'const char *' strings (Daniel P. Berrange),
  conf: Don't deref NULL actual network in virDomainNetGetActualHostdev() (Peter Krempa),
  libxl: Check for regcomp failure (Jim Fehlig),
  libxl: Fix Coverity warning (Jim Fehlig),
  Don't call VIR_ALLOC on def->uuid in parallels storage driver (Daniel P. Berrange),
  qemu: Make domain renaming work during migration (Jiri Denemark),
  AppArmorSetSecurityImageLabel: Avoid use of uninitialized variable (Michal Privoznik),
  build: fix typo that broke 'make dist' (Eric Blake),
  esx_driver: Resolve Coverity RESOURCE_LEAK on error paths (John Ferlan),
  esx_vi: Resolve Coverity RESOURCE_LEAK in error path (John Ferlan),
  test_virtlockd.aug.in: Use the correct file (Michal Privoznik),
  virsh-console: Avoid using signal() in multithreaded application (Peter Krempa),
  qemu: Handle huge number of queues correctly (Michal Privoznik),
  Fix leaks in python bindings (Ján Tomko),
  virsh-domain: Avoid killing ssh transport tunnels when cancelling job (Peter Krempa),
  qemu: Fix networking for ARM guests (Cole Robinson),
  qemu: Don't try to allocate PCI addresses for ARM (Cole Robinson),
  Fix AM_LDFLAGS typo (Guido Günther)
- Improvements:
  VMware: Add Fusion version test (Doug Goldstein),
  VMware: Support more than 2 driver backends (Doug Goldstein),
  Makefile.am: Always include rule to make org.libvirt.api.policy (Michal Privoznik),
  event: Make debug message match function comments (Doug Goldstein),
  lxc: fix a warning typo in virLXCControllerEventSend (Chen Hanxiao),
  Distribute check-aclperms.pl (Guido Günther),
  conf: clean up virDomainChrSourceDefParseXML (Peter Krempa),
  spec: Clean up distribution of ChangeLog (and others) (Cole Robinson),
  test: Allow specifying object runstate in driver XML (Cole Robinson),
  Don't print all test suite errors to stderr in vmx2xmltest (Daniel P. Berrange),
  qemu: prefer to put a Q35 machine's dmi-to-pci-bridge at 00:1E.0 (Laine Stump),
  qemu: turn if into switch in qemuDomainValidateDevicePCISlotsQ35 (Laine Stump),
  qemu: support ich9-intel-hda audio device (Laine Stump),
  qemu: replace multiple strcmps with a switch on an enum (Laine Stump),
  qemu: allow some PCI devices to be attached to PCIe slots (Laine Stump),
  qemu: eliminate redundant if clauses in qemuCollectPCIAddress (Laine Stump),
  bridge driver: don't masquerade local subnet broadcast/multicast packets (Laszlo Ersek),
  util/viriptables: add/remove rules that short-circuit masquerading (Laszlo Ersek),
  qemu: Wire up better early error reporting (Peter Krempa),
  qemu: monitor: Produce better errors on monitor hangup (Peter Krempa),
  qemu: monitor: Add infrastructure to access VM logs for better err msgs (Peter Krempa),
  qemu_process: Make qemuProcessReadLog() more versatile and reusable (Peter Krempa),
  maint: update to latest gnulib (Eric Blake),
  test: fix call to virFDStreamOpenFile in testDomainScreenshot (Claudio Bley),
  Add test case for virNetServerClient object identity code (Daniel P. Berrange),
  Add a virNetSocketNewConnectSockFD method (Daniel P. Berrange),
  python: add bindings for virConnectGetCPUModelNames (Giuseppe Scrivano),
  virsh: add function to get the CPU models for an arch (Giuseppe Scrivano),
  virConnectGetCPUModelNames: add the support for the test protocol (Giuseppe Scrivano),
  virConnectGetCPUModelNames: add the support for qemu (Giuseppe Scrivano),
  virConnectGetCPUModelNames: implement the remote protocol (Giuseppe Scrivano),
  cpu: add function to get the models for an arch (Giuseppe Scrivano),
  build: ensure 'make check' sees up-to-date config.h (Eric Blake),
  docs: Load libvirt_access*.xml from build dir (Jiri Denemark),
  LXC: Check the existence of dir before resolving symlinks (Chen Hanxiao),
  LXC: follow the unit style of /proc/meminfo (Chen Hanxiao),
  conf: Do better job when comparing features ABI compatibility (Peter Krempa),
  VMware: Make version parsing testable and add tests (Doug Goldstein),
  VMware: Store vmrun binary's path in the driver (Doug Goldstein),
  VMware: Convert driver type defines to enum (Doug Goldstein),
  virsh: add missing "async" option in opts_block_commit (Simone Gotti),
  qemumonitorjsontest: Introduce DO_TEST_SIMPLE (Michal Privoznik),
  qemumonitorjsontest: Test CPU state handling code (Michal Privoznik),
  daemon: Remove more hardcoded paths from help output (Christophe Fergeau),
  Fix LIBVIRTD_CONFIGURATION_FILE constant (Christophe Fergeau),
  Ensure system identity includes process start time (Daniel P. Berrange),
  Also store user & group ID values in virIdentity (Daniel P. Berrange),
  daemon: Don't hardcode pki paths in help output (Christophe Fergeau),
  daemon: Fix 'caert.pem' typo in privileged help output (Christophe Fergeau),
  virsh: Add vshCompleter to each option (Tomas Meszaros),
  Add forwarder attribute to <dns/> element (Diego Woitasen),
  VMX: Add a VMWare Fusion 5 configuration for tests (Doug Goldstein),
  VMX: Add support for 'auto detect' fileNames (Doug Goldstein),
  Allow <source> for type=block to have no dev (Doug Goldstein),
  maint: ignore recently-added test (Eric Blake),
  tests: metadatatest: Quiesce errors on expected paths (Peter Krempa),
  test: Refactor setting of dummy error handlers (Peter Krempa),
  Add tftp protocol support for cdrom disk (Aline Manera),
  Add ftps protocol support for cdrom disk (Aline Manera),
  Add https protocol support for cdrom disk (Aline Manera),
  tests: Add metadata tests (Peter Krempa),
  test: Add <metadata> support into the test driver (Peter Krempa),
  lxc: Add metadata modification APIs (Peter Krempa),
  lib: Don't force the key argument when deleting metadata (Peter Krempa),
  conf: allow to add XML metadata using the virDomainSetMetadata api (Peter Krempa),
  conf: Add support for requesting of XML metadata via the API (Peter Krempa),
  virsh-domain: Add command to allow modifications of XML metadata (Peter Krempa),
  virsh-domain: use virXMLNodeToString instead of xmlNodeDump (Peter Krempa),
  util: Add helper to convert libxml2 nodes to a string (Peter Krempa),
  conf: Factor out setting of metadata to simplify code (Peter Krempa),
  qemu: Factor out body of qemuDomainSetMetadata for universal use (Peter Krempa),
  qemu: Factor out body of qemuDomainGetMetadata for universal use (Peter Krempa),
  virsh-domain: Line up signal names array (Peter Krempa),
  virsh-domain: Remove spurious ATTRIBUTE_UNUSED from cmdDesc (Peter Krempa),
  Allow LUN type disks to have no source (Doug Goldstein),
  cgroup: Move [qemu|lxc]GetCpuBWStatus to vicgroup.c and refactor it (Peter Krempa),
  cleanup: Kill usage of access(PATH, F_OK) in favor of virFileExists() (Peter Krempa),
  util: Declare that virFileExists shall honor errno (Peter Krempa),
  virsh: move command maxvcpus from domain group to host group. (yangdongsheng),
  tools: add missing 'interface' type and update man page (Alex Jia),
  tests: Don't test user config file if ran as root (Martin Kletzander),
  test-lib: Make case skipping possible (Martin Kletzander),
  LXC: don't try to mount selinux filesystem when user namespace enabled (Gao feng),
  rename "struct interface_driver" to virNetcfDriverState (Laine Stump),
  Ensure root filesystem is recursively mounted readonly (Daniel P. Berrange),
  Move array of mounts out of lxcContainerMountBasicFS (Daniel P. Berrange),
  Fix virsystemdtest for previous commit (Daniel P. Berrange),
  DBus: introduce virDBusIsServiceEnabled (Gao feng),
  LXC: introduce lxcContainerUnmountForSharedRoot (Gao feng),
  LXC: umount the temporary filesystem created by libvirt (Gao feng),
  Add test for the nodemask double free crash (Ján Tomko),
  Fix cgroups when all are mounted on /sys/fs/cgroup (Daniel P. Berrange),
  qemu: endjob returns a bool (Eric Blake),
  build: use automake subdir-objects (Eric Blake),
  tests: check remaining .x files (Eric Blake),
  build: use library rather than cross-directory compilation (Eric Blake),
  build: avoid $(srcdir) in *_SOURCES (Eric Blake),
  Add ARM v7 big-endian architecture (armv7b) (Yogesh Tillu),
  qemu: avoid users specifying CPU features for non-x86 plaftorm. (Li Zhang),
  qemu: recognize -machine accel=kvm when parsing native (Eric Blake),
  qemu: only parse basename when determining emulator properties (Eric Blake),
  spec: make client-only testing easier (Eric Blake),
  build: shut up automake warnings (Eric Blake),
  Change 'shortforward' to bool. (Ján Tomko),
  Add '<nat>' element to '<forward>' network schemas (Ján Tomko),
  cpu: Add cpu test cases for PPC CPU driver. (Li Zhang),
  cpu: Implement guestData and update for PPC (Li Zhang),
  qemu: Remove CPU features functions calling for non-x86 platform. (Li Zhang),
  Stop calling virAllocN directly from ESX code (Daniel P. Berrange),
  virDomainDeviceIsUSB: Drop check for USB controller (Liuji (Jeremy)),
  Ensure 'arch' is always set in cpuArchNodeData (Daniel P. Berrange),
  qemu: simplify list cleanup (Eric Blake),
  libxl: Unconditionally call virSysinfoRead() on driver init (Jim Fehlig),
  spec: default vbox according to libvirtd build (Eric Blake),
  build: only install nwfilter examples when building nwfilter (Eric Blake),
  build: only run fdstreamtest when libvirtd is built (Eric Blake),
  virGet{User,Group}Ent() don't say success on fail (Doug Goldstein),
  build: enforce makefile conditional style (Eric Blake),
  Add missing 'libvirt_lxc_api' variable in pkg-config file (Daniel P. Berrange),
  Fix coding style issues in daemon/remote.c (Nehal J Wani),
  conf: Remove the actual hostdev when removing a network (Peter Krempa),
  libxl: Use standard format for source file copyright notice (Jim Fehlig),
  libxl: Add libxlDomObjFromDomain (Jim Fehlig),
  libxl: Remove unnecessary driver locking (Jim Fehlig),
  libxl: Move driver lock/unlock to libxl_conf (Jim Fehlig),
  libxl: Add comments to libxlDriverPrivate fields (Jim Fehlig),
  libxl: Use atomic ops for driver->nactive (Jim Fehlig),
  libxl: Introduce libxlDriverConfig object (Jim Fehlig),
  libxl: User per-domain ctx in libxlDomainGetInfo (Jim Fehlig),
  libxl: libxl: Use per-domain ctx in libxlMakeDomCreateInfo (Jim Fehlig),
  libxl: Add libxl_version_info to libxlDriverPrivate (Jim Fehlig),
  libxl: Earlier detection of not running on Xen (Jim Fehlig),
  libxl: Introduce libxl_domain.[ch] (Jim Fehlig),
  libxl: Move detection of autoballoon to libxl_conf (Jim Fehlig),
  virsh: Rename vshMakeStdinRaw to vshTTYMakeRaw and move it to virsh.c (Peter Krempa),
  tools: rename console.[ch] to virsh-console.[ch] and fix coding style (Peter Krempa),
  virsh: Remember terminal state when starting and add helpers (Peter Krempa),
  VMX: Add cdrom-raw dev type from VMWare Fusion (Doug Goldstein),
  VMX: Some serial ports are not actually connected (Doug Goldstein),
  qemu: Support virtio-mmio transport for virtio on ARM (Cole Robinson),
  domain_conf: Add disk bus=sd, wire it up for qemu (Cole Robinson),
  qemu: Fix specifying char devs for ARM (Cole Robinson),
  qemu: Don't add default memballoon device on ARM (Cole Robinson),
  domain_conf: Add default memballoon in PostParse callbacks (Cole Robinson),
  qemu: Set QEMU_AUDIO_DRV=none with -nographic (Cole Robinson),
  Pass AM_LDFLAGS to driver modules too (Guido Günther),
  qemu: Support setting the 'removable' flag for USB disks (Fred A. Kemp),
  qemu: Add capability flag for usb-storage (Fred A. Kemp),
  VMX: Create virVMXFormatDisk() from HD and CD-ROM (Doug Goldstein)
- Cleanups:
  daemon: Avoid dead code in polkit auth (Jiri Denemark)

### 1.1.2: Sep 02 2013

- Features:
  various improvements to libxl driver (Jim Fehlig, Bamvor Jian Zhang),
  systemd integration improvements (Daniel P. Berrange, Mooli Tayer),
  Add flag to BaselineCPU API to return detailed CPU features (Don Dugger),
  Introduce a virt-login-shell binary (Dan Walsh),
  conf: add startupPolicy attribute for harddisk (Guannan Ren)
- Security:
  provide supplemental groups even when parsing label (CVE-2013-4291) (Eric Blake),
  Add bounds checking on virDomainMigrate*Params RPC calls (CVE-2013-4292) (Daniel P. Berrange),
  CVE-2013-5651 virbitmap: Refactor virBitmapParse to avoid access beyond bounds of array (Peter Krempa),
  CVE-2013-4239 xen: fix memory corruption in legacy driver (Jim Fehlig)
- Documentation:
  Reformat <disk> attribute description in formatdomain (John Ferlan),
  Update iSCSI storage pool example (John Ferlan),
  Update formatsecrets to include more examples of each type (John Ferlan),
  Update the formatdomain disk examples (John Ferlan),
  Clean 09adfdc62de2b up (Michal Privoznik),
  virt-pki-validate: add --help/--version option (Eric Blake),
  virt-xml-validate: add --help/--version option (Eric Blake),
  Discourage users to set hard_limit (Michal Privoznik),
  Update polkit examples to use 'lookup' method (Daniel P. Berrange),
  fix usb node device sub-element names (Xuesong Zhang),
  virt-login-shell: improve error message grammar (Ruben Kerkhof),
  storage pool permission copy-paste fix (Philipp Hahn),
  mention VIR_TEST_RANGE (Eric Blake),
  Document use of systemd socket activation (Daniel P. Berrange),
  Remove leftovers from hyperv spinlocks documentation (Ján Tomko),
  Fix typo in domain name in polkit acl example (Daniel P. Berrange),
  Add documentation for access control system (Daniel P. Berrange),
  Add an example config file for virtlockd (Daniel P. Berrange),
  Add a man page for virtlockd daemon (Daniel P. Berrange),
  Add info about access control checks into API reference (Daniel P. Berrange),
  Fix minor typos in messages and docs (Yuri Chornoivan)
- Portability:
  build: fix virtlockd file distribution (Eric Blake),
  build: shipped files must not depend on BUILT_SOURCES (Eric Blake),
  build: only create virt-login-shell for lxc builds (Eric Blake),
  qemu: Only setup vhost if virtType == "kvm" (Cole Robinson),
  Process virtlockd.conf instead of libvirtd.conf (Guido Günther),
  Change way we fake dbus method calls (Daniel P. Berrange),
  random: don't mix RAND_MAX with random_r (Eric Blake),
  tests: skip schema validation tests if xmllint is missing (Eric Blake),
  Check for --no-copy-dt-needed linker flag (Guido Günther),
  Simplify RELRO_LDFLAGS (Guido Günther),
  tests: fix building without xattr support (Claudio Bley),
  nwfilter: Don't fail to start if DBus isn't available (Peter Krempa),
  virsystemd: Don't fail to start VM if DBus isn't available or compiled in (Peter Krempa),
  tools: Make sure to distribute conf_DATA, fix RPM build (Cole Robinson),
  Directly link against needed libraries (Guido Günther),
  Directly link against needed libraries (Guido Günther),
  build: avoid -lgcrypt with newer gnutls (Eric Blake),
  build: more workarounds for if_bridge.h (Eric Blake),
  tests: avoid too-large constants (Eric Blake),
  tests: work with older dbus (Eric Blake),
  build: fix compilation of virt-login-shell.c (Jim Fehlig),
  maint: the compiler is not always named gcc (Eric Blake),
  build: fix qemuagenttest build with -O0 in fedora 19. (Jincheng Miao),
  spec: RHEL-7 does not have sanlock on i686 (Jiri Denemark),
  spec: Disable libssh2 support for RHEL (Peter Krempa)
- Bug Fixes:
  qemu_hotplug: Resolve DEADCODE coverity error (John Ferlan),
  Fix memory leak in cmdAttachDisk (Hongwei Bi),
  python: Fix a PyList usage mistake (Guan Qiang),
  qemu: Remove hostdev entry when freeing the depending network entry (Peter Krempa),
  virsh: detect programming errors with option parsing (Eric Blake),
  virt-sanlock-cleanup; Fix augtool usage (Jiri Denemark),
  virsh: Fix debugging (Martin Kletzander),
  virsh: free the caps list properly if one of them is invalid (Ján Tomko),
  virsh: free the formatting string when listing pool details (Ján Tomko),
  virsh: free the list from ListAll APIs even for 0 items (Ján Tomko),
  virsh: free messages after logging them to a file (Ján Tomko),
  Test network update XML parsing (Ján Tomko),
  Always specify qcow2 compat level on qemu-img command line (Ján Tomko),
  virsh: fix return value error of cpu-stats (Guannan Ren),
  Don't free NULL network in cmdNetworkUpdate (Ján Tomko),
  schema: Allow dots in device aliases (Jiri Denemark),
  qemu: Don't update count of vCPUs if hot-plug fails silently (Peter Krempa),
  tests: Add URI precedence checking (Martin Kletzander),
  Fix URI connect precedence (Martin Kletzander),
  libxl: fix libvirtd crash when reconnecting domains (Jim Fehlig),
  migration: do not restore labels on failed migration (Eric Blake),
  storage: Fix the use-after-free memory bug (Osier Yang),
  storage: Fix coverity warning (Osier Yang),
  qemu_conf: Fix broken logic for adding passthrough iscsi lun (Osier Yang),
  libxl: Resolve possible NULL dereference (John Ferlan),
  virsh: Don't leak list of volumes when undefining domain with storage (Peter Krempa),
  virbitmaptest: Shut coverity up in case of broken test (Peter Krempa),
  storage: Update pool metadata after adding/removing/resizing volume (Osier Yang),
  virbitmaptest: Add test for out of bounds condition (Peter Krempa),
  virsh-domain: Fix memleak in cmdCPUBaseline (Peter Krempa),
  libxl: unref DomainObjPrivate on error path (Jim Fehlig),
  virsh-domain: Fix memleak in cmdUndefine with storage (Peter Krempa),
  Fix qemuProcessReadLog with non-zero offset (Ján Tomko),
  network: permit upstream forwarding of unqualified DNS names (Laine Stump),
  virsh-domain: Flip logic in cmdSetvcpus (Peter Krempa),
  Don't crash in qemuBuildDeviceAddressStr (Guido Günther),
  libxl: fix libvirtd segfault (Jim Fehlig),
  Make check for /dev/loop device names stricter to avoid /dev/loop-control (Daniel P. Berrange),
  libxl: fix node ranges in libxlNodeGetCellsFreeMemory() (Dario Faggioli),
  Fix double-free and broken logic in virt-login-shell (Daniel P. Berrange),
  virnettlscontext: Resolve Coverity warnings (UNINIT) (John Ferlan),
  remote: Fix a segfault in remoteDomainCreateWithFlags (Alex Jia),
  qemu: Allow hotplug of multiple SCSI devices (Eric Farman),
  Fix validation of CA certificate chains (Daniel P. Berrange),
  Reverse logic allowing partial DHCP host XML (Ján Tomko),
  xen: Use internal interfaces in xenDomainUsedCpus (Stefan Bader),
  qemu_migration: Don't error on tunelled migration with --copy-storage (Michal Privoznik),
  build: fix missing max_queued_clients in augeas test file for libvirtd.conf (Laine Stump),
  Fix crashing upgrading from older libvirts with running guests (Daniel P. Berrange),
  Avoid crash if NULL is passed for filename/funcname in logging (Daniel P. Berrange),
  qemumonitortestutils: Don't skip va_end() on error path (Peter Krempa),
  tests: Coverity found new NULL_RETURNS (John Ferlan),
  Configuring systemd to restart libvirt on failure (Mooli Tayer),
  xen: Avoid double free of virDomainDef in xenDaemonCreateXML (Stefan Bader)
- Improvements:
  build: fix 'make distcheck' out of the box (Eric Blake),
  virsh-domain: rename print_job_progress to vshPrintJobProgress (Peter Krempa),
  Prohibit unbounded arrays in XDR protocols (Daniel P. Berrange),
  Add bounds checking on virConnectListAllSecrets RPC call (Daniel P. Berrange),
  Add bounds checking on virConnectListAllNWFilters RPC call (Daniel P. Berrange),
  Add bounds checking on virConnectListAllNodeDevices RPC call (Daniel P. Berrange),
  Add bounds checking on virConnectListAllInterfaces RPC call (Daniel P. Berrange),
  Add bounds checking on virConnectListAllNetworks RPC call (Daniel P. Berrange),
  Add bounds checking on virStoragePoolListAllVolumes RPC call (Daniel P. Berrange),
  Add bounds checking on virConnectListAllStoragePools RPC call (Daniel P. Berrange),
  Add bounds checking on virConnectListAllDomains RPC call (Daniel P. Berrange),
  Add bounds checking on virDomain{SnapshotListAllChildren,ListAllSnapshots} RPC calls (Daniel P. Berrange),
  Add bounds checking on virDomainGetJobStats RPC call (Daniel P. Berrange),
  autogen.sh: Correctly detect .git as a file (Michal Privoznik),
  bridge_driver: Introduce networkObjFromNetwork (Michal Privoznik),
  virsh-pool.c: Don't jump over variable declaration (Michal Privoznik),
  Remove the space before the slash in network XML (Ján Tomko),
  Build QEMU command line for pcihole64 (Ján Tomko),
  Add pcihole64 element to root PCI controllers (Ján Tomko),
  Allow controller XML parsing to use XPath context (Ján Tomko),
  Move virDomainParseScaledValue earlier (Ján Tomko),
  Add ftp protocol support for cdrom disk (Aline Manera),
  Add http protocol support for cdrom disk (Aline Manera),
  virsh: C99 style for info_domfstrim and opts_lxc_enter_namespace (Tomas Meszaros),
  qemuDomainAttachHostPciDevice: Fall back to mem balloon if there's no hard_limit (Michal Privoznik),
  qemuhotplugtest: Add tests for virtio SCSI disk hotplug (Jiri Denemark),
  qemuhotplugtest: Add tests for USB disk hotplug (Jiri Denemark),
  qemuhotplugtest: Add tests for async virtio disk detach (Jiri Denemark),
  qemuhotplugtest: Add support for DEVICE_DELETED event (Jiri Denemark),
  qemu: Let tests override waiting time for device unplug (Jiri Denemark),
  qemu: Export qemuProcessHandleDeviceDeleted for tests (Jiri Denemark),
  tests: Add support for passing driver to qemu monitor (Jiri Denemark),
  tests: Add support for passing vm to qemu monitor (Jiri Denemark),
  qemuhotplugtest: Add tests for virtio disk hotplug (Jiri Denemark),
  qemuxml2argvtest: Add XML for testing device hotplug (Jiri Denemark),
  qemuhotplugtest: Define QMP_OK for the most common reply (Jiri Denemark),
  qemuhotplugtest: Compare domain XML after device hotplug (Jiri Denemark),
  qemuhotplugtest: Generate better output (Jiri Denemark),
  qemu: Move qemuDomainDetachDeviceDiskLive to qemu_hotplug.c (Jiri Denemark),
  qemu: Move qemuDomainAttachDeviceDiskLive to qemu_hotplug.c (Jiri Denemark),
  qemu: Avoid using global qemu_driver in event handlers (Jiri Denemark),
  qemu: Typedef monitor callbacks (Jiri Denemark),
  python: simplify complicated conditional assignment (Claudio Bley),
  Test for object identity when checking for None in Python (Claudio Bley),
  qemuagenttest.c: Missing documentation (Timeout) (Nehal J Wani),
  python: Use RELRO_LDFLAGS and NO_INDIRECT_LDFLAGS (Guido Günther),
  Set security label on FD for virDomainOpenGraphics (Daniel P. Berrange),
  qemuBuildNicDevStr: Add mq=on for multiqueue networking (Michal Privoznik),
  virBitmapParse: Fix behavior in case of error and fix up callers (Peter Krempa),
  VMX: Improve disk parse error for unknown values (Doug Goldstein),
  bridge driver: implement networkEnableIpForwarding for BSD (Roman Bogorodskiy),
  BSD: implement virNetDev(Set|Clear)IPv4Address (Roman Bogorodskiy),
  Test handling of non-existent x509 certs (Daniel P. Berrange),
  Report secret usage error message similarly (John Ferlan),
  virsh: Print cephx and iscsi usage (John Ferlan),
  selinux: enhance test to cover nfs label failure (Eric Blake),
  selinux: distinguish failure to label from request to avoid label (Eric Blake),
  virsh-pool: Improve error message in cmdPoolList (Peter Krempa),
  virsh: modify vshStringToArray to duplicate the elements too (Peter Krempa),
  qemuBuildCommandLine: Fall back to mem balloon if there's no hard_limit (Michal Privoznik),
  qemuSetupMemoryCgroup: Handle hard_limit properly (Michal Privoznik),
  virt-xml-validate: add missing schemas (Eric Blake),
  libxl: implement NUMA capabilities reporting (Jim Fehlig),
  virdbus: Add virDBusHasSystemBus() (Peter Krempa),
  Make max_clients in virtlockd configurable (David Weber),
  snapshot_conf: Allow parsing an XML node (Cole Robinson),
  test: Unify object XML parsing (Cole Robinson),
  test: Simplify args passed to testDomainStartState (Cole Robinson),
  test: Split object parsing into their own functions (Cole Robinson),
  maint: slightly reduce configure size (Eric Blake),
  libxl: refactor capabilities code (Jim Fehlig),
  virbitmaptest: Fix function header formatting (Peter Krempa),
  maint: update gnulib submodule (Eric Blake),
  maint: fix typo for 'switch' (Eric Blake),
  examples: support crash events in event-test.py (Giuseppe Scrivano),
  cpu: Add Power7+ and Power8 CPU definition in map.xml (Li Zhang),
  Ensure that /dev exists in the container root filesystem (Daniel P. Berrange),
  Properly handle -h / -V for --help/--version aliases in virtlockd/libvirtd (Daniel P. Berrange),
  Address missed feedback from review of virt-login-shell (Daniel P. Berrange),
  Honour root prefix in lxcContainerMountFSBlockAuto (Daniel P. Berrange),
  tests: Fix parallel runs of TLS test suites (Martin Kletzander),
  cgroup macros refactoring, part 5 (Roman Bogorodskiy),
  cgroup macros refactoring, part 4 (Roman Bogorodskiy),
  cgroup macros refactoring, part 3 (Roman Bogorodskiy),
  cgroup macros refactoring, part 2 (Roman Bogorodskiy),
  cgroup macros refactoring, part 1 (Roman Bogorodskiy),
  cgroup: functional sort (Eric Blake),
  cgroup: topological sort (Eric Blake),
  cgroup: use consistent formatting (Eric Blake),
  Add missing ATTRIBUTE_UNUSED (Guido Günther),
  virsh: nicer abort of blockcopy (Eric Blake),
  tests: Skip virsh-all test as expensive (Peter Krempa),
  qemuagenttest: Test timeout of agent commands (Peter Krempa),
  tests: add helper to determine when to skip expensive tests (Eric Blake),
  build: add configure option to disable gnulib tests (Eric Blake),
  qemuagenttest: Test arbitrary command passthrough (Peter Krempa),
  Record the where the auto-generated data comes from (Daniel P. Berrange),
  tests: test negative number through dbus (Eric Blake),
  libxl: Create per-domain log file (Jim Fehlig),
  Fix parallel runs of TLS test suites (Daniel P. Berrange),
  configure: fix formatting of missing pkg-config modules error (Giuseppe Scrivano),
  Ensure securityfs is mounted readonly in container (Dan Walsh),
  Change data passed into TLS test cases (Daniel P. Berrange),
  Avoid re-generating certs every time (Daniel P. Berrange),
  Split TLS test into two separate tests (Daniel P. Berrange),
  maint: avoid C99 loop declaration (Eric Blake),
  qemu: support to drop disk with 'optional' startupPolicy (Guannan Ren),
  nwfilter: Use -m conntrack rather than -m state (Stefan Berger),
  virGetGroupList: always include the primary group (Guido Günther),
  qemu: improve error reporting during PCI address validation (Laine Stump),
  qemu: enable using implicit sata controller in q35 machines (Laine Stump),
  qemu: properly set/use device alias for pci controllers (Laine Stump),
  qemu: fix handling of default/implicit devices for q35 (Laine Stump),
  qemu: add dmi-to-pci-bridge controller (Laine Stump),
  qemu: add pcie-root controller (Laine Stump),
  qemu: enable auto-allocate of all PCI addresses (Laine Stump),
  Introduce max_queued_clients (Michal Privoznik),
  RPC: Don't accept client if it would overcommit max_clients (Michal Privoznik),
  qemu: eliminate almost-duplicate code in qemu_command.c (Laine Stump),
  qemu: rename some functions in qemu_command.c (Laine Stump),
  conf: add default USB controller in qemu post-parse callback (Laine Stump),
  spec: Explicitly claim ownership of channel subdir (Jiri Denemark),
  Ensure LXC/QEMU APIs set the filename for errors (Daniel P. Berrange),
  Remove reference to python/tests from RPM %doc (Daniel P. Berrange),
  qemuagenttest: Check invalid response in shutdown test (Peter Krempa),
  qemuagenttest: Fix checking of shutdown mode (Peter Krempa),
  bridge driver: extract platform specifics (Roman Bogorodskiy),
  valgrind: Adjust filter for _dl_allocate_tls (John Ferlan),
  maint: use modern autoconf idioms (Eric Blake),
  qemu: check presence of each disk and its backing file as well (Guannan Ren),
  qemu: add helper functions for diskchain checking (Guannan Ren),
  qemu: refactor qemuDomainCheckDiskPresence for only disk presence check (Guannan Ren),
  Enable support for systemd-machined in cgroups creation (Daniel P. Berrange),
  Cope with races while killing processes (Daniel P. Berrange),
  Add support for systemd cgroup mount (Daniel P. Berrange),
  Add APIs for formatting systemd slice/scope names (Daniel P. Berrange),
  qemuagenttest: Add tests for CPU plug functions and helpers (Peter Krempa),
  qemuagenttest: Introduce testing of shutdown commands (Peter Krempa),
  qemuagenttest: Add testing of agent suspend modes (Peter Krempa),
  qemuagenttest: Test the filesystem trimming (Peter Krempa),
  tests: Add qemuagenttest (Peter Krempa),
  qemumonitortestutils: Add the ability to check arguments of commands (Peter Krempa),
  qemumonitortestutils: Improve error reporting from mock qemu monitor (Peter Krempa),
  qemumonitortestutils: Add instrumentation for guest agent testing (Peter Krempa),
  qemumonitortestutils: Split lines on \n instead of \r\n (Peter Krempa),
  qemumonitortestutils: Refactor the test helpers to allow reuse (Peter Krempa),
  qemumonitortestutils: Split up creation of the test to allow reuse (Peter Krempa),
  qemumonitortestutils: Don't crash on non fully initialized test (Peter Krempa),
  qemumonitortestutils: remove multiline function calls (Peter Krempa),
  qemumonitortestutils: Use VIR_DELETE_ELEMENT and VIR_APPEND_ELEMENT (Peter Krempa),
  qemumonitortestutils: Use consistent header style and line spacing (Peter Krempa),
  qemu_agent: Remove obvious comments (Peter Krempa),
  qemu_agent: Move updater function for VCPU hotplug into qemu_agent.c (Peter Krempa),
  qemu_agent: Output newline at the end of the sync JSON message (Peter Krempa),
  conf: Export virDomainChrSourceDefClear() (Peter Krempa),
  add console support in libxl (Bamvor Jian Zhang),
  util: add virGetUserDirectoryByUID (Dan Walsh),
  maint: fix typo for SENTINEL (Eric Blake),
  spec: Don't mix commands with macro definitions (Jiri Denemark),
  spec: Use --enable-werror on RHEL (Jiri Denemark),
  tests: Put a mock library at the start of LD_PRELOAD (Jiri Denemark),
  Support apparmor in RPM spec (Daniel P. Berrange),
  Delete obsolete / unused python test files (Daniel P. Berrange)
- Cleanups:
  qemu_hotplug: Fix whitespace around addition in argument (Peter Krempa),
  qemu: Drop qemuDomainMemoryLimit (Michal Privoznik),
  maint: avoid bootstrap warning (Eric Blake),
  libxl: remove unnecessary curly braces (Jim Fehlig),
  virtio-rng: Remove double space in error message (Peter Krempa),
  Don't mark parentIndex with ATTRIBUTE_UNUSED (Ján Tomko)

### 1.1.1: Jul 30 2013

- Features:
  Adding device removal or deletion events (Jiri Denemark),
  Introduce new domain create APIs to pass pre-opened FDs to LXC (Daniel P. Berrange),
  Add interface versions for Xen 4.3 (Stefan Bader),
  Add new public API virDomainSetMemoryStatsPeriod (John Ferlan),
  Various LXC improvements (Daniel P. Berrange and Gao feng)
- Security:
  security: fix deadlock with prefork (Eric Blake),
  CVE-2013-4153 qemu: Fix double free of returned JSON array in qemuAgentGetVCPUs() (Peter Krempa),
  CVE-2013-4154 qemu: Prevent crash of libvirtd without guest agent configuration (Alex Jia),
  CVE-2013-2230 Fix crash when multiple event callbacks were registered (Ján Tomko)
- Documentation:
  formatdomain.html.in: Document implementation limitation of QoS (Michal Privoznik),
  formatdomain.html.in: Correctly use `` in #elementQoS (Michal Privoznik),
  Fix copy-paste-error in virNodeGetMemoryStats (Philipp Hahn),
  virsh: Mention --driver in man page for nodedev-detach (Peter Krempa),
  maint: tweak use of <a> in HACKING (Eric Blake),
  maint: fix typo in qemu error message (Eric Blake),
  daemon: Fix command example in libvirtd.sasl (Cole Robinson),
  Put virt-sanlock-cleanup into section 8 (Guido Günther),
  Document hypervisor drivers that support certain timer models (Peter Krempa)
- Portability:
  build: fix shunloadtest breakage (Eric Blake),
  examples: fix mingw build vs. printf (Eric Blake),
  build: skip systemd mock on non-Linux (Eric Blake),
  Fix dbus message reading code on big endian hosts (Daniel P. Berrange),
  build: fix another virdbus issue on mingw (Eric Blake),
  build: fix virutil build on mingw (Eric Blake),
  build: fix virthread build on mingw (Eric Blake),
  build: fix virdbus build on mingw (Eric Blake),
  build: fix vircgroup build on mingw (Eric Blake),
  Conditionalize build of virCgroupValidateMachineGroup (Daniel P. Berrange),
  build: fix VPATH 'make check' (Eric Blake),
  cpu: Fix one compile error for PPC. (Li Zhang),
  virdbustest: Don't pass number of arguments as long long (Guido Günther),
  Fix virCgroupAvailable() w/o HAVE_GETMNTENT_R defined (Roman Bogorodskiy),
  Fix link_addr detection (Roman Bogorodskiy),
  build: work around broken kernel headers (Eric Blake),
  dbus: work with older dbus (Eric Blake),
  Use AC_LINK_IFELSE (Guido Günther),
  Check for link_addr more thoroughly (Guido Günther),
  Fix bridge routines detection on kFreeBSD (Roman Bogorodskiy),
  Fix build with clang (Ján Tomko),
  build: don't ship access syms files in tarball (Eric Blake),
  build: work around mingw header pollution (Eric Blake),
  build: avoid build failure without gnutls (Eric Blake)
- Bug Fixes:
  Fix probing of legacy Xen driver to not leave URI set (Daniel P. Berrange),
  caps: use -device for primary video when qemu >1.6 (Guannan Ren),
  Resolve Coverity complaint in storagevolxml2argvtest (Ján Tomko),
  Don't check validity of missing attributes in DNS SRV XML (Ján Tomko),
  Set the number of elements 0 in virNetwork*Clear (Ján Tomko),
  conf:Fix a copy paste error (Alex Jia),
  virLXCMonitorClose: Unlock domain while closing monitor (Michal Privoznik),
  libxl: Correctly initialize vcpu bitmap (Stefan Bader),
  Add new virAuth symbols to private.syms (Ján Tomko),
  Use qemuOpenFile in qemu_driver.c (Martin Kletzander),
  Make qemuOpenFile aware of per-VM DAC seclabel. (Martin Kletzander),
  domain_event: Resolve memory leak found by Valgrind (John Ferlan),
  lxc: Resolve Coverity warning (John Ferlan),
  qemu: Take error path if acquiring of job fails in qemuDomainSaveInternal (Peter Krempa),
  build: fix make rpm failure (Laine Stump),
  virsh: fix change-media bug on disk block type (Guannan Ren),
  tests: Free test at the end of GetDeviceAliases JSON test (Jiri Denemark),
  vmware: Fix bogus CPU arch copy (Jiri Denemark),
  qemu: Shorten SCSI hostdev alias to avoid QEMU failure (Viktor Mihajlovski),
  Add virtio-scsi to fallback models of scsi controller (Martin Kletzander),
  qemuhotplugtest: Resolve some memleaks (Michal Privoznik),
  qemuDomainDetachChrDevice: Don't leak @charAlias (Michal Privoznik),
  Fix impl of virDomainCreateWithFlags remote client helper (Daniel P. Berrange),
  cgroup: reuse buffer for getline (Ján Tomko),
  Create directory for lease files if it's missing (Guido Günther),
  rbd: Do not free the secret if it is not set (Wido den Hollander),
  Make logical pools independent on target path (Martin Kletzander),
  qemu: add macvlan delete to qemuDomainAttachNetDevice cleanup (Matthew Rosato),
  qemuBuildChrDeviceCommandLine: Don't leak devstr (Michal Privoznik),
  conf: reject pci-root controllers with non-zero indexes (Ján Tomko),
  nodeinfo: Don't fail on non-contiguous NUMA topologies (hejia hejia),
  util: make virSetUIDGID async-signal-safe (Eric Blake),
  qemu_hostdev: Resolve Coverity issue (John Ferlan),
  storage_backend: Resolve Coverity issue (John Ferlan),
  virsh-nodedev: Resolve Coverity issues (John Ferlan),
  virsh-interface: Resolve Coverity issues (John Ferlan),
  virsh-domain-monitor: Resolve Coverity issues (John Ferlan),
  testutils: Resolve Coverity issues (John Ferlan),
  hellolibvirt: Resolve Coverity issues (John Ferlan),
  storage: return -1 when fs pool can't be mounted (Ján Tomko),
  qemu: fix double free in qemuMigrationPrepareDirect (Ján Tomko),
  Properly detect VMDK with internal version 2 (Martin Kletzander),
  Resolve Coverity complaints in tests/securityselinuxlabeltest.c (John Ferlan),
  Paused domain should remain paused after migration (Jiri Denemark),
  conf: don't check hyperv spinlock retries if disabled (Ján Tomko),
  Fix NULL dereference caused by ACL filtering of domains (Jiri Denemark),
  Unlock the storage volume object after looking it up (Ján Tomko),
  libxl: fix deadlock in libxlReconnectDomain (Marek Marczykowski-Górecki),
  LXC: fix memory leak when userns configuration is incorrect (Gao feng),
  virNetDevBandwidthUnplug: Don't leak @cmd (Michal Privoznik),
  virCgroupNewPartition: Don't leak @newpath (Michal Privoznik),
  qemuNodeDeviceDetachFlags: Avoid use of uninitialized variables (Michal Privoznik),
  qemu: fix return value of qemuDomainBlockPivot on errors (Ján Tomko)
- Improvements:
  tests: consistently use virFilePrintf (Eric Blake),
  Rename VIR_DOMAIN_PAUSED_GUEST_PANICKED to VIR_DOMAIN_PAUSED_CRASHED (Daniel P. Berrange),
  Remove VIR_DOMAIN_SHUTDOWN_CRASHED from public API (Daniel P. Berrange),
  spec: Cat test-suite.log if make check fails (Jiri Denemark),
  build: avoid uninitialized use warning (Eric Blake),
  Set default partition in libvirtd instead of libvirt_lxc (Daniel P. Berrange),
  virStateDriver - Separate AutoStart from Initialize (John Ferlan),
  Separate out StateAutoStart from StateInitialize (John Ferlan),
  Remove redundant free in virNetworkDNSHostDefParseXML (Ján Tomko),
  Remove double space in error messages (Ján Tomko),
  Fix virsh snapshot-list error reporting (Jim Fehlig),
  Skip detecting placement if controller is disabled (Daniel P. Berrange),
  Add 'controllers' arg to virCgroupNewDetect (Daniel P. Berrange),
  Fix detection of 'emulator' cgroup (Daniel P. Berrange),
  Make virCgroupIsValidMachine static (Daniel P. Berrange),
  Introduce a more convenient virCgroupNewDetectMachine (Daniel P. Berrange),
  Add inputpool to storagevolxml2argvtest (Ján Tomko),
  Move volume XMLs out of storagevolxml2argvdata (Ján Tomko),
  Move pool XML out of storagevolxml2argvdata (Ján Tomko),
  Use separate macros for failure/success in vol-to-argv test (Ján Tomko),
  tests: PCI controller checks (Ján Tomko),
  Don't overwrite errors in qemuTranslateDiskSourcePool (Ján Tomko),
  Protection against doing bad stuff to the root group (Daniel P. Berrange),
  Convert LXC driver to use virCgroupNewMachine (Daniel P. Berrange),
  Convert QEMU driver to use virCgroupNewMachine (Daniel P. Berrange),
  New cgroups API for atomically creating machine cgroups (Daniel P. Berrange),
  Add a colon after 'internal error' (Ján Tomko),
  Expose ownership ID parsing (Martin Kletzander),
  qemu: set/validate slot/connection type when assigning slots for PCI devices (Laine Stump),
  qemu: make QEMU_PCI_ADDRESS_(SLOT|FUNCTION)_LAST less misleading (Laine Stump),
  qemu: only check for PIIX3-specific device addrs on pc-* machinetypes (Laine Stump),
  qemu: turn qemuDomainPCIAddressBus into a struct (Laine Stump),
  valgrind.supp: Add more valgrind suppression paths (John Ferlan),
  Create + setup cgroups atomically for LXC process (Daniel P. Berrange),
  Create + setup cgroups atomically for QEMU process (Daniel P. Berrange),
  Remove obsolete cgroups creation apis (Daniel P. Berrange),
  Auto-detect existing cgroup placement (Daniel P. Berrange),
  Add API for checking if a cgroup is valid for a domain (Daniel P. Berrange),
  Add a virCgroupNewDetect API for finding cgroup placement (Daniel P. Berrange),
  Add logic for handling systemd-machined non-existence (Daniel P. Berrange),
  Fix handling of DBus errors emitted by the bus itself (Daniel P. Berrange),
  storage: Add connection for autostart storage pool (John Ferlan),
  Adjust 'ceph' authentication secret usage for rbd pool. (John Ferlan),
  storage: Support "chap" authentication for iscsi pool (John Ferlan),
  qemu_common: Create qemuBuildVolumeString() to process storage pool (John Ferlan),
  qemu: Create a common qemuGetSecretString (John Ferlan),
  qemu: Add source pool auth info to virDomainDiskDef for iSCSI (John Ferlan),
  bridge driver: use more general function names (Roman Bogorodskiy),
  Add virDBusMessage(Encode,Decode) stubs (Roman Bogorodskiy),
  qemu: Translate the volume type disk source before cgroup setting (Osier Yang),
  conf: Ignore the volume type disk if its mode is "direct" (Osier Yang),
  qemu: Translate the iscsi pool/volume disk source (John Ferlan),
  conf: Introduce virDomainDiskSourceIsBlockType (John Ferlan),
  conf: Introduce new XML tag "mode" for disk source (John Ferlan),
  storage_iscsi: Reflect the default target port (John Ferlan),
  bridge driver: s/network_driver/virNetworkDriverState/ (Roman Bogorodskiy),
  Convert remainder of cgroups code to report errors (Daniel P. Berrange),
  Convert the virCgroupKill* APIs to report errors (Daniel P. Berrange),
  Report full errors from virCgroupNew* (Daniel P. Berrange),
  Add helpers for dealing with system errors (Daniel P. Berrange),
  Add API for calling systemd-machined's DBus API (Daniel P. Berrange),
  Introduce virDBusCallMethod & virDBusMessageRead methods (Daniel P. Berrange),
  cpu: Let explicit features override model features (Jiri Denemark),
  cpu: Store arch in virCPUData (Jiri Denemark),
  Replace union cpuData with virCPUData (Jiri Denemark),
  cpu_x86: Use x86-specific CPU data structure (Jiri Denemark),
  LXC: Set default driver for image backed filesystems (Daniel P. Berrange),
  LXC: Fix some error reporting in filesystem setup (Daniel P. Berrange),
  qemu: Unplug devices that disappeared when libvirtd was down (Jiri Denemark),
  qemu: Introduce qemuMonitorGetDeviceAliases (Jiri Denemark),
  conf: Make error reporting in virDomainDefFindDevice optional (Jiri Denemark),
  util: Non-existent string array does not contain any string (Jiri Denemark),
  Change s/i/iv/ in test code to avoid syntax-check (Daniel P. Berrange),
  Allow test cases to be run selectively (Daniel P. Berrange),
  maint: update to latest gnulib (Eric Blake),
  autogen: Handle case when libvirt's submodule (Michal Privoznik),
  security_dac: compute supplemental groups before fork (Eric Blake),
  security: framework for driver PreFork handler (Eric Blake),
  qemu: Emit VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED events (Jiri Denemark),
  qemu: Remove devices only after DEVICE_DELETED event (Jiri Denemark),
  qemu: Add support for DEVICE_DELETED event (Jiri Denemark),
  Add virDomainDefFindDevice for looking up a device by its alias (Jiri Denemark),
  Clarify virDomainDetachDeviceFlags documentation (Jiri Denemark),
  examples: Handle VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED event (Jiri Denemark),
  Add VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED event (Jiri Denemark),
  qemu: Separate char device removal into a standalone function (Jiri Denemark),
  qemu: Set cpuset.cpus for domain process (Osier Yang),
  caps: Add helpers to convert NUMA nodes to corresponding CPUs (Peter Krempa),
  Introduce lxcDomObjFromDomain (Michal Privoznik),
  Remove lxcDriverLock from almost everywhere (Michal Privoznik),
  lxc: Make activeUsbHostdevs use locks (Michal Privoznik),
  Stop accessing driver->caps directly in LXC driver (Michal Privoznik),
  lxc: switch to virCloseCallbacks API (Michal Privoznik),
  Introduce annotations for virLXCDriverPtr fields (Michal Privoznik),
  lxc: Use atomic ops for driver->nactive (Michal Privoznik),
  Introduce a virLXCDriverConfigPtr object (Michal Privoznik),
  virLXCDriver: Drop unused @cgroup (Michal Privoznik),
  qemu: Move close callbacks handling into util/virclosecallbacks.c (Michal Privoznik),
  virAsprintf: correctly check return value (Ján Tomko),
  Merge virCommandPreserveFD / virCommandTransferFD (Daniel P. Berrange),
  Enable FD passing when starting guests with virsh (Daniel P. Berrange),
  LXC: Wire up the virDomainCreate{XML}WithFiles methods (Daniel P. Berrange),
  Introduce remote protocol support for virDomainCreate{XML}WithFiles (Daniel P. Berrange),
  maint: Make ctags work out of the box (Jiri Denemark),
  esx: Support for disk-only and quiescing snapshots. (Geoff Hickey),
  libxl: implement virDomainGetNumaParameters (Dario Faggioli),
  libxl: advertise the support for VIR_TYPED_PARAM_STRING (Dario Faggioli),
  lxc_container: Don't call virGetGroupList during exec (Michal Privoznik),
  qemuDomainGetSchedulerType: Prefer qemuDomObjFromDomain (Michal Privoznik),
  virSecurityManagerGenLabel: Skip seclabels without model (Michal Privoznik),
  lxcCapsInit: Allocate primary security driver unconditionally (Michal Privoznik),
  qemu: Separate host device removal into a standalone function (Jiri Denemark),
  qemu: Separate net device removal into a standalone function (Jiri Denemark),
  qemu: Separate controller removal into a standalone function (Jiri Denemark),
  qemu: Separate disk device removal into a standalone function (Jiri Denemark),
  qemu: Add qemuDomainReleaseDeviceAddress to remove any address (Jiri Denemark),
  build: avoid compiler warning on shadowed name (Eric Blake),
  LXC: Change the owner of live attached host devices (Gao feng),
  LXC: Change the owner of host devices to the root of container (Gao feng),
  LXC: Create host devices for container on host side (Gao feng),
  LXC: Change the owner of live attached disk device (Gao feng),
  LXC: Move virLXCControllerChown to lxc_container.c (Gao feng),
  LXC: controller: change the owner of disk to the root of container (Gao feng),
  LXC: Setup disks for container on host side (Gao feng),
  Allow balloon driver collection to be adjusted dynamically (John Ferlan),
  Implement the virDomainSetMemoryStatsPeriod for QEMU driver (John Ferlan),
  Specify remote protocol for virDomainSetMemoryStatsPeriod (John Ferlan),
  Add capability to fetch balloon stats (John Ferlan),
  Determine whether to start balloon memory stats gathering. (John Ferlan),
  Add 'period' for Memballoon statistics gathering capability (John Ferlan),
  qemuhotplugtest: Introduce test for chardev hotplug (Michal Privoznik),
  qemu: Implement chardev hotplug on live level (Michal Privoznik),
  qemu: Implement chardev hotplug on config level (Michal Privoznik),
  domain_conf: Auto fill chardev port (Michal Privoznik),
  cpu: Allow fine tuning of "host-model" cpu (Peter Krempa),
  cpu: Clean up code style (Peter Krempa),
  cpu: Add virCPUDefUpdateFeature() (Peter Krempa),
  conf: Clean up error reporting in cpu definition parsing (Peter Krempa),
  storage_conf: Merge AuthChap and AuthCephx into AuthSecret (John Ferlan),
  storage_conf: Move username processing into common function (John Ferlan),
  storage_pool: Rework chap XML to mimic ceph (John Ferlan),
  storage_conf: Move auth processing into virStoragePoolDefParseAuth (John Ferlan),
  storage_conf: Introduce virStoragePoolAuthSecretPtr (John Ferlan),
  storage_conf: Adjust virStoragePoolAuthType enum (John Ferlan),
  Add qemuMonitorJSONSetObjectProperty() method for QMP qom-set command (John Ferlan),
  Add qemuMonitorJSONGetObjectProperty() method for QMP qom-get command (John Ferlan),
  Add qemuMonitorJSONGetObjectListPaths() method for QMP qom-list command (John Ferlan),
  pci: make virPCIDeviceReset more autonomous (Laine Stump),
  pci: reorder static functions (Laine Stump),
  python: return dictionary without value in case of no blockjob (Guannan Ren),
  Change domain controller index type to unsigned (Jincheng Miao),
  Add a couple of debug statements to LXC driver (Daniel P. Berrange),
  qemu: Introduce qemuBuildChrDeviceStr (Michal Privoznik),
  qemu_command: Honour chardev alias assignment with a function (Michal Privoznik),
  qemu_monitor: Introduce qemuMonitorDetachCharDev (Michal Privoznik),
  qemu_monitor: Introduce qemuMonitorAttachCharDev (Michal Privoznik),
  qemu_monitor_json: Move InetSocketAddress build to a separate function (Michal Privoznik),
  domain_conf: Introduce chardev hotplug helpers (Michal Privoznik),
  remote: Improve libssh2 password authentication (Peter Krempa),
  libssh2: Improve password based authentication (Peter Krempa),
  virAuth: Don't require virConnectPtr to retrieve authentication creds (Peter Krempa),
  util: add virGetGroupList (Eric Blake),
  util: improve user lookup helper (Eric Blake),
  maint: update to latest gnulib (Eric Blake),
  qemu: Fix hot (un-)plug error codes and messages (Michal Privoznik),
  conf: Rework virDomainDeviceDefParse (Michal Privoznik),
  conf: Extend device types handled by virDomainDeviceDefParse (Michal Privoznik),
  LXC: remove some incorrect setting ATTRIBUTE_UNUSED (Gao feng),
  qemu: Slightly increase memory limit (Jiri Denemark),
  util: add rebase fix that was accidentally omitted from previous patch (Laine Stump),
  util: use VIR_(APPEND|DELETE)_ELEMENT for pci/usb device lists (Laine Stump),
  Prevent use of 'int' data type & 'ii', 'jj', 'kk' var names for loops (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in examples/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in python/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/cpu/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/hyperv/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/interface/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/network/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/libxl/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/locking/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/lxc/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/node_device/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/nwfilter/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/openvz/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/parallels/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/phyp/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/qemu files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/remote/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/rpc/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/secret/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/security files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/test/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/uml/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/vbox/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/storage/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/{esx,vmx,vmware} files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/{xen,xenapi,xenxs} files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in tools/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in tests/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/util/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in src/conf/ files (Daniel P. Berrange),
  Convert 'int i' to 'size_t i' in daemon/ files (Daniel P. Berrange),
  Adapt to VIR_ALLOC and virAsprintf in tools/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in tests/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/xenxs/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/xenapi/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/xen/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/vmx/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/vmware/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/vbox/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/util/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/uml/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/test/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/storage/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/security/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/secret/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/rpc/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/remote/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/qemu/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/phyp/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/parallels/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/openvz/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/nwfilter/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/network/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/node_device/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/lxc/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/locking/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/libxl/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/interface/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/hyperv/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/esx/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/cpu/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/conf/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in src/access/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in daemon/* (Michal Privoznik),
  Adapt to VIR_ALLOC and virAsprintf in docs/ (Michal Privoznik),
  Introduce OOM reporting to virAsprintf (Michal Privoznik),
  viralloc: Report OOM error on failure (Michal Privoznik),
  build: honor autogen.sh --no-git (Eric Blake),
  LXC: hostdev: create parent directory for hostdev (Gao feng),
  LXC: hostdev: introduce lxcContainerSetupHostdevCapsMakePath (Gao feng),
  LXC: Create /dev/tty within a container (Richard Weinberger),
  scsi: Fix construction of sysfs device path (Viktor Mihajlovski),
  selinux: Always generate imagelabel (Peter Krempa),
  selinux: Cleanup coding style (Peter Krempa),
  qemu: Set RLIMIT_MEMLOCK when memoryBacking/locked is used (Jiri Denemark),
  qemu: Use qemuDomainMemoryLimit when computing memory for VFIO (Jiri Denemark),
  qemu: Move memory limit computation to a reusable function (Jiri Denemark),
  Don't spam logs with "port 0 must be in range" errors (Jiri Denemark),
  qemu: Release correct websocket port (Jiri Denemark),
  conf: virDomainObjListRemoveLocked function (Marek Marczykowski-Górecki),
  maint: update to latest gnulib (Eric Blake),
  Extend the ACL test case to validate filter rule checks (Daniel P. Berrange),
  Add access control filtering of interface objects (Daniel P. Berrange),
  Add access control filtering of nwfilter objects (Daniel P. Berrange),
  Add access control filtering of secret objects (Daniel P. Berrange),
  Add access control filtering of storage objects (Daniel P. Berrange),
  Add access control filtering of node device objects (Daniel P. Berrange),
  Add access control filtering of network objects (Daniel P. Berrange),
  Change signature of ACL filter functions (Daniel P. Berrange),
  Add access control filtering of domain objects (Daniel P. Berrange),
  qemu: Allow seamless migration for domains with multiple graphics (Martin Kletzander),
  qemu: Don't miss errors when changing graphics passwords (Martin Kletzander),
  LXC: blkio: allow to setup weight_device (Gao feng),
  qemu: Implement 'oncrash' coredump events when guest panicked (Chen Fan),
  qemu: Implement 'oncrash' events when guest panicked (Chen Fan),
  qemu: expose qemuProcessShutdownOrReboot() (Chen Fan),
  qemu: refactor processWatchdogEvent (Chen Fan),
  libvirt: Define domain crash event types (Chen Fan),
  Add some misc debugging to LXC startup (Daniel P. Berrange),
  Ignore failure to mount SELinux filesystem in container (Daniel P. Berrange),
  LXC: fuse: Change files owner to the root user of container (Gao feng),
  LXC: controller: change the owner of /dev/pts and ptmx to the root of container (Gao feng),
  LXC: controller: change the owner of devices created on host (Gao feng),
  LXC: controller: change the owner of /dev to the root user of container (Gao feng),
  LXC: controller: change the owner of tty devices to the root user of container (Gao feng),
  LXC: Creating devices for container on host side (Gao feng),
  LXC: introduce virLXCControllerSetupUserns and lxcContainerSetID (Gao feng),
  LXC: sort the uidmap/gidmap of domain (Gao feng),
  LXC: enable user namespace only when user set the uidmap (Gao feng),
  LXC: Introduce New XML element for user namespace (Gao feng),
  qemu: Improve info message and remove a variable in qemuDomainManagedSave (Peter Krempa),
  libxl: implement per NUMA node free memory reporting (Dario Faggioli),
  build: configure must not affect tarball contents (Eric Blake),
  Drop iptablesContext (Roman Bogorodskiy),
  qemu: indentation fix (Ján Tomko),
  qemu: Implement CPUs check against machine type's cpu-max (Michal Novotny)
- Cleanups:
  python: Drop TODO (Cole Robinson),
  maint: split long lines in Makefiles (Eric Blake),
  tests: split long lines (Eric Blake),
  qemu: Cleanup coding style nits in qemu_cgroup.c (Peter Krempa)

### 1.1.0: Jul 01 2013

- Features:
  Extensible migration APIs (Jiri Denemark),
  Add a policy kit access control driver (Daniel P. Berrange),
  various improvements in the Xen driver (Jim Fehlig and Marek Marczykowski-Górecki),
  improve networking support on BSD (Roman Bogorodskiy),
  agent based vCPU hotplug support (Peter Krempa)
- Security:
  CVE-2013-2218: Fix crash listing network interfaces with filters (Daniel P. Berrange)
- Documentation:
  Document security reporting & handling process (Daniel P. Berrange),
  Fix reference to #elementsUSB (Philipp Hahn),
  Fix sample TPM XML (Stefan Berger),
  correct and update network vlan example (Laine Stump),
  add spaces to formatstorage.html (Ján Tomko)
- Portability:
  spec: require xen-devel for libxl driver (Eric Blake),
  Conditionalize use of IF_MAXUNIT in virnetdevtap.c (Daniel P. Berrange),
  Replace use of 'in_addr_t' with 'struct in_addr' (Daniel P. Berrange),
  build: Fix VPATH build for access/* (Viktor Mihajlovski),
  util: fix build error on non-Linux systems (Laine Stump),
  conf: Swap order of AddImplicitControllers and DomainDefPostParse (Viktor Mihajlovski),
  S390: Testcase for console default target type (virtio) (Viktor Mihajlovski),
  Fix units in virNetDevBridgeSetSTPDelay on BSD (Roman Bogorodskiy),
  build: Fix check-aclrules in VPATH build (Jiri Denemark),
  build: Fix build with -Werror (Jim Fehlig),
  use net/if.h instead of linux/if.h (Roman Bogorodskiy),
  build: fix build without posix_fallocate (Eric Blake),
  spec: Explicitly require libgcrypt-devel (Jiri Denemark)
- Bug Fixes:
  pci: initialize virtual_functions array pointer to avoid segfault (Laine Stump),
  node device driver: update driver name during dumpxml (Laine Stump),
  Resolve valgrind errors for nodedev cap parsing (John Ferlan),
  Resolve valgrind error in remoteConfigGetStringList() (John Ferlan),
  Resolve valgrind error in virStorageBackendCreateQemuImgCmd() (John Ferlan),
  Resolve valgrind error in virNetDevVlanParse() (John Ferlan),
  Fix vPort management: FC vHBA creation (Dennis Chen),
  bridge: don't crash on bandwidth unplug with no bandwidth (Ján Tomko),
  Plug leak in virCgroupMoveTask (Ján Tomko),
  Fix invalid read in virCgroupGetValueStr (Ján Tomko),
  qemu: fix infinite loop in OOM error path (Laine Stump),
  pci: fix dangling pointer in qemuDomainReAttachHostdevDevices (Laine Stump),
  pci: eliminate leak in OOM condition (Laine Stump),
  util: fix bug found by Coverity (Laine Stump),
  Fix possible NULL dereference during migration (Jiri Denemark),
  virsh: edit: don't leak XML string on reedit or redefine (Ján Tomko),
  qemu: don't reset PCI devices being assigned with VFIO (Laine Stump),
  pci: eliminate memory leak in virPCIDeviceReattach (Laine Stump),
  qemu: check if block I/O limits fit into long long (Ján Tomko),
  network: increase max number of routes (Laine Stump),
  lxc: Resolve issue with GetScheduler APIs for non running domain (John Ferlan),
  qemu: Resolve issue with GetScheduler APIs for non running domain (John Ferlan),
  qemu: Avoid leaking uri in qemuMigrationPrepareDirect (Jiri Denemark),
  udev: fix crash in libudev logging (Ján Tomko),
  remote: Fix client crash when URI path is empty when using ssh (Peter Krempa),
  remote: Forbid default "/session" connections when using ssh transport (Peter Krempa),
  nodedev: fix vport detection for FC HBA (Ján Tomko),
  qemu: Fix memory leak in Prepare phase (Jiri Denemark),
  virSocketAddrIsWildcard: Use IN6_IS_ADDR_UNSPECIFIED correctly (Michal Privoznik),
  Fix ordering of file open in virProcessGetNamespaces (Richard Weinberger),
  qemuDomainGetVcpusFlags: Initialize ncpuinfo (Michal Privoznik),
  virtlockd: fix socket path (Ján Tomko),
  nwfilter: grab driver lock earlier during init (bz96649) (Stefan Berger),
  Fix a invalid usage of virDomainNetDef in OpenVZ driver (Alvaro Polo),
  use virBitmapFree instead of VIR_FREE for cpumask (Ján Tomko),
  usb: don't spoil decimal addresses (Martin Kletzander)
- Improvements:
  Allow RO connections to interface udev backend (Doug Goldstein),
  virsh: Add parenthesis into virsh nodedev-detach help (xuzhang),
  nodedev: add iommuGroup to node device object (Laine Stump),
  pci: new iommu_group functions (Laine Stump),
  network: allow <vlan> in type='hostdev' networks (Laine Stump),
  test: include qemuhotplugtest data files in source rpm (Laine Stump),
  pci: virPCIDeviceListAddCopy API (Laine Stump),
  pci: update stubDriver name in virPCIDeviceBindToStub (Laine Stump),
  pci: eliminate repetitive path constructions in virPCIDeviceBindToStub (Laine Stump),
  pci: rename virPCIParseDeviceAddress and make it public (Laine Stump),
  pci: rename virPCIDeviceGetVFIOGroupDev to virPCIDeviceGetIOMMUGroupDev (Laine Stump),
  pci: eliminate unused driver arg from virPCIDeviceDetach (Laine Stump),
  tests: Introduce qemuhotplugtest (Michal Privoznik),
  qemu: Implement support for VIR_MIGRATE_PARAM_GRAPHICS_URI (Jiri Denemark),
  Implement extensible migration APIs in qemu driver (Jiri Denemark),
  qemu: Move internals of Confirm phase to qemu_migration.c (Jiri Denemark),
  qemu: Move common parts of Prepare phase to qemu_migration.c (Jiri Denemark),
  qemu: Move internals of Begin phase to qemu_migration.c (Jiri Denemark),
  Use 1.1.0 everywhere in the documentation (Ján Tomko),
  Add polkit policy for API checks to rpm spec (Daniel Veillard),
  Configure native vlan modes on Open vSwitch ports (james robson),
  Introduce VIR_MIGRATE_PARAM_GRAPHICS_URI parameter (Jiri Denemark),
  virsh: Use extensible migration APIs (Jiri Denemark),
  python: Add bindings for extensible migration APIs (Jiri Denemark),
  Adapt virDomainMigratePeer2Peer for extensible migration APIs (Jiri Denemark),
  Adapt virDomainMigrateVersion3 for extensible migration APIs (Jiri Denemark),
  Implement extensible migration APIs in remote driver (Jiri Denemark),
  New internal migration APIs with extensible parameters (Jiri Denemark),
  Introduce migration parameters (Jiri Denemark),
  Introduce virTypedParamsCopy internal API (Jiri Denemark),
  Log input type parameters in API entry points (Jiri Denemark),
  Introduce VIR_TYPED_PARAMS_DEBUG macro for dumping typed params (Jiri Denemark),
  Introduce virTypedParamsReplaceString internal API (Jiri Denemark),
  Introduce virTypedParamsCheck internal API (Jiri Denemark),
  util: Emit proper error code in virTypedParamsValidate (Jiri Denemark),
  Rename virTypedParameterArrayValidate as virTypedParamsValidate (Jiri Denemark),
  pci: make virPCIDeviceDetach consistent in behavior (Laine Stump),
  pci: new utility functions (Laine Stump),
  pci: change stubDriver from const char* to char* (Laine Stump),
  syntax: virPCIDeviceFree is also a NOP for NULL args (Laine Stump),
  libxl: support qdisk backend (Jim Fehlig),
  libxl: Fix disk format error message (Jim Fehlig),
  Add validation that all APIs contain ACL checks (Daniel P. Berrange),
  Set process ID in system identity (Daniel P. Berrange),
  Add ACL checks into the secrets driver (Daniel P. Berrange),
  Add ACL checks into the nwfilter driver (Daniel P. Berrange),
  Add ACL checks into the node device driver (Daniel P. Berrange),
  Add ACL checks into the interface driver (Daniel P. Berrange),
  Add ACL checks into the network driver (Daniel P. Berrange),
  Add ACL checks into the storage driver (Daniel P. Berrange),
  Add ACL checks into the libxl driver (Daniel P. Berrange),
  Add ACL checks into the Xen driver (Daniel P. Berrange),
  Add ACL checks into the UML driver (Daniel P. Berrange),
  Add ACL checks into the LXC driver (Daniel P. Berrange),
  Add ACL checks into the QEMU driver (Daniel P. Berrange),
  Auto-generate helpers for checking access control rules (Daniel P. Berrange),
  Add ACL annotations to all RPC messages (Daniel P. Berrange),
  Setup default access control manager in libvirtd (Daniel P. Berrange),
  Set conn->driver before running driver connectOpen method (Daniel P. Berrange),
  Define basic internal API for access control (Daniel P. Berrange),
  netdev: accept NULL in virNetDevSetupControl (Ján Tomko),
  xen: Implement virConnectGetSysinfo (Jim Fehlig),
  libxl: Implement virConnectGetSysinfo (Jim Fehlig),
  libxl: Allow libxl to set NIC devid (Jim Fehlig),
  storage: add support for creating qcow2 images with extensions (Ján Tomko),
  conf: add features to volume target XML (Ján Tomko),
  util: add support for qcow2v3 image detection (Ján Tomko),
  qemu: add hv_vapic and hv_spinlocks support (Ján Tomko),
  conf: add vapic and spinlocks to hyperv features (Ján Tomko),
  BSD: implement bridge add/remove port and set STP (Roman Bogorodskiy),
  BSD: implement virNetDevBridgeCreate() and virNetDevBridgeDelete() (Roman Bogorodskiy),
  conf: Requires either uuid or usage of secret (Osier Yang),
  qemu: Make probing for commands declarative (Jiri Denemark),
  qemu: Make probing for events declarative (Jiri Denemark),
  libxl: support paused domain restore in virDomainRestoreFlags (Marek Marczykowski-Górecki),
  qemuDomainChangeGraphics: Check listen address change by listen type (Michal Privoznik),
  libxl: initialize device structures (Marek Marczykowski-Górecki),
  libxl: populate xenstore memory entries at startup, handle dom0_mem (Marek Marczykowski-Górecki),
  conf: split out snapshot disk XML formatting (Ján Tomko),
  storage: rework qemu-img command line generation (Ján Tomko),
  util: switch virBufferTrim to void (Ján Tomko),
  migration: Don't propagate VIR_MIGRATE_ABORT_ON_ERROR (Peter Krempa),
  migration: Make erroring out on I/O error controllable by flag (Peter Krempa),
  qemu_migration: Move waiting for SPICE migration (Michal Privoznik),
  spec: Enable KVM support on ARM (Cole Robinson),
  virsh: Support SCSI_GENERIC cap flag for nodedev-list (Osier Yang),
  nodedev: Support SCSI_GENERIC cap flag for listAllNodeDevices (Osier Yang),
  nodedev_hal: Enumerate scsi generic device (Osier Yang),
  nodedev_udev: Enumerate scsi generic device (Osier Yang),
  qemu: set QEMU_CAPS_DEVICE_VIDEO_PRIMARY cap flag in QMP detection (Guannan Ren),
  nodedev_udev: changes missed by commit 1aa0ba3cef (Osier Yang),
  nodedev_udev: Refactor udevGetDeviceType (Osier Yang),
  nodedev: Expose sysfs path of device (Osier Yang),
  Move virGetUserEnt() to where its needed (Doug Goldstein),
  BSD: implement virNetDevTapCreate() and virNetDevTapDelete() (Roman Bogorodskiy),
  Make virNetDevSetupControl() public. (Roman Bogorodskiy),
  LXC: s/chroot/chdir in lxcContainerPivotRoot() (Richard Weinberger),
  Implement dispose method for libxlDomainObjPrivate (Frediano Ziglio),
  libxl: allow only 'ethernet' and 'bridge' interfaces, allow script there (Marek Marczykowski-Górecki),
  qemu: allow restore with non-migratable XML input (Ján Tomko),
  libxl: set bootloader for PV domains if not specified (Jim Fehlig),
  libxl: Report connect type as Xen (Jim Fehlig),
  schema: simplify RNG pattern, remove superfluous <optional> (Claudio Bley),
  libvirt_private.syms: add virProcessGetStartTime (Ján Tomko),
  qemu: Forbid migration of machines with I/O errors (Peter Krempa),
  qemu: Cancel migration if guest encoutners I/O error while migrating (Peter Krempa),
  qemu_migrate: Dispose listen address if set from config (Michal Privoznik),
  selinux: assume 's0' if the range is empty (Ján Tomko),
  storage: fix description of versionOffset (Martin Kletzander),
  spec: Drop Requires: vbox (Cole Robinson),
  Prefer VIR_STRDUP over virAsprintf(&dst, "%s", str) (Michal Privoznik),
  qemu: Implement new QMP command for cpu hotplug (Peter Krempa),
  qemu: Implement support for VIR_DOMAIN_VCPU_AGENT in qemuDomainSetVcpusFlags (Peter Krempa),
  qemu: Implement request of vCPU state using the guest agent (Peter Krempa),
  API: Introduce VIR_DOMAIN_VCPU_AGENT, for agent based CPU hot(un)plug (Peter Krempa),
  qemu_agent: Introduce helpers for agent based CPU hot(un)plug (Peter Krempa),
  qemu: Use bool instead of int in qemuMonitorSetCPU APIs (Peter Krempa),
  virsh-domain-monitor: Remove ATTRIBUTE_UNUSED from a argument (Peter Krempa),
  Add support for VirtualBox 4.2 APIs (ryan woodsmall),
  qemuDomainMigrateGraphicsRelocate: Use then new virSocketAddrIsWildcard (Michal Privoznik),
  virsocket: Introduce virSocketAddrIsWildcard (Michal Privoznik),
  iscsi: pass hostnames to iscsiadm instead of resolving them (Ján Tomko),
  qemu: Report the offset from host UTC for RTC_CHANGE event (Osier Yang),
  qemu: simplify CPU command line parsing (Ján Tomko),
  qemu: change two-state int parameters to bool (Ján Tomko),
  nwfilter: change two-state int parameters to bool (Ján Tomko),
  Remove redundant two-state integers (Ján Tomko),
  Replace two-state local integers with bool (Ján Tomko),
  storage: Avoid unnecessary ternary operators and refactor the code (Peter Krempa),
  openvz: Fix code coverage issue in OpenVZ driver (Alvaro Polo),
  qemu: Reformat listen address prior to checking (Michal Privoznik),
  Ensure non-root can read /proc/meminfo file in LXC containers (Daniel P. Berrange),
  storage: Provide better error message if metadata pre-alloc is unsupported (Peter Krempa),
  storage: Clean up function header and reflow error message (Peter Krempa),
  storagevolxml2argvtest: Report better error messages on test failure (Peter Krempa),
  maint: don't use config.h in .h files (Eric Blake),
  qemu: Abstract code for the cpu controller setting into a helper (Osier Yang),
  storage: Forbid to shrink the vol's capacity if no --shrink is specified (Osier Yang),
  storage: Support preallocate the new capacity for vol-resize (Osier Yang),
  snapshot: remove mutually exclusive memory and disk-only duplicate check (Guannan Ren),
  virsh: Allow attach-disk to specify disk wwn (Osier Yang),
  tests: fix typo in securityselinuxtest (Ján Tomko),
  virsh: Obey pool-or-uuid spec when creating volumes (Jiri Denemark),
  libvirt-qemu: Dispatch errors from virDomainQemuAgentCommand() (Peter Krempa),
  qemu: Properly report guest agent errors on command passthrough (Peter Krempa),
  virsh-domain: Report errors and don't deref NULL in qemu-agent-command (Peter Krempa),
  RPC: Support up to 16384 cpus on the host and 4096 in the guest (Peter Krempa),
  virsh iface-bridge: Ignore delay if stp is turned off (Jiri Denemark),
  Fix warning about using an uninitialized next_unit value (Jiri Denemark),
  virsh-domain: Add --live, --config, --current logic to cmdAttachInterface (Peter Krempa),
  virsh-domain: Add --live, --config, --current logic to cmdAttachDisk (Peter Krempa),
  virsh-domain: Add --live, --config, --current logic to cmdAttachDevice (Peter Krempa)
- Cleanups:
  Get rid of useless VIR_STORAGE_FILE_FEATURE_NONE (Ján Tomko),
  configure: Remove unused brctl check (Cole Robinson),
  storage_backend: Drop unused code (Cole Robinson),
  Remove legacy code for single-instance devpts filesystem (Daniel P. Berrange)

### 1.0.6: Jun 03 2013

- Features:
  Move VirtualBox driver into libvirtd (Daniel P. Berrange),
  Support for static routes on a virtual bridge (Gene Czarcinski),
  Various improvement for hostdev SCSI support (Osier Yang and Han Cheng),
  Switch to VIR_STRDUP and VIR_STRNDUP (Michal Privoznik),
  Various cleanups and improvement in Xen and LXC drivers (Daniel P. Berrange)
- Documentation:
  Document that runtime changes may be lost after S4 suspend (Jiri Denemark),
  domain: /dev/urandom isn't a valid rng patch (Cole Robinson),
  formatdomain: fix links in the table of contents (Ján Tomko),
  add another user (Eric Blake),
  datatypes: fix virGetStoragePool's comment (Ján Tomko),
  Expand documentation for LXC driver (Daniel P. Berrange),
  Fix/update syntax in Sysinfo/SMBIOS description (John Ferlan),
  Update formatdomain for lifecycle events (John Ferlan),
  Fix the wrong links in secret documentation (Osier Yang),
  Add the missed usage type 'iscsi' (Osier Yang),
  Add docs about cgroups layout and usage (Daniel P. Berrange),
  Point users to Virt-Viewer MSI installers for Windows builds (Daniel P. Berrange),
  Fix namespace bugs in API docs, todo page & hv support page (Daniel P. Berrange),
  Fix a few more docs XSL bugs related to the TOC (Daniel P. Berrange),
  Fix docs generator regression in previous commit (Daniel P. Berrange),
  Fix multiple formatting problems in HTML docs (Daniel P. Berrange),
  fix 'since' for socket path generation (Ján Tomko)
- Portability:
  vbox: define DYNLIB_NAME for kFreeBSD (Guido Günther),
  build: skip qemu in tests when !WITH_QEMU (Eric Blake),
  build: use correct rpc.h for virtlockd (Eric Blake),
  build: work around cygwin header bug (Eric Blake),
  build: cast [ug]id_t when printing (Eric Blake),
  build: port qemu to cygwin (Eric Blake),
  build: use correct rpc.h for lockd (Eric Blake),
  build: work around broken sasl header (Eric Blake),
  build: fix build without libvirtd (Eric Blake),
  build: fix build with newer gnutls (Eric Blake),
  build: fix build with older gcc (Eric Blake),
  qemu: Fix build without gnutls (Jiri Denemark),
  spec: Build vbox packages only for x86 architectures (Viktor Mihajlovski),
  Add missing c-ctype.h to virfile.c (Daniel P. Berrange),
  test: fix VPATH fchosttest failure (Viktor Mihajlovski),
  libxl: fix build with Xen4.3 (Jim Fehlig),
  build: Fix check-driverimpls in VPATH (Jiri Denemark),
  util: Fix build without devmapper (Jiri Denemark),
  FreeBSD: disable buggy -fstack-protector-all (Roman Bogorodskiy),
  build: avoid gcrypt deprecation warnings (Roman Bogorodskiy),
  build: avoid shadowed variable in fdstreamtest (Eric Blake),
  fix virNetDevSetMAC and virNetDevExists on BSD (Roman Bogorodskiy),
  Disable some URI tests on older libxml2 (Daniel P. Berrange),
  Fix build of python bindings on Python 2.4 (Daniel P. Berrange),
  build: fix build with old polkit0 (Jim Fehlig),
  Fixup rpcgen code on kFreeBSD too (Guido Günther),
  build: avoid non-portable cast of pthread_t (Eric Blake),
  build: Fix build when WITH_HAL is defined (Jim Fehlig),
  build: fix mingw build of vbox (Eric Blake),
  build: fix mingw build of virprocess.c (Eric Blake)
- Bug Fixes:
  conf: Generate address for scsi host device automatically (Osier Yang),
  qemu: prevent termination of guests w/hostdev on driver reconnect (Laine Stump),
  qemu: escape literal IPv6 address in NBD migration (Ján Tomko),
  Check for existence of interface prior to setting terminate flag (John Ferlan),
  Resolve memory leak found by valgrind (John Ferlan),
  qemu: snapshot: Don't kill access to disk if snapshot creation fails (Peter Krempa),
  virsh: migrate: Don't disallow --p2p and --migrateuri (Cole Robinson),
  qemu: Don't report error on successful media eject (Cole Robinson),
  qemu: save domain state to XML after reboot (Sergey Fionov),
  esx: Fix dynamic VI object type detection (Matthias Bolte),
  storage_conf: Don't leak "uuid" in virStoragePoolDefParseAuthCephx (Osier Yang),
  storage_conf: Fix the wrong error message (Osier Yang),
  Fix blkdeviotune for shutoff domain (Martin Kletzander),
  virsh: Fix regression of vol-resize (Osier Yang),
  xen: Resolve Coverity FORWARD_NULL issue (John Ferlan),
  qemu: fix NBD migration to hosts with IPv6 enabled (Ján Tomko),
  conf: fix use after free in virChrdevOpen (Ján Tomko),
  virNetMessageSaveError: Fix copy and paste error (Michal Privoznik),
  virNWFilterHashTablePut: Free the correct variable (Michal Privoznik),
  umlConnectTapDevice: initialize tapfd variable (Michal Privoznik),
  remote: fix dom->id after virDomainCreateWithFlags (Marek Marczykowski),
  virsh: Fix virDomainFree for NULL domain in blkdeviotune (Martin Kletzander),
  virNetDevTapCreate: Fail on systems not supporting IFF_MULTI_QUEUE (Michal Privoznik),
  cgroup: be robust against cgroup movement races (Eric Blake),
  shunloadtest: Resolve Coverity CHECKED_RETURN error (John Ferlan),
  xencapstest: Resolve Coverity CHECKED_RETURN error (John Ferlan),
  qemu: fix a typo in qemuAddSharedDevice (Guannan Ren),
  qemuDomainChangeEjectableMedia: Unlock domain while waiting for event (Michal Privoznik),
  LXC: fix memory leak in virLXCControllerSetupDevPTS (Gao feng),
  LXC: remove unnecessary check on root filesystem (Gao feng),
  esx: Fix error reporting in esxVI_LookupManagedObjectHelper (Matthias Bolte),
  Fix failure to detect missing cgroup partitions (Daniel P. Berrange),
  libxl: fix leaking libxl events (Jim Fehlig),
  qemu: Fix cgroup handling when setting VCPU BW (Martin Kletzander),
  Don't mount selinux fs in LXC if selinux is disabled (Daniel P. Berrange),
  Fix LXC startup when /var/run is an absolute symlink (Daniel P. Berrange),
  conf: Fix the bug of disk->copy_on_read formating (Osier Yang),
  daemon: fix leak after listing all volumes (Ján Tomko),
  qemu: Fix crash in migration of graphics-less guests. (Viktor Mihajlovski),
  Adjust improperly formatted <sysinfo> uuid (John Ferlan),
  storage: Ensure 'qemu-img resize' size arg is a 512 multiple (Christophe Fergeau),
  spec: fix outdated comment (Eric Blake),
  Forbid use of ':' in RBD pool names (Daniel P. Berrange),
  qemu: fix bad free (Eric Blake),
  Fix starting domains when kernel has no cgroups support (Jim Fehlig),
  Fix error handling of readdir() in virFileLoopDeviceOpen (Daniel P. Berrange),
  util: Fix regression introduced by commit 4360a098441 (Osier Yang),
  util: Fix regression of wwn reading (Osier Yang),
  build: fix use of mmap (Eric Blake),
  conf: don't crash on a tpm device with no backends (Ján Tomko),
  don't mention disk controllers in generic controller errors (Ján Tomko),
  iscsi: don't leak portal string when starting a pool (Ján Tomko),
  virsh: Resolve Coverity 'MISSING_BREAK' (John Ferlan),
  lxc: Coverity false positive USE_AFTER_FREE (John Ferlan),
  Don't allow renaming of domains by the backdoor (Daniel P. Berrange),
  qemu: fix stupid typos in VFIO cgroup setup/teardown (Laine Stump),
  Ignore 'uri' parameter in lockd driver (Daniel P. Berrange),
  network: fix network driver startup for qemu:///session (Laine Stump),
  Fix warning about unsupported cookie flags in QEMU driver (Daniel P. Berrange),
  Fix release of resources with lockd plugin (Daniel P. Berrange),
  Fix F_DUPFD_CLOEXEC operation args (Daniel P. Berrange),
  build: fix make rpm failure (Laine Stump),
  Fix potential use of undefined variable in remote dispatch code (Daniel P. Berrange),
  virInitctlRequest: unbreak make syntax check (Guido Günther),
  virInitctlRequest: unbreak make syntax check (Guido Günther)
- Improvements:
  nodedev_hal: Modernize the function's style (Osier Yang),
  Introduce virFilePrintf() as a portable fprintf() (Daniel P. Berrange),
  qemu: migration: error if tunnelled + storage specified (Cole Robinson),
  qemu: migration: Improve p2p error if we can't open conn (Cole Robinson),
  storage_conf: Use uid_t/gid_t instead of int to cast the value (Osier Yang),
  storage_conf: Improve error messages (Osier Yang),
  storage_conf: Use NULLSTR instead (Osier Yang),
  storage_conf: Improve the memory deallocation of virStorageVolDefParseXML (Osier Yang),
  storage_conf: Improve the memory deallocation of pool def parsing (Osier Yang),
  syntax: fix broken error message in previous patch (Eric Blake),
  util: fix the VIR_STRDUP when src is NULL (yangdongsheng),
  Adapt to new VIR_STRNDUP behavior (Michal Privoznik),
  virStrndup: Accept negative values as string length (Michal Privoznik),
  storage_conf: Fix the error type (Osier Yang),
  storage_conf: Put "%s" at the same line with error type (Osier Yang),
  storage_conf: Use xmlStrEqual instead of STREQ (Osier Yang),
  storage_conf: Remove the useless casting (Osier Yang),
  syntax-check: ignore all quoted strings in bracket-spacing (Ján Tomko),
  nwfilter: Remove error report in virNWFilterDHCPSnoopEnd (Stefan Berger),
  cgroups: Do not enforce nonexistent controllers (Viktor Mihajlovski),
  Introduce syntax-check rule to prefer VIR_STRDUP over strdup (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in tools/virsh.c (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/util/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/util/vircgroup.c (Michal Privoznik),
  virCgroupAddTaskStrController: s/-1/-ENOMEM/ (Michal Privoznik),
  conf: add missing OOM errors (Ján Tomko),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/xenxs/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/xenapi/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/xen/* (Michal Privoznik),
  Fix the build failure (Osier Yang),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/security/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/rpc/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/remote/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/qemu/* (Michal Privoznik),
  virsh: omit OPTION section in 'virsh help' if no option exists (Zhang Xiaohe),
  Change virConnectDomainEventGraphicsCallback signature (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/openvz/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/conf/* (Michal Privoznik),
  qemu: Enable multiqueue network (Michal Privoznik),
  qemu: Adapt qemuBuildInterfaceCommandLine to to multiqueue net (Michal Privoznik),
  qemu: Move interface cmd line construction into a separate function (Michal Privoznik),
  Introduce /domain/devices/interface/driver/@queues attribute (Michal Privoznik),
  qemu: add ', share=<policy>' to qemu commandline (Guannan Ren),
  conf: add 'sharePolicy' attribute to graphics element for vnc (Guannan Ren),
  qemu: new vnc display sharing policy caps flag (Guannan Ren),
  vbox: fix VIR_STRDUP value check (Ján Tomko),
  syntax-check: Add the rule to forbid whitespace before ";" (Osier Yang),
  Fix the syntax-check failure (Osier Yang),
  interface: list all interfaces with flags == 0 (Guannan Ren),
  Convert Xen domain core dump driver methods to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain stats/peek driver methods to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain scheduler driver methods to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain autostart driver methods to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain device hotplug driver methods to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain VCPU driver methods to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain create/define/getxml/migration APIs to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain managed save driver methods to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain property driver methods to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain lifecycle driver methods to use virDomainDefPtr (Daniel P. Berrange),
  Convert Xen domain lookup driver methods to use virDomainDefPtr (Daniel P. Berrange),
  qemu: Don't remove the "return 0" (Osier Yang),
  esx: Replace almost all esxVI_String_DeepCopyValue vith VIR_STRDUP (Matthias Bolte),
  vmware: Restore OOM error reporting in vmwareCopyVMXFileName (Matthias Bolte),
  maint: enforce correct copyright usage (Eric Blake),
  maint: refer to correct license file (Eric Blake),
  maint: follow recommended practice for using LGPL (Eric Blake),
  maint: use LGPL correctly (Eric Blake),
  openvzDomainSetNetwork: use virCommand (Michal Privoznik),
  qemu: Add callback struct for qemuBuildCommandLine (Osier Yang),
  storage_conf: Improve the coding style in storage_conf.h (Osier Yang),
  storage_conf: Fix indentions in storage_conf.c (Osier Yang),
  storage_conf: Fix the coding stype in storage_conf.c (Osier Yang),
  qemu: Abstract code for cpuset controller setting into a helper (Osier Yang),
  qemu: Abstract code for devices controller setting into a helper (Osier Yang),
  qemu: Abstract code for memory controller setting into a helper (Osier Yang),
  qemu: Abstract the code for blkio controller setting into a helper (Osier Yang),
  Add libvirt-daemon-vbox & libvirt-daemon-driver-vbox RPMs (Daniel P. Berrange),
  Include GNULIB mkdtemp module (Daniel P. Berrange),
  Set PKG_CONFIG_LIBDIR in autobuild.sh (Daniel P. Berrange),
  qemu: report useful error failing to destroy domain gracefully (Guannan Ren),
  qemu: Check conflicts for shared scsi host device (Osier Yang),
  Re-add selinux/selinux.h to lxc_container.c (Daniel P. Berrange),
  schema: make source optional in volume XML (Ján Tomko),
  schema: require target path in storage pool xml (Ján Tomko),
  qemu: Change values of disk discard (Osier Yang),
  qemu: Implement support for locking domain's memory pages (Jiri Denemark),
  Add support for locking domain's memory pages (Jiri Denemark),
  Fix build with VirtualBox (Jiri Denemark),
  qemu: Set unpriv_sgio for scsi host device (Osier Yang),
  qemu: Refactor qemuSetUnprivSGIO to support scsi host device (Osier Yang),
  qemu: Move qemuSetUnprivSGIO into qemu_conf.c (Osier Yang),
  conf: Introduce sgio for hostdev (Osier Yang),
  Rename virDomainDiskSGIO to virDomainDeviceSGIO (Osier Yang),
  qemu: Manage shared device entry for scsi host device (Osier Yang),
  qemu: Refactor the helpers to track shared scsi host device (Osier Yang),
  utils: Add a helper to get the device name that sg device mapped to (Osier Yang),
  qemu: Rename qemu_driver->sharedDisks to qemu_driver->sharedDevices (Osier Yang),
  conf: Introduce <shareable> for hostdev (Osier Yang),
  string: test VIR_STRDUP (Eric Blake),
  virsh: lookup interface by name or mac other than one by one (Guannan Ren),
  nwfilter: check for inverted ctdir (Stefan Berger),
  Validate the bios_date format for <sysinfo> (John Ferlan),
  Remove obsolete skipRoot flag in LXC driver (Daniel P. Berrange),
  Stop passing around old root directory prefix (Daniel P. Berrange),
  Remove obsolete pivotRoot flag in LXC driver (Daniel P. Berrange),
  qemu: Support discard for disk (Osier Yang),
  Handle the domain event 'on_reboot' and 'on_poweroff' settings (John Ferlan),
  Adjust comments to describe on_poweroff and on_reboot action (John Ferlan),
  Adjust usage of qemu -no-reboot and -no-shutdown options (John Ferlan),
  qemu: Add VNC WebSocket support (Martin Kletzander),
  Add VNC WebSocket support (Martin Kletzander),
  qemu: New XML to disable memory merge at guest startup (Osier Yang),
  qemu: detect -machine mem-merge capability (Eric Blake),
  Rename rbd-invalid.xml to rbd-no-colon.xml (Daniel P. Berrange),
  tests: Add fchostdata in EXTRA_DIST (Osier Yang),
  virsh: Pretty the output of qemu-agent-command (Osier Yang),
  virsh: Use vshPrint instead of printf (Osier Yang),
  Fix invalid argument reference in virnetdev.h (Martin Kletzander),
  Don't duplicate compiler warning flags when linking (Daniel P. Berrange),
  Only pass -export-dynamic to linker, not compiler (Daniel P. Berrange),
  Correctly detect warning flags with clang (Daniel P. Berrange),
  Ignore cast alignment warnings in inotify code for Xen. (Daniel P. Berrange),
  Workaround issue with clang and inline functions with static vars (Daniel P. Berrange),
  Ensure consistent enablement of gcc 'diagnostic' pragma (Daniel P. Berrange),
  qemu: query command line options in QMP (Eric Blake),
  qemu: simplify string cleanup (Eric Blake),
  qemu: use bool in monitor struct (Eric Blake),
  json: support removing a value from an object (Eric Blake),
  Don't overwrite useful message when creating macvlan fails (Daniel P. Berrange),
  Remove & ban use of select() for waiting for I/O (Daniel P. Berrange),
  qemu: Add hotplug support for scsi host device (Han Cheng),
  .gitignore: add fchosttest (Ján Tomko),
  qemu: Refactor helpers for USB device attachment (Osier Yang),
  Escaping leading '.' in cgroup names (Daniel P. Berrange),
  qemu: Introduce activeScsiHostdevs list for scsi host devices (Han Cheng),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/vbox/* (Michal Privoznik),
  Support NBD backed disks/filesystems in LXC driver (Daniel P. Berrange),
  Add 'nbd' as a valid filesystem driver type (Daniel P. Berrange),
  Add a helper API for setting up a NBD device with qemu-nbd (Daniel P. Berrange),
  Re-arrange code setting up ifs/disk loop devices for LXC (Daniel P. Berrange),
  Add support for storage format in FS <driver> (Daniel P. Berrange),
  security_apparmor.c: Include virscsi.h (Michal Privoznik),
  security: Manage the security label for scsi host device (Osier Yang),
  qemu: Allow the scsi-generic device in cgroup (Han Cheng),
  qemu: Support bootindex for scsi host device (Osier Yang),
  Introduce <readonly> for hostdev (Osier Yang),
  rng: Interleave hostdev elements (Osier Yang),
  qemu: Build qemu command line for scsi host device (Han Cheng),
  utils: util functions for scsi hostdev (Han Cheng),
  qemu: New cap flags for scsi-generic (Han Cheng),
  node_device: Clean up unused macros (Osier Yang),
  conf: Generic XMLs for scsi hostdev (Han Cheng),
  tests: Add tests for fc_host (Osier Yang),
  util: Honor the passed sysfs_prefix (Osier Yang),
  util: Update the comment for virGetFCHostNameByWWN (Osier Yang),
  util: Change virIsCapable* to return bool (Osier Yang),
  util: Don't miss the slash in constructed path (Osier Yang),
  build: update to latest gnulib, for syntax-check (Eric Blake),
  Update hellolibvirt to demo virGetLastErrorMessage() (Daniel P. Berrange),
  Add a test case for the fdstream file read/write code (Daniel P. Berrange),
  Allow the iohelper path to be customized by test programs (Daniel P. Berrange),
  Add a virGetLastErrorMessage() function (Daniel P. Berrange),
  Fix iohelper usage with streams opened for read (Daniel P. Berrange),
  Cope with missing swap cgroup controls (Daniel P. Berrange),
  util: move virFile* functions from virutil.c to virfile.c (Laine Stump),
  util: fix virFileOpenAs return value and resulting error logs (Laine Stump),
  Build breaker - requires VIR_FROM_THIS (John Ferlan),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/test/* (Michal Privoznik),
  virGetStorageVol: Don't ignore NULL pool name (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in tests/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/storage/* (Michal Privoznik),
  dom event example: Add error check to impl call (Jesse J. Cook),
  dom event example: init before register event impl (Jesse J. Cook),
  conf: Fix typo in error message in ABI stability check (Peter Krempa),
  tests: use portable shell code (Eric Blake),
  Replace 'goto clean' with 'goto cleanup' in apparmor code (Daniel P. Berrange),
  Replace list of driver source files with variables (Daniel P. Berrange),
  Fix naming of methods in ESX storage backends to follow public APIs (Daniel P. Berrange),
  Skip virNWFilterTechDriver when validating API naming (Daniel P. Berrange),
  Replace 'goto cleanup' with 'goto error' in udev interface driver (Daniel P. Berrange),
  Replace 'goto err' with 'goto cleanup' in udev interface driver (Daniel P. Berrange),
  tests: files named '.*-invalid.xml' should fail validation (Ján Tomko),
  Simplify the Xen domain stats/peek / node memory driver methods (Daniel P. Berrange),
  Simplify the Xen domain autostart driver method (Daniel P. Berrange),
  Simplify the Xen domain scheduler parameter driver methods (Daniel P. Berrange),
  Simplify the Xen domain attach/dettach driver methods (Daniel P. Berrange),
  Simplify the Xen domain define/undefine driver methods (Daniel P. Berrange),
  Simplify the Xen domain start driver method (Daniel P. Berrange),
  Simplify the Xen driver define domain driver methods (Daniel P. Berrange),
  Simplify the Xen domain migration driver methods (Daniel P. Berrange),
  Simplify the Xen domain get XML driver method (Daniel P. Berrange),
  Simplify the Xen domain VCPU driver methods (Daniel P. Berrange),
  Simplify the Xen domain save/restore driver methods (Daniel P. Berrange),
  Simplify the Xen domain get info/state driver methods (Daniel P. Berrange),
  Simplify the Xen domain get/set (max) memory driver methods (Daniel P. Berrange),
  Remove Xen get hostname driver method (Daniel P. Berrange),
  Simplify the Xen domain get OS type driver method (Daniel P. Berrange),
  Simplify the Xen domain destroy driver method (Daniel P. Berrange),
  Simplify the Xen domain shutdown/reboot driver methods (Daniel P. Berrange),
  Simplify the Xen domain suspend/resume driver methods (Daniel P. Berrange),
  Simplify the Xen domain is persistent driver method (Daniel P. Berrange),
  Simplify the Xen domain lookup driver methods (Daniel P. Berrange),
  Simplify the Xen domain create driver method (Daniel P. Berrange),
  Simplify the Xen count/list domains driver methods (Daniel P. Berrange),
  Simplify the Xen get max vcpus / node get info driver methods (Daniel P. Berrange),
  Simplify the Xen get version driver method (Daniel P. Berrange),
  Simplify the Xen get type driver method (Daniel P. Berrange),
  Simplify opening of Xen drivers (Daniel P. Berrange),
  Remove pointless GET_PRIVATE macro from Xen driver (Daniel P. Berrange),
  Remove VIR_CONNECT_RO checks from xen drivers (Daniel P. Berrange),
  Remove xen driver checks for priv->handle < 0 (Daniel P. Berrange),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/vmx/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/vmware/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/uml/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/secret/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/phyp/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/parallels/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/nwfilter/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/interface/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/node_device/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/network/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/lxc/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/locking/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/libxl/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/hyperv/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/esx/* (Michal Privoznik),
  Adapt to VIR_STRDUP and VIR_STRNDUP in src/cpu/* (Michal Privoznik),
  Delete udevFreeIfaceDef function in udev interface driver (Daniel P. Berrange),
  maint: update to latest gnulib (Eric Blake),
  Unmerge attach/update/modify device APIs in drivers (Daniel P. Berrange),
  Pull parsing of migration xml up into QEMU driver APIs (Daniel P. Berrange),
  Fix naming of some node device APIs (Daniel P. Berrange),
  Separate internal node suspend APIs from public API (Daniel P. Berrange),
  Separate internal node device APIs from public API (Daniel P. Berrange),
  Separate virGetHostname() API contract from driver APIs (Daniel P. Berrange),
  Include process start time when doing polkit checks (Daniel P. Berrange),
  Rename "security context" to "selinux context" (Daniel P. Berrange),
  Fix possible undefined value in check-symsorting.pl (Daniel P. Berrange),
  storage: Skip inactive lv volumes (Osier Yang),
  string: make VIR_STRDUP easier to use (Eric Blake),
  alloc: make VIR_APPEND_ELEMENT safer (Eric Blake),
  syntax-check: forbid virBufferAsprintf with string literals (Ján Tomko),
  get rid of virBufferAsprintf where possible (Ján Tomko),
  qemu: allocate network connections sooner during domain startup (Laine Stump),
  Ensure stub todo.html.in file is HTML5 (Daniel P. Berrange),
  qemu: Enable the capability bit for -no-kvm-pit-reinjection on x86 only (Boris Fiuczynski),
  rpc: message related sizes enlarged (Daniel Hansel),
  qemu: Do fake auto-allocation of ports when generating native command (Peter Krempa),
  spec: proper soft static allocation of qemu uid (Eric Blake),
  build: always include libvirt_lxc.syms in tarball (Eric Blake),
  Adapt to VIR_STRDUP and VIR_STRNDUP in daemon/* (Michal Privoznik),
  virstring: Introduce VIR_STRDUP and VIR_STRNDUP (Michal Privoznik),
  Make detect_scsi_host_caps a function on all architectures (Guido Günther),
  More paranoid initialization of 'nparams' variable in dispatch code (Daniel P. Berrange),
  Fix format string handling in network driver (Daniel P. Berrange),
  esx: Reduce code duplication in generator (Matthias Bolte),
  build: avoid useless virAsprintf (Eric Blake),
  build: always include sanitytest in tarball (Eric Blake),
  util: fix compile errors caused by moving string functions (Laine Stump),
  virutil: Move string related functions to virstring.c (Michal Privoznik),
  qemu: Generate agent socket path if missing (Michal Privoznik),
  build: fix FreeBSD build (Eric Blake)
- Cleanups:
  Storage: Fix the indention of rbd test file (Osier Yang),
  qemu: Fix damaged whitespace (Peter Krempa),
  Properly indent function's opening bracket (Martin Kletzander),
  build: fix typo in earlier commit (Eric Blake),
  build: drop unused variable (Eric Blake),
  syntax-check: mandate space after mid-line semicolon (Eric Blake),
  syntax: prefer space after semicolon in for loop (Eric Blake),
  security_dac: Fix the coding style (Osier Yang),
  nwfilter: Change the comment style (Osier Yang),
  src/*.[ch]: Remove the whitespace before ";" (Osier Yang),
  src/locking: Remove the whitespace before ";" (Osier Yang),
  python: Remove the whitespace before ";" (Osier Yang),
  examples: Remove the whitespace before ';' (Osier Yang),
  src/lxc: Remove the whitespace before ";" (Osier Yang),
  src/remote: Remove the whitespace before ";" (Osier Yang),
  src/rpc: Remove the whitespace before ";" (Osier Yang),
  src/utils: Remove the whitespace before ";" (Osier Yang),
  tests/: Remove the whitespace before ";" (Osier Yang),
  daemon: Remove the whitespace before ";" (Osier Yang),
  tools: Remove the whitespace before ";" (Osier Yang),
  src/storage: Remove the whitespace before ';' (Osier Yang),
  src/security: Remove the whitespace before ';' (Osier Yang),
  src/xen: Remove the whitespace before ';' (Osier Yang),
  src/vmware: Remove the whitespace before ';' (Osier Yang),
  src/qemu: Remove the whitespace before ';' (Osier Yang),
  src/interface: Remove the whitespace before ';' (Osier Yang),
  src/parallels: Remove the whitespace before ';' (Osier Yang),
  src/uml: Remove the whitespace before ';' (Osier Yang),
  src/openvz: Remove the whitespace before ';' (Osier Yang),
  src/node_device: Remove the whitespace before ';' (Osier Yang),
  src/phyp: Remove the whitespace before ';' (Osier Yang),
  src/nwfilter: Remove the whitespace before ';' (Osier Yang),
  src/xenxs: Remove the whitespace before ';' (Osier Yang),
  src/vbox: Remove the whitespace before ';' (Osier Yang),
  src/test: Remove the whitespace before ';' (Osier Yang),
  src/conf: Remove the whitespace before ';' (Osier Yang),
  src/libxl: Remove the whitespace before ';' (Osier Yang),
  src/network: Remove the whitespace before ';' (Osier Yang),
  LXC: move the comments to the proper place (Gao feng),
  conf: Improve the coding style (Osier Yang),
  tests: Sort the EXTRA_DIST list (Osier Yang),
  libvirt.c: Fix the indention (Osier Yang),
  conf: Remove the unrelated comment (Osier Yang),
  build: clean up stray files found by 'make distcheck' (Eric Blake),
  Remove redundant () in expression (Daniel P. Berrange)

### 1.0.5: May 02 2013

- Features:
  Add NVRAM device (Li Zhang),
  Add XML config for resource partitions (Daniel P. Berrange),
  Add support for TPM (Stefan Berger),
  NPIV storage migration support (Osier Yang)
- Documentation:
  Fix closing tag in snapshot documentation (Christophe Fergeau),
  Fix typo in augeas comment (Martin Kletzander),
  Fix VIR_DOMAIN_EVENT_ID_PMSUSPEND capitalization in API doc (Christophe Fergeau),
  Improve /domainsnapshot/disks/disk@snapshot doc (Christophe Fergeau),
  fix memballoon examples (Ján Tomko),
  Clarify usage of SELinux baselabel (Peter Krempa),
  fix usage of 'onto' (Eric Blake),
  Update HACKING (Osier Yang),
  conf: fix comment about parsing graphics listen address (Ján Tomko),
  lib: Fix docs about return value of virDomainGetVcpusFlags() (Peter Krempa),
  virsh: Document that using incomplete XML files may have unexpected results (Peter Krempa),
  fix typo when using Kerberos principals (Eric Blake),
  use MiB/s instead of Mbps for migration speed (Ján Tomko),
  Add the missed <pre> tag (Osier Yang),
  virsh: Fix typo in docs (Peter Krempa),
  manual: Fix copy-paste errors (Martin Kletzander),
  manual: Add info about migrateuri in virsh manual (Martin Kletzander)
- Portability:
  S390: Do not generate a default USB controller (Viktor Mihajlovski),
  S390: Mention changed USB behavior (Viktor Mihajlovski),
  build: fix cygwin build in virnetdev (Eric Blake),
  portability: handle ifreq differences in virnetdev (Roman Bogorodskiy),
  qemu: fix build error with older platforms (Eric Blake),
  Fix compilation error in util/vircgroup.c (Stefan Berger),
  Conditionally compile storagevolxml2argvtest (Daniel P. Berrange),
  Fix signature of dummy virNetlinkCommand stub (Daniel P. Berrange),
  Add empty stub for virThreadCancel on Win32 (Daniel P. Berrange),
  Don't enable -fPIE on Win32 platforms (Daniel P. Berrange),
  spec: Require pod2man when running autoreconf (Jiri Denemark),
  Avoid cast alignment warnings in port allocator test (Daniel P. Berrange)
- Bug Fixes:
  pci: autolearn name of stub driver, remove from arglist (Laine Stump),
  ESX: Fix DISPATCH_FREE generation code to free all extended objects (Ata E Husain Bohra),
  qemu: fix failure to start with spice graphics and no tls (Laine Stump),
  Need to call virFreeError after virSaveLastError (John Ferlan),
  libvirt-guests: status: return non-zero when stopped (Ján Tomko),
  security driver: eliminate memory leaks in failure paths (Laine Stump),
  libxl: Fix double-dispose of libxl domain config (Jim Fehlig),
  virsh: fix incorrect argument errors for long options (Ján Tomko),
  network: Don't remove transient network if creating of config file fails (Peter Krempa),
  qemu: prevent invalid reads in qemuAssignDevicePCISlots (Ján Tomko),
  qemu: don't assign a PCI address to 'none' USB controller (Ján Tomko),
  fix segfault during virsh save in pv guest (Bamvor Jian Zhang),
  conf: reject controllers with duplicate indexes (Ján Tomko),
  fix typo introduced by 90430791 (Bamvor Jian Zhang),
  Fix usb master startport parsing (Martin Kletzander),
  qemu_conf: Don't discard strdup OOM error (Michal Privoznik),
  util: Error out if the numa nodeset is out of range (Osier Yang),
  selinux: Don't mask errors of virSecuritySELinuxGenNewContext (Peter Krempa),
  qemu: Fix the wrong expression (Osier Yang),
  audit: properly encode device path in cgroup audit (Eric Blake),
  network: bridge_driver: don't lose transient networks on daemon restart (Peter Krempa),
  qemu: fix default spice password setting (Ján Tomko),
  Fix build breaker with ATTRIBUTE_NONNULL defs (John Ferlan),
  Resolve valgrind error (John Ferlan),
  Do more complete initialization of libgcrypt (Daniel P. Berrange),
  qemu: Set correct migrate host in client_migrate_info (Michal Privoznik),
  qemu: fix crash in qemuOpen (Ján Tomko),
  conf: fix error for parallel port mismatch (Ján Tomko),
  conf: fix a memory leak when parsing nat port XML nodes (Guannan Ren),
  conf: Fix race between looking up a domain object and freeing it (Peter Krempa),
  Fix crash in virNetDevGetVirtualFunctions (Laine Stump),
  schemas: Move PortNumber and sourceinfoadapter to basictypes.rng (Han Cheng),
  virsh: Unregister the connection close notifier upon termination (Viktor Mihajlovski),
  libvirt: Increase connection reference count for callbacks (Viktor Mihajlovski),
  storage: Fix volume cloning for logical volume. (Atsushi Kumagai),
  security_manager: fix comparison (Guido Günther),
  qemu: fix memory leak on -machine usage error (Eric Blake),
  qemu-blockjob: Fix limit of bandwidth for block jobs to supported value (Peter Krempa),
  sec_manager: Refuse to start domain with unsupported seclabel (Michal Privoznik),
  qemu: Fix crash when updating media with shared device (Peter Krempa),
  virsh: Call virDomainFree in cmdDomFSTrim (Michal Privoznik),
  smartcard: spell ccid-card-emulated qemu property correctly (Eric Blake),
  Resolve valgrind failure (John Ferlan)
- Improvements:
  spec: collect all BuildRequires into one area (Eric Blake),
  Resolve valgrind error (John Ferlan),
  esx: Support virtualHW version 9 (Martin Kletzander),
  build: mark conditionally unused variables (Eric Blake),
  virsh: clarify vol-{down,up}load description (Ján Tomko),
  qemu: report an error if memballoon has wrong address type (Ján Tomko),
  qemu: assign addresses when converting xml to native (Ján Tomko),
  qemu: Error out if spice port autoallocation is requested, but disabled (Peter Krempa),
  qemu: put usb cgroup setup in common function (Laine Stump),
  qemu: add vfio devices to cgroup ACL when appropriate (Laine Stump),
  qemu: honor allowDiskFormatProbing when parsing command line (Ján Tomko),
  conf: add missing error on OOM (Ján Tomko),
  qemu: don't always reserve PCI addresses for implicit controllers (Ján Tomko),
  conf: remove extraneous _TYPE from driver backend enums (Laine Stump),
  network: support <driver name='vfio'/> in network definitions (Laine Stump),
  qemu: launch bridge helper from libvirtd (Paolo Bonzini),
  virnetdevtap: add virNetDevTapGetName (Paolo Bonzini),
  qemu: set qemu process' RLIMIT_MEMLOCK when VFIO is used (Laine Stump),
  qemu: use new virCommandSetMax(Processes|Files) (Laine Stump),
  util: new virCommandSetMax(MemLock|Processes|Files) (Laine Stump),
  Do proper escaping of cgroup resource partitions (Daniel P. Berrange),
  Ensure all cgroup partitions have a suffix of ".partition" (Daniel P. Berrange),
  Change VM cgroup suffix from '{lxc,qemu}.libvirt' to 'libvirt-{lxc,qemu}' (Daniel P. Berrange),
  test: Add JSON test for query-tpm-types (Stefan Berger),
  virsh: suppress aliases in group help (Eric Blake),
  security: update hostdev labelling functions for VFIO (Laine Stump),
  util: new function virPCIDeviceGetVFIOGroupDev (Laine Stump),
  virsh: use new virNodeDeviceDetachFlags (Laine Stump),
  xen: implement virNodeDeviceDetachFlags backend (Laine Stump),
  qemu: implement virNodeDeviceDetachFlags backend (Laine Stump),
  hypervisor api: implement RPC calls for virNodeDeviceDetachFlags (Laine Stump),
  hypervisor api: new virNodeDeviceDetachFlags (Laine Stump),
  qemu: bind/unbind stub driver according to config <driver name='x'/> (Laine Stump),
  pci: keep a stubDriver in each virPCIDevice (Laine Stump),
  qemu: use vfio-pci on commandline when appropriate (Laine Stump),
  conf: formatter/parser/RNG/docs for hostdev <driver name='kvm|vfio'/> (Laine Stump),
  conf: put hostdev pci address in a struct (Laine Stump),
  qemu: detect vfio-pci device and its bootindex parameter (Laine Stump),
  build: avoid unsafe functions in libgen.h (Eric Blake),
  qemu: auto-add pci-root to 'pc-i440*' machines too (Ján Tomko),
  qemu: auto-add bridges and allow using them (Ján Tomko),
  qemu: auto-add pci-root controller for pc machine types (Ján Tomko),
  qemu: build command line for pci-bridge device (liguang),
  conf: add PCI controllers (Ján Tomko),
  qemu: call post-parse callbacks when parsing command line too (Ján Tomko),
  qemu: Add command line builder and parser for NVRAM. (Li Zhang),
  qemuBuildCommandLine: Don't overwrite errors with NWFilter's one (Michal Privoznik),
  Introduce a sub-element <driver> for controller (Osier Yang),
  qemu: Don't require a block or file when looking for an alias (Wido den Hollander),
  Change the tag name "num_queues" into "queues" (Osier Yang),
  qemu: Improve handling of channels when generating SPICE command line (Peter Krempa),
  qemu: Do sensible auto allocation of SPICE port numbers (Peter Krempa),
  Make driver method names consistent with public APIs (Daniel P. Berrange),
  Dedicated name for sub-driver open/close methods (Daniel P. Berrange),
  Rename 'DeviceMonitor' to 'NodeDeviceDriver' (Daniel P. Berrange),
  Extend previous check to validate driver struct field names (Daniel P. Berrange),
  Ensure driver method names match public API names (Daniel P. Berrange),
  Make naming of remote procedures match API names exactly (Daniel P. Berrange),
  Cleanup command line options in gendispatch.pl (Daniel P. Berrange),
  qemu: Split out SPICE port allocation into a separate function (Peter Krempa),
  qemu: Use switch instead of ifs in qemuBuildGraphicsCommandLine (Peter Krempa),
  qemu: Split out code to generate VNC command line (Peter Krempa),
  qemu: Split out code to generate SPICE command line (Peter Krempa),
  qemu: Use -machine accel=tcg|kvm when available (Jiri Denemark),
  qemu: Move -enable-kvm and friends earlier in the command line (Jiri Denemark),
  Switch to a more extensible annotation system for RPC protocols (Daniel P. Berrange),
  qemu: Fix setting of memory tunables (Peter Krempa),
  logging: Make log regexp more compact (and readable) (Jiri Denemark),
  qemu: Ignore libvirt logs when reading QEMU error output (Jiri Denemark),
  qemu: Move QEMU log reading into a separate function (Jiri Denemark),
  update input ip processing (Gene Czarcinski),
  create virSocketAddrGetIpPrefix utility function (Gene Czarcinski),
  Replace more cases of /system with /machine (Daniel P. Berrange),
  Change default resource partition to /machine (Daniel P. Berrange),
  qemu: rename CheckSlot to SlotInUse (Ján Tomko),
  qemu: switch PCI address set from hash table to an array (Ján Tomko),
  conf: add model attribute to virDomainDefMaybeAddController (Ján Tomko),
  qemu: move PCI address check out of qemuPCIAddressAsString (Ján Tomko),
  qemu: QEMU_PCI constant consistency (Ján Tomko),
  qemu: print PCI address hexadecimally in errors (Ján Tomko),
  qemu: make qemuComparePCIDevice aware of multiple buses (Ján Tomko),
  conf: Reword error message to be more universal (Peter Krempa),
  cpu: Rename PowerPCUpdate and PowerPCDataFree functions (Jiri Denemark),
  cpu: Remove hardcoded list of PowerPC models (Jiri Denemark),
  cpu: Reimplement PowerPCDecode (Jiri Denemark),
  cpu: Reimplement PowerPCBaseline (Jiri Denemark),
  cpu: Fix loading PowerPC vendor from cpu_map.xml (Jiri Denemark),
  cpu: Fix PowerPCNodeData (Jiri Denemark),
  cpu: Make comparing PowerPC CPUs easier to read (Jiri Denemark),
  cpu: Introduce cpuModelIsAllowed internal API (Jiri Denemark),
  virsh-domain: Refactor cmdVcpucount and fix output on inactive domains (Peter Krempa),
  Set legacy USB option with default for ppc64. (Li Zhang),
  qemu_conf: add new configuration key bridge_helper (Paolo Bonzini),
  util: allow using virCommandAllowCap with setuid helpers (Paolo Bonzini),
  util: simplify virSetUIDGIDWithCaps (Paolo Bonzini),
  virsh-domain: Report errors on invalid --holdtime value for cmdSendKey (Peter Krempa),
  virsh-domain: Clean up cmdSendKey (Peter Krempa),
  qemu: simplify use of virArchFromHost (Tal Kain),
  rng: tighten up domain <controller> schema (Laine Stump),
  network: remove autostart flag from network when undefining it (Peter Krempa),
  syntax-check: Only allows to include public headers in external tools (Osier Yang),
  syntax-check: Don't include public headers in internal source (Osier Yang),
  syntax-check: Don't include duplicate header (Osier Yang),
  qemu: Allow the disk wwn to have "0x" prefix (Osier Yang),
  cleanup: Don't include libvirt/virterror.h (Osier Yang),
  cleanup: Don't include libvirt/libvirt.h (Osier Yang),
  cleanup: Remove the duplicate header (Osier Yang),
  cleanup: Only include testutils.h once (Osier Yang),
  Check for unsupported QMP command (Stefan Berger),
  qemu_agent: Add support for appending arrays to commands (Peter Krempa),
  Add support for perf_event and net_cls cgroup controllers (Daniel P. Berrange),
  Replace LXC cgroup mount code with call to virCgroupIsolateMount (Daniel P. Berrange),
  Add an API for re-mounting cgroups, to isolate the process location (Daniel P. Berrange),
  Track symlinks for co-mounted cgroup controllers (Daniel P. Berrange),
  Remove non-functional code for setting up non-root cgroups (Daniel P. Berrange),
  Change default cgroup layout for QEMU/LXC and honour XML config (Daniel P. Berrange),
  Add a new virCgroupNewPartition for setting up resource partitions (Daniel P. Berrange),
  Cleanup if creating cgroup directories fails (Daniel P. Berrange),
  Add misc extra debugging into cgroups code (Daniel P. Berrange),
  Refactor cgroups internal data structures (Daniel P. Berrange),
  Add a test suite for cgroups functionality (Daniel P. Berrange),
  Rename virCgroupForXXX to virCgroupNewXXX (Daniel P. Berrange),
  Pull definition of structs out of vircgroup.c to vircgrouppriv.h (Daniel P. Berrange),
  Store a virCgroupPtr instance in virLXCDomainObjPrivatePtr (Daniel P. Berrange),
  Store a virCgroupPtr instance in qemuDomainObjPrivatePtr (Daniel P. Berrange),
  Add missing param to virCgroupForDriver stub (Daniel P. Berrange),
  Introduce a virFileDeleteTree method (Daniel P. Berrange),
  Conditionalize use of symlink() function in test suite (Daniel P. Berrange),
  maint: update to latest gnulib (Eric Blake),
  Use unsigned int instead of unsigned (Osier Yang),
  qemu: Report also domain name in error message when domain object wasn't found (Peter Krempa),
  qemu: Refactor lookup of domain object (Peter Krempa),
  cleanup: Change datatype of net->stp to boolean (Osier Yang),
  cleanup: Change datatype of usbdev->allow to boolean (Osier Yang),
  cleanup: Change datatype of graphic's members to boolean (Osier Yang),
  cleanup: Change datatype of accel's members to boolean (Osier Yang),
  Add test case for TPM passthrough (Stefan Berger),
  TPM support for QEMU command line (Stefan Berger),
  QEMU Cgroup support for TPM passthrough (Stefan Berger),
  Audit the starting of a guest using TPM passthrough (Stefan Berger),
  Add SELinux and DAC labeling support for TPM passthrough (Stefan Berger),
  Convert QMP strings into QEMU capability bits (Stefan Berger),
  Parse TPM passthrough XML in the domain XML (Stefan Berger),
  Helper functions for host TPM support (Stefan Berger),
  Add documentation and schema for TPM passthrough (Stefan Berger),
  Add function to find a needle in a string array (Stefan Berger),
  Add QMP probing for TPM (Stefan Berger),
  conf: Allow for non-contiguous device boot orders (Peter Krempa),
  Tweak EOF handling of streams (Daniel P. Berrange),
  Add USB option capability (Li Zhang),
  Add error handling to optional arguments in cmdCPUStats (John Ferlan),
  qemu: Do not report unsafe migration for local files (Jiri Denemark),
  qemu: Try to use QMP for send-key if supported (Peter Krempa),
  virsh: Update list of shutdown/reboot modes (Michal Privoznik),
  cleanup: Change datatype of secret->private to boolean (Osier Yang),
  cleanup: Change datatype of secret->ephemeral to boolean (Osier Yang),
  cleanup: Change datatype of fs->readonly to boolean (Osier Yang),
  cleanup: Change datatype of disk->readonly to boolean (Osier Yang),
  cleanup: Change datatype of disk->transient to boolean (Osier Yang),
  cleanup: Change datatype of disk->shared to boolean (Osier Yang),
  cleanup: Change datatype of auth->expires to boolean (Osier Yang),
  cleanup: Change datatype of hostdev->missing to boolean (Osier Yang),
  Cleanup: Change datatype of origstate's members to boolean (Osier Yang),
  Cleanup: Change datatype of hostdev->managed to boolean (Osier Yang),
  conf: Change help function (Han Cheng),
  qemu: Remove now obsolete assignment of default network card model for s390 hosts (Peter Krempa),
  qemu: Clean up network device CLI generator (Peter Krempa),
  qemu: Use correct default model on s390 (Viktor Mihajlovski),
  sanlock: add missing test command in virt-sanlock-cleanup.in (Alex Jia),
  Generate RFC4122 compliant UUIDs (Milos Vyletel),
  Unmount existing filesystems under user specified mounts in LXC (Daniel P. Berrange),
  Move lxcContainerUnmountSubtree further up in file (Daniel P. Berrange),
  Implement support for <hostdev caps=net> (Bogdan Purcareata),
  Update structure & XML definitions to support <hostdev caps=net> (Bogdan Purcareata),
  Rename virCgroupMounted to virCgroupHasController & make it more robust (Daniel P. Berrange),
  qemu: Allow volume type disk for device 'lun' (Osier Yang),
  qemu: Support sgio setting for volume type disk (Osier Yang),
  qemu: Support shareable volume type disk (Osier Yang),
  qemu: Translate the pool disk source earlier (Osier Yang),
  Support seclabels for volume type disk (Osier Yang),
  Support startupPolicy for 'volume' disk (Osier Yang),
  qemu: Translate the pool disk source when building drive string (Osier Yang),
  Introduce new XMLs to specify disk source using libvirt storage (Osier Yang),
  conf: New helper virDomainDiskSourceDefFormat to format the disk source (Osier Yang),
  storage: Guess the parent if it's not specified for vHBA (Osier Yang),
  storage: Add startPool and stopPool for scsi backend (Osier Yang),
  util: Add helper to get the scsi host name by iterating over sysfs (Osier Yang),
  phyp: Prohibit fc_host adapter for phyp driver (Osier Yang),
  storage: Move virStorageBackendSCSIGetHostNumber into iscsi backend (Osier Yang),
  storage: Make the adapter name be consistent with node device driver (Osier Yang),
  New XML attributes for storage pool source adapter (Osier Yang),
  Disable cast-align warnings in various places (Daniel P. Berrange),
  Copy struct inotify_event entries to avoid alignment problems (Daniel P. Berrange),
  Use VIR_ALLOC_VAR instead of VIR_ALLOC_N for creating virObject (Daniel P. Berrange),
  Avoid casts between unsigned char * and struct nlmsghdr (Daniel P. Berrange),
  Rewrite keycode map to avoid a struct (Daniel P. Berrange),
  Add a test suite for keycode mapping functions (Daniel P. Berrange),
  qemu: Error out if the bitmap for pinning is all clear (Osier Yang),
  util: Add a helper to check if all bits of a bitmap are clear (Osier Yang),
  qemu: Support multiple queue virtio-scsi (Osier Yang),
  build: check correct protocol.o file (Eric Blake),
  build: use proper pod for nested bulleted VIRSH_DEBUG list (Eric Blake),
  qemu: Remove maximum cpu limit when setting processor count using the API (Peter Krempa),
  Don't create dirs in cgroup controllers we don't want to use (Daniel P. Berrange),
  Rename virCgroupGetAppRoot to virCgroupForSelf (Daniel P. Berrange),
  Ensure LD_PRELOAD exists before running test case (Daniel P. Berrange),
  Refactor RNG schema for resource tuning (Daniel P. Berrange),
  rpc: Fix connection close callback race condition and memory corruption/crash (Peter Krempa),
  virsh: Register and unregister the close callback also in cmdConnect (Peter Krempa),
  virsh: Move cmdConnect from virsh-host.c to virsh.c (Peter Krempa),
  virCaps: get rid of defaultConsoleTargetType callback (Peter Krempa),
  virCaps: get rid of macPrefix field (Peter Krempa),
  virCaps: get rid of hasWideScsiBus (Peter Krempa),
  virCaps: get rid of defaultDiskDriverType (Peter Krempa),
  virCaps: get rid of emulatorRequired (Peter Krempa),
  virCaps: get rid of defaultDiskDriverName (Peter Krempa),
  virCaps: get rid of "defaultInitPath" value in the virCaps struct (Peter Krempa),
  qemu: Record the default NIC model in the domain XML (Peter Krempa),
  conf callback: Rearrange function parameters (Peter Krempa),
  conf: Add post XML parse callbacks and prepare for cleaning of virCaps (Peter Krempa),
  maint: Rename xmlconf to xmlopt and virDomainXMLConfig to virDomainXMLOption (Peter Krempa),
  Create fake NUMA info if libnuma isn't available (Daniel P. Berrange),
  Cope with missing /sys/devices/system/cpu/cpu0/topology files (Daniel P. Berrange),
  Add armv6l architecture to list of valid arches (Daniel P. Berrange),
  Implement minimal sysinfo for ARM platforms (Daniel P. Berrange),
  Disable of unused sysinfotest functions (Daniel P. Berrange),
  Wire up sysinfo for LXC driver (Daniel P. Berrange),
  Add support for SD cards in nodedev driver (Daniel P. Berrange),
  Auto-add a root <filesystem> element to LXC containers on startup (Daniel P. Berrange),
  Remove support for old kernels lacking private devpts (Daniel P. Berrange),
  Enable full RELRO mode (Daniel P. Berrange),
  Build all binaries with PIE (Daniel P. Berrange),
  rng: Add definition for network disk source (Osier Yang),
  Disable static libraries by default (Daniel P. Berrange),
  Allow multiple parameters for schedinfo (Martin Kletzander),
  virsh-domain: Add --live, --config, --current logic to cmdDetachDisk (Peter Krempa),
  virsh-domain: Add --live, --config, --current logic to cmdDetachDevice (Peter Krempa),
  virsh-domain: Add --live, --config, --current logic to cmdDetachInterface (Peter Krempa),
  virsh: Fix semantics of --config for "update-device" command (Peter Krempa),
  virsh-domain: Fix declarations of flag variables in cmdChangeMedia (Peter Krempa),
  virsh-domain: Simplify usage of --current, --live and --config flags (Peter Krempa),
  virsh-domain-monitor: Refactor cmdDomIfGetLink (Peter Krempa),
  Use virMacAddrFormat instead of manual mac address formatting (Peter Krempa),
  util: Change virMacAddrFormat to lowercase hex characters (Peter Krempa),
  Optimize machine option to set more options with it (Li Zhang),
  conf: Enforce ranges on cputune variables (Peter Krempa),
  test: Return Libvirt logo as domain screenshot (Michal Privoznik),
  qemu: Allow migration over IPv6 (Ján Tomko),
  virsh: Add a helper to parse cpulist (Osier Yang)
- Cleanups:
  qemu_command.c: Fix whitespacing within for() (Michal Privoznik),
  qemu: Fix the indention (Osier Yang),
  Sanitize whitespace in driver.h (Daniel P. Berrange),
  sheepdog: Omit braces with a single-line body (Harry Wei),
  storage: Fix the indention (Osier Yang),
  Remove extraneous comma in info_cpu_stats and opts_cpu_stats (John Ferlan)

### 1.0.4: Apr 01 2013

- Features:
  qemu: support passthrough for iscsi disks (Paolo Bonzini),
  various S390 improvements (Viktor Mihajlovski),
  various LXC bugs fixes and improvements (Daniel P. Berrange, Gao feng),
  Add API for thread cancellation (Daniel P. Berrange)
- Documentation:
  Fix truncated sentence in RDP 'multiUser' attribute (Christophe Fergeau),
  Remove the redundant parentheses in migrate help (Yanbing Du),
  virsh: Fix docs for "virsh setmaxmem" (Peter Krempa),
  util: fix virAllocVar's comment (Ján Tomko),
  clarify virsh net commands (Gene Czarcinski),
  storage: Fix grammar (Philipp Hahn),
  Fix /pool/storage/name documentation (Christophe Fergeau),
  Fix /pool/storage/directory@path documentation (Christophe Fergeau),
  Fix snapshot-create-as syntax in help output (Martin Kletzander),
  Update to COPYING.LIB to latest LGPLv2.1 copy (Christophe Fergeau),
  Fix a copy & paste error for virsh dump help (Yanbing Du),
  Clarify semantics of sparse storage volumes (Jiri Denemark)
- Portability:
  virutil: Fix compilation on non-linux platforms (Michal Privoznik),
  Fix linkage of virt-aa-helper with numa library (Daniel P. Berrange),
  Don't fail if SELinux is diabled (Guido Günther),
  Fix --without-libvirtd builds (Doug Goldstein),
  lxc: include sys/stat.h (Guido Günther),
  Ensure GET_VLAN_VID_CMD is always defined (Daniel P. Berrange),
  Don't import loop.h unless HAVE_DECL_LO_FLAGS_AUTOCLEAR is defined (Daniel P. Berrange)
- Bug Fixes:
  virsh: don't call virSecretFree on NULL (Ján Tomko),
  storage: Avoid double virCommandFree in virStorageBackendLogicalDeletePool (Martin Kletzander),
  nodedev: invert virIsCapableFCHost return value (Ján Tomko),
  security_manager.c: Append seclabel iff generated (Michal Privoznik),
  security: Don't add seclabel of type none if there's already a seclabel (Michal Privoznik),
  security_manager: Don't manipulate domain XML in virDomainDefGetSecurityLabelDef (Michal Privoznik),
  conf: fix memory leak of class_id bitmap (Guannan Ren),
  uml:release config object when uml driver shutdown (Guannan Ren),
  qemu:release qemu config object when qemu driver shutdown (Guannan Ren),
  net: use newer iptables syntax (Stefan Seyfried),
  remote: Don't call NULL closeFreeCallback (Viktor Mihajlovski),
  rpc: Fix client crash when server drops connection (Jiri Denemark),
  conf: fix a failure when detaching a usb device (Guannan Ren),
  qemu: Don't set address type too early during virtio disk hotplug (Guido Günther),
  virsh: error out on non-numeric timeout values (Ján Tomko),
  qemu: Set migration FD blocking (Michal Privoznik),
  util: Fix bug of managing vport (Osier Yang),
  nodedev: Fix the improper logic when enumerating SRIOV VF (Osier Yang),
  lxc: Prevent shutting down the host (Martin Kletzander),
  Ensure root filesystem is mounted if a file/block mount. (Daniel P. Berrange),
  Fix thread safety in LXC callback handling (Daniel P. Berrange),
  Remove bogus filtering from virDomainGetRootFilesystem (Daniel P. Berrange),
  Fix parsing of bond interface XML (Jim Fehlig),
  virsh: don't print --(null) in vol-name and vol-pool (Ján Tomko),
  Fix free of uninitialized value in LXC numad setup (Daniel P. Berrange),
  Correct invalid RNG schemas (Martin Kletzander),
  python: Fix emulatorpin API bindings (Peter Krempa),
  qemu: Un-mark volume as mirrored/copied if blockjob copy fails (Peter Krempa),
  Fix initialization of virIdentityPtr thread locals (Daniel P. Berrange),
  qemu: Add the new disk src into shared disk table when updating disk (Osier Yang),
  python: fix bindings that don't raise an exception (Guannan Ren),
  Fix typos s/HAVE_SELINUX/WITH_SELINUX/ (Daniel P. Berrange),
  fix TLS error with virNetServerClientCreateIdentity (Olivia Yin),
  storage: fix unlikely memory leak in rbd backend (Laine Stump),
  Do not prematurely close loop devices in LXC controller (Daniel P. Berrange),
  qemu: Fix startupPolicy regression (Jiri Denemark),
  qemu: do not support non-network disks without -drive (Paolo Bonzini),
  Fix size probing for VDI images (Ján Tomko),
  Fix memory leak on OOM in virSecuritySELinuxMCSFind (Daniel P. Berrange),
  Avoid closing uninitialized FDs when LXC startup fails (Daniel P. Berrange),
  Prevent streams from becoming libvirtd controlling TTY (Daniel P. Berrange),
  util: escapes special characters in VIR_LOG_REGEX (Guannan Ren),
  Daemonize fuse thread in libvirt_lxc (Daniel P. Berrange),
  Fix missing error dispatch in virDomainLxcEnterNamespace (Daniel P. Berrange),
  Fix query of LXC security label (Daniel P. Berrange),
  qemu_driver: Try KVM_CAP_MAX_VCPUS only if defined (Michal Privoznik),
  Add missing break in LXC loop device setup (Daniel P. Berrange),
  qemu: Avoid NULL dereference in qemuSharedDiskEntryFree (Jiri Denemark),
  qemu: Fix retrieval of maximum number of vCPUs on KVM hosts (Peter Krempa),
  virsh: fix snapshot-create with no xmlfile (Ján Tomko),
  lxc: Init activeUsbHostdevs (Guido Günther),
  bandwidth: Require network QoS if interface uses 'floor' (Michal Privoznik),
  qemuDomainBlockStatsFlags: Guard disk lookup with a domain job (Michal Privoznik),
  Fix crash parsing RNG device specification (Daniel P. Berrange),
  Resolve valgrind error (John Ferlan),
  storage: Cleanup logical volume creation code (Jiri Denemark),
  qemu: update domain live xml for virsh memtune with --live flag (Guannan Ren),
  util: fix a integer boundary error (Guannan Ren)
- Improvements:
  util: Fix the conflict type for virIsCapableFCHost (Osier Yang),
  libvirt_private.syms: Correctly export seclabel APIs (Michal Privoznik),
  log: Separate thread ID from timestemp in ring buffer (Jiri Denemark),
  virsh: Correct DESCRIPTION for virsh help blockcopy (Yanbing Du),
  Fix virConnectOpen.*() name requirements (Martin Kletzander),
  virsh: Let the compiler check usage of all fields in vshCmdOptType enum (Peter Krempa),
  python: set default value to optional arguments (Guannan Ren),
  libvirt-guests: newline between output sentences (Eric Blake),
  nodedev: Abstract nodeDeviceVportCreateDelete as util function (Osier Yang),
  nodedev: Dump max vports and vports in use for HBA's XML (Osier Yang),
  nodedev: Refactor the helpers (Osier Yang),
  nodedev: Use access instead of stat (Osier Yang),
  util: Add one helper virReadFCHost to read the value of fc_host entry (Osier Yang),
  nodedev: Introduce two new flags for listAll API (Osier Yang),
  nodedev: Remove the unused enum (Osier Yang),
  Mount temporary devpts on /var/lib/libvirt/lxc/$NAME.devpts (Daniel P. Berrange),
  Move FUSE mount to /var/lib/libvirt/lxc/$NAME.fuse (Daniel P. Berrange),
  viralloc: Export virAllocTest* (Michal Privoznik),
  qemu: add support for LSI MegaRAID SAS1078 (aka megasas) SCSI controller (Paolo Bonzini),
  qemu: pass iscsi authorization credentials (Paolo Bonzini),
  domain: parse XML for iscsi authorization credentials (Paolo Bonzini),
  secret: add iscsi to possible usage types (Paolo Bonzini),
  domain: make port optional for network disks (Paolo Bonzini),
  qemu: add support for libiscsi (Paolo Bonzini),
  make: regenerate bindings when <classname>.py changes (Guannan Ren),
  python: treat flags as default argument with value 0 (Guannan Ren),
  virsh-snapshot: Simplify cleanup path in cmdSnapshotEdit (Peter Krempa),
  virsh-snapshot: Use the mutually exclusive params macro in cmdSnapshotEdit (Peter Krempa),
  virsh-snapshot: Refactor cmdSnapshotCurrent (Peter Krempa),
  virsh-domain: Fix flag name in error message to match the check (Peter Krempa),
  virsh-host: Refactor cmdFreecell (Peter Krempa),
  virsh-snapshot: Refactor virsh snapshot-list (Peter Krempa),
  virsh: Introduce macros to reject mutually exclusive arguments (Peter Krempa),
  qemu: s/VIR_ERR_NO_SUPPORT/VIR_ERR_OPERATION_UNSUPPORTED (Michal Privoznik),
  domain: add support for iscsi network disks (Paolo Bonzini),
  cgroup: export virCgroupRemoveRecursively (Gao feng),
  doc/schema: disk storage volume formats (Philipp Hahn),
  doc/schema: Support iqn for storage pools (Philipp Hahn),
  doc/schema: add ocfs2 for disk vol (Philipp Hahn),
  LXC: add cpuset cgroup support for lxc (Gao feng),
  NUMA: cleanup for numa related codes (Gao feng),
  LXC: allow uses advisory nodeset from querying numad (Gao feng),
  rename qemuGetNumadAdvice to virNumaGetAutoPlacementAdvice (Gao feng),
  selinux: deal with dtb file (Olivia Yin),
  qemu: add dtb option support (Olivia Yin),
  conf: support <dtb> tag in XML domain file (Olivia Yin),
  rename tests/conftest.c (Gene Czarcinski),
  Setup LXC cgroups in two phases (Daniel P. Berrange),
  Set the current client identity during API call dispatch (Daniel P. Berrange),
  Add ability to get a virIdentity from a virNetServerClientPtr (Daniel P. Berrange),
  internal APIs for managing identities (Daniel P. Berrange),
  Add API to get the system identity (Daniel P. Berrange),
  Add APIs for associating a virIdentityPtr with the current thread (Daniel P. Berrange),
  Define internal APIs for managing identities (Daniel P. Berrange),
  Add APIs to get at more client security data (Daniel P. Berrange),
  qemu: support URI syntax for NBD (Paolo Bonzini),
  qemu: support NBD with Unix sockets (Paolo Bonzini),
  qemu: support named nbd exports (Paolo Bonzini),
  qemu: rewrite NBD command-line builder and parser (Paolo Bonzini),
  qemu: test NBD command-line builder and parser (Paolo Bonzini),
  util: portably check for unchanged uid (Eric Blake),
  Make vshDebug work when parsing parameters (Martin Kletzander),
  Remove contiguous CPU indexes assumption (Li Zhang),
  audit: Audit resources used by VirtIO RNG (Peter Krempa),
  S390: Testcases for virtio-scsi and virtio-rng (Viktor Mihajlovski),
  S390: Enable virtio-scsi and virtio-rng (Viktor Mihajlovski),
  qemu: Rename virtio-scsi capability (Viktor Mihajlovski),
  util: fix clear_emulator_capabilities=0 (Laine Stump),
  Fix deps for generating RPC dispatch code (Daniel P. Berrange),
  Fix generation of systemtap probes for RPC protocols (Daniel P. Berrange),
  Re-add DTrace probes on 'dispose' functions (Daniel P. Berrange),
  Fix parsing of SELinux ranges without a category (Daniel P. Berrange),
  Separate MCS range parsing from MCS range checking (Daniel P. Berrange),
  virtio-rng: Add rate limiting options for virtio-RNG (Peter Krempa),
  S390: Testcases for virtio-ccw machines (Viktor Mihajlovski),
  S390: Add hotplug support for s390 virtio devices (J.B. Joret),
  S390: QEMU driver support for CCW addresses (Viktor Mihajlovski),
  S390: domain_conf support for CCW (Viktor Mihajlovski),
  S390: Documentation for CCW address type (Viktor Mihajlovski),
  Use separate symbol file for GNUTLS symbols (Daniel P. Berrange),
  Apply security label when entering LXC namespaces (Daniel P. Berrange),
  virCaps: conf: start splitting out irrelevant data (Peter Krempa),
  Remove hack using existence of an 'identity' string to disable auth (Daniel P. Berrange),
  Convert HAVE_SELINUX to WITH_SELINUX (Guido Günther),
  capabilities: add NUMA memory information (Dusty Mabe),
  apparmor: use AppArmorSetFDLabel for both imageFD and tapFD (Guannan Ren),
  Include pid namespace inode in LXC audit messages (Daniel P. Berrange),
  Add support for disks backed by plain files in LXC (Daniel P. Berrange),
  Refactor loop device setup code in LXC (Daniel P. Berrange),
  Convert QEMU driver to use virLogProbablyLogMessage (Daniel P. Berrange),
  Improve LXC startup error reporting (Daniel P. Berrange),
  Add method for checking if a string is (probably) a log message (Daniel P. Berrange),
  Use VIR_MASS_CLOSE in LXC container startup (Daniel P. Berrange),
  Fix conditional build of virNetDevSetupControlFull (Daniel P. Berrange),
  Rename 'daemon' param to 'binary' in virNetClientNewUNIX (Daniel P. Berrange),
  Rename 'clone' to 'clonevol' to avoid name clash with clone() syscall (Daniel P. Berrange),
  viralloc: use consistent naming (Eric Blake),
  rng: allow default device in RNG grammar (Eric Blake),
  build: avoid shadowing a function name (Eric Blake),
  conf: Report errors on cputune parameter parsing (Peter Krempa),
  conf: Make virDomainDeviceInfoIterate usable without os type (Peter Krempa),
  virsh-snapshot: Add ability to print only snapshot names (Peter Krempa)
- Cleanups:
  python:remove semicolon in python code (Guannan Ren),
  Clean redundant code about VCPU string checking (Li Zhang),
  Cleanup useless flags specifications (Martin Kletzander),
  nodeinfo: don't define nodeGetCellMemory if it isn't ever used (Hu Tao),
  virsh-domain: Remove unused vshCompleteXMLFromDomain (Peter Krempa),
  sheepdog: Adjust logic to break while loop to avoid Coverity error (John Ferlan),
  libxl_driver: Resolve Coverity errors (John Ferlan),
  libxl_conf: Resolve Coverity issue with call to regcomp() (John Ferlan),
  conf: whitespace cleanups and refactors with no semantic impact (Peter Krempa)

### 1.0.3: Mar 05 2013

- Features:
  Introduce virDomainMigrate*CompressionCache APIs (Jiri Denemark),
  Introduce virDomainGetJobStats API (Jiri Denemark),
  Add basic support for VDI images (Martin Kletzander),
  Introduce API virNodeDeviceLookupSCSIHostByWWN (Osier Yang),
  Various locking improvements (Daniel P. Berrange)
- Documentation:
  internals: Update to include RPC and Lock links and add new data (John Ferlan),
  Add references for phyp and parallels (John Ferlan),
  api: Add text and references for daemon (John Ferlan),
  api: Add text and references for drivers section (John Ferlan),
  api: Complete list of function and naming conventions (John Ferlan),
  api: Reword and clean lists for object description (John Ferlan),
  api: Reword objects exposed section (John Ferlan),
  hellolibvirt: Adjust code to use new APIs (John Ferlan),
  libvirt: Update headers for doc (John Ferlan),
  hook: log the exit status of the hook not 256 (Guido Günther),
  maint: fix typo in network docs (Eric Blake),
  util: Add docs for virXMLProp string (Peter Krempa),
  Fix attribute name for virtio-rng backend (Peter Krempa),
  document new storage volume/pool types (Philipp Hahn),
  schema: Add basic documentation for the virtual RNG device support (Peter Krempa),
  util: fix typo in comment (Laine Stump),
  Add missing 'vram' in QXL video device doc (Christophe Fergeau),
  Fix HTML errors (Jiri Denemark),
  fix 1.0.2 release date (Eric Blake),
  HACKING: Sync with docs/hacking.html.in (John Ferlan),
  hacking: Add some details to handle Valgrind output (John Ferlan),
  don't ignore virEvent API (Eric Blake),
  use div, not table, for notices on opaque types (Claudio Bley),
  abort when missing return or argument documentation (Claudio Bley),
  libvirt.h.in: document virConnectDomainEventCallback's return value (Claudio Bley),
  libvirt.h.in: add missing return doc for virEventRemoveHandleFunc (Claudio Bley),
  libvirt.h.in: fix documentation for virConnectDomainEventBlockJobCallback (Claudio Bley),
  libvirt.h.in: add missing documentation for virConnectCloseFunc (Claudio Bley),
  Sync HACKING and hacking.html.in (Martin Kletzander)
- Portability:
  build: don't use gcrypt.h without gnutls support (Eric Blake),
  tests: skip virstoragetest on RHEL 5 (Eric Blake),
  Remove some C99 variable decls in parallels driver (Daniel P. Berrange),
  tests: old automake lacks abs_builddir (Eric Blake),
  tests: consistent skip messages (Eric Blake),
  tests: don't test json when not compiled in (Eric Blake),
  tests: avoid segfault if json monitor not present (Eric Blake),
  run: use portable shell (Eric Blake),
  s/arm/armv7l/ in caps-qemu-kvm.xml (Daniel P. Berrange),
  build: force correct gcc syntax for attribute_nonnull (Eric Blake),
  build: more mingw fixes (Eric Blake),
  build: fix mingw build (Eric Blake),
  build: fix vircommand build on mingw (Eric Blake),
  regex: gnulib guarantees that we have regex support (Eric Blake),
  build: fix compilation of selinux on RHEL 5 (Eric Blake),
  build: fix VPATH testsuite (Eric Blake),
  build: fix build of HAL node backend (Eric Blake),
  sanitytest.py: Do not rely on system libvirt (Jiri Denemark),
  tests: reserve more fds for commandtest (Eric Blake),
  build: Add libcurl dependency to libvirt_driver.la (Jiri Denemark),
  tests: Don't build securityselinuxlabeltest without qemu (Jiri Denemark)
- Bug Fixes:
  Fix TLS tests with gnutls 3 (Daniel P. Berrange),
  qemu: fix wrong evaluation in qemuDomainSetMemoryParameters (Satoru Moriya),
  libvirt does not logout of iscsi targets, causing system hang on shutdown (Fritz Elfert),
  qemu: Remove managed save flag from VM when starting with --force-boot (Peter Krempa),
  qemu: Use -1 as unpriviledged uid/gid (Christophe Fergeau),
  virnetdevmacvlan.c: Introduce mutex for macvlan creation (Michal Privoznik),
  Fix deadlock in QEMU close callback APIs (Daniel P. Berrange),
  Fix crash in QEMU auto-destroy with transient guests (Daniel P. Berrange),
  python: fix fd leak in generator.py (Guannan Ren),
  qemu: Make sure qemuProcessStart is run within a job (Jiri Denemark),
  Fix starting qemu instances when apparmor driver is enabled (Jim Fehlig),
  qemu: Don't fail to shutdown domains with unresponsive agent (Michal Privoznik),
  qemu: virConnectGetVersion returns bogus value (Viktor Mihajlovski),
  qemu: fix use-after-free when parsing NBD disk (Paolo Bonzini),
  Don't try to add non-existent devices to ACL (Daniel P. Berrange),
  Fix typo in internal VIR_QEMU_PROCESS_START_AUTODESROY constant (Daniel P. Berrange),
  Fix autodestroy of QEMU guests (Daniel P. Berrange),
  qemu: -numa doesn't (yet) support disjoint range (Eric Blake),
  interface: udev backend coverity NULL deref (Doug Goldstein),
  Fix crash changing CDROM media (Daniel P. Berrange),
  qemu: do not set unpriv_sgio if neither supported nor requested (Paolo Bonzini),
  conf: Avoid leaking of RNG device definition (Peter Krempa),
  interface: Fix udev backend bridge device display (Doug Goldstein),
  storage: use f_frsize, not f_bsize, for calculating available space (Sage Weil),
  conf: Don't leak 'ram' video property on error (Christophe Fergeau),
  conf: Don't leak 'primary' video property on error (Christophe Fergeau),
  qemu: check backing chains even when cgroup is omitted (Eric Blake),
  qemu: Avoid deadlock in autodestroy (Jiri Denemark),
  qemu: fix an off-by-one error in qemuDomainGetPercpuStats (Guannan Ren),
  qemu: Fix the memory leak (Osier Yang),
  keepalive: Guard against integer overflow (John Ferlan),
  libxl: Fix setting of disk backend (Jim Fehlig),
  Remove a couple of misplaced VIR_FREE (John Ferlan),
  Fix memory leak in virNetClientIOWriteMessage (Sergey Fionov),
  qemu: Do not ignore mandatory features in migration cookie (Jiri Denemark),
  rpc: Avoid deadlock when closing client connection (Jiri Denemark),
  Avoid resetting errors in virTypedParamsFree (Jiri Denemark),
  interface: fix udev backend use after free (Doug Goldstein),
  virsh: Resolve possible NULL dereference (John Ferlan),
  commandtest: Resolve some coverity resource leaks (John Ferlan),
  Fix libvirt upgrade path when nwfilter is used (Stefan Berger),
  util: maintain caps when running command with uid != 0 (Laine Stump),
  virCommand: Don't misuse the eventloop for async IO (Michal Privoznik),
  Release VM lock before acquiring virDomainObjListPtr lock (Daniel P. Berrange),
  Fix potential deadlock across fork() in QEMU driver (Daniel P. Berrange),
  hypervisor: Restore pm initialization (John Ferlan),
  Remove re-entrant API call in SELinux/AppArmor security managers (Daniel P. Berrange),
  xend: Fix a memory leak found by Coverity (John Ferlan),
  network_conf.c: Free xmlDoc after use (Michal Privoznik),
  virsh-snapshot: Fix XPath query to determine snapshot state (Peter Krempa),
  virnetttlcontext: Resolve issues found by Valgrind (John Ferlan),
  qemumonitortestutils: Resolve resource leaks found by Valgrind (John Ferlan),
  qemumonitorjsontest: Resolve resource leaks found by Valgrind (John Ferlan),
  qemu_command: Resolve resource leaks found by Valgrind (John Ferlan),
  domain_conf: Resolve resource leaks found by Valgrind (John Ferlan),
  vport_profile_conf: Resolve memory leak found by Valgrind (John Ferlan),
  netdev_vlan_conf: Resolve memory leak found by Valgrind. (John Ferlan),
  qemuxml2argvtest: Resolve resource leaks found by Valgrind (John Ferlan),
  virnettlscontexttest: Resolve memory leak found by Valgrind (John Ferlan),
  qemu_hotplug: Need to call virUSBDeviceFree() (John Ferlan),
  rpc: Need to virCommandFree on error path (John Ferlan),
  uml: Resolve leak if need to requery in umlIdentifyOneChrPTY() (John Ferlan),
  openvz: Need to error check openvzDomainSetVcpusFlagsInternal() (John Ferlan),
  parallels: Need to free memory on error path (John Ferlan),
  network: Remove conditional settings to resolve resource leak (John Ferlan),
  storage: Resolve resource leaks with cmd processing (John Ferlan),
  keepalive: Resolve Coverity complaint (John Ferlan),
  tlscontext: Make sure to get proper pointer to 'dname' (John Ferlan),
  Fix leak of usbDevice struct when initializing cgroups (Daniel P. Berrange),
  Fix typo in configure.ac causing $LIBS to gain a copy of $CFLAGS (Daniel P. Berrange),
  util: Fix mask for 172.16.0.0 private address range (Jiri Denemark)
- Improvements:
  rng: restrict passthrough names to known-good files (Eric Blake),
  util: use string libvirt to prefix error message instead of libvir (Guannan Ren),
  python: fix typoes and repeated global vars references (Guannan Ren),
  Fix a message typo (Serge Hallyn),
  Avoid spamming logs with cgroups warnings (Daniel P. Berrange),
  tests: Test XML entities in source path for RNG device (Peter Krempa),
  tests: fix leaks in storagevolxml2argvtest (Ján Tomko),
  libvirt.c: Make VIR_MIGRATE_NON_SHARED_{INC,DISK} mutually exclusive (Michal Privoznik),
  schema: Restrict mode to octal (Philipp Hahn),
  libvirt: fix error message when connection can't be opened (Ján Tomko),
  tests: uniformly report test failures (Eric Blake),
  qemu: minor monitor lock cleanups (Eric Blake),
  qemu: don't override earlier json error (Eric Blake),
  qemu: Refactor qemuDomainSetMemoryParameters (Peter Krempa),
  storage: cast -1 for uid_t|gid_t (Philipp Hahn),
  storage: Cast uid_t|gid_t to unsigned int (Philipp Hahn),
  util: Fix printf format for uid_t|gid_t (Philipp Hahn),
  tests: Add tests for virtio-rng device handling (Peter Krempa),
  qemu: Implement support for EGD backend for virtio-rng (Peter Krempa),
  qemu: Implement support for default 'random' backend for virtio-rng (Peter Krempa),
  conf: Add RNG device ABI compatibility check (Peter Krempa),
  conf: Add support for RNG device configuration in XML (Peter Krempa),
  conf: Add fake switch statement to warn for new device types (Peter Krempa),
  use client id for IPv6 DHCP host definition (Gene Czarcinski),
  Trivial fix: in dhcp-host the name is optional (Gene Czarcinski),
  storage: qemu-img: change INFO to DEBUG (Ján Tomko),
  storage: move qemu-img options before positional arguments (Ján Tomko),
  storage: add test for qemu-img command line generation (Ján Tomko),
  storage: separate qemu-img command generation and execution (Ján Tomko),
  storage: move flag setting after declarations (Ján Tomko),
  run: license as LGPL (Eric Blake),
  qemu_migration: Cancel running jobs on failed migration (Michal Privoznik),
  qemu_migration: Stop NBD server at Finish phase (Michal Privoznik),
  qemu_migration: Introduce qemuMigrationDriveMirror (Michal Privoznik),
  qemu_migration: Introduce qemuMigrationStartNBDServer() (Michal Privoznik),
  qemu: Introduce nbd-server-stop command (Michal Privoznik),
  qemu: Introduce nbd-server-add command (Michal Privoznik),
  qemu: Introduce nbd-server-start command (Michal Privoznik),
  Introduce NBD migration cookie (Michal Privoznik),
  qemu: Introduce NBD_SERVER capability (Michal Privoznik),
  Add support for <option> tag in network config (Pieter Hollants),
  maint: check all symfiles for sorting (Eric Blake),
  qemu: Implement virDomainMigrate*CompressionCache (Jiri Denemark),
  virsh: Add migrate-compcache command (Jiri Denemark),
  remote: Implement virDomainMigrate*CompressionCache (Jiri Denemark),
  python: Implement virDomainMigrateGetCompressionCache wrapper (Jiri Denemark),
  qemu: Implement virDomainGetJobStats (Jiri Denemark),
  qemu: Parse more fields from query-migrate QMP command (Jiri Denemark),
  virsh: Use virDomainGetJobStats in domjobinfo if available (Jiri Denemark),
  remote: Implement virDomainGetJobStats (Jiri Denemark),
  remote: Auto-allocate params in remoteDeserializeTypedParameters (Jiri Denemark),
  python: Implement virDomainGetJobStats wrapper (Jiri Denemark),
  qemu: Add support for compressed migration (Jiri Denemark),
  Introduce VIR_MIGRATE_COMPRESSED flag (Jiri Denemark),
  Update arch names in RNG schema to match virarch.c (Daniel P. Berrange),
  interface: dev type support for bond interfaces (Doug Goldstein),
  interface: add bond support to udev backend (Doug Goldstein),
  interface: Improve udev backend device type id (Doug Goldstein),
  interface: Refactor interface vlan to helper func (Doug Goldstein),
  interface: udev bridge code error handling updates (Doug Goldstein),
  interface: Refactor udev bridge to helper func (Doug Goldstein),
  conf: Refactor ABI stability checking and break long lines (Peter Krempa),
  conf: Refactor cpumask handling (Peter Krempa),
  conf: Reformat many function headers in domain_conf.c (Peter Krempa),
  conf: Fix label naming in virDomainDefFormatInternal (Peter Krempa),
  conf: Ensure that new devices are added to conf copy function (Peter Krempa),
  qemu: Refactor error paths in virQEMUDriverCreateCapabilities (Peter Krempa),
  conf: Improve core dump config error message (Peter Krempa),
  qemu: Turn closeCallbacks into virObjectLockable (Jiri Denemark),
  qemu: Run lzop with '--ignore-warn' (Michal Privoznik),
  qemu: Remove the shared disk entry if the operation is ejecting or updating (Osier Yang),
  qemu: Move the shared disk adding and sgio setting prior to attaching (Osier Yang),
  qemu: Update shared disk table when reconnecting qemu process (Osier Yang),
  qemu: Record names of domain which uses the shared disk in hash table (Osier Yang),
  qemu: Merge qemuCheckSharedDisk into qemuAddSharedDisk (Osier Yang),
  qemu: Add checking in helpers for sgio setting (Osier Yang),
  maint: enforce private symbol section sorting (Eric Blake),
  qemu: switch PCI address allocation to use virDevicePCIAddress (Ján Tomko),
  virsh: distinguish errors between missing argument and wrong option (Guannan Ren),
  maint: sort private syms to reflect recent header renames (Eric Blake),
  maint: fix header file owners of private symbols (Eric Blake),
  net: use structs for address and port ranges (Natanael Copa),
  net: add support for specifying port range for forward mode nat (Natanael Copa),
  net: support set public ip range for forward mode nat (Natanael Copa),
  qemu: Use atomic ops for driver->nactive (Jiri Denemark),
  virsh: Always print capacity unit (Jiri Denemark),
  qemu: pass "-1" as uid/gid for unprivileged qemu (Guido Günther),
  Add capabilities bit for -no-kvm-pit-reinjection (Doug Goldstein),
  Add autogenerated lxc_protocol.[ch] to gitignore (Doug Goldstein),
  drivermodule: Ignore coverity warning about leaked_storage (John Ferlan),
  storage: test backing chain traversal (Eric Blake),
  storage: don't follow backing chain symlinks too eagerly (Eric Blake),
  storage: refactor metadata lookup (Eric Blake),
  storage: prepare for refactoring (Eric Blake),
  storage: rearrange functions (Eric Blake),
  vbox: Don't overwrite errors returned by virDomainDeviceDefParse (Jiri Denemark),
  util: virSetUIDGIDWithCaps - change uid while keeping caps (Laine Stump),
  util: drop capabilities immediately after changing uid/gid of child (Laine Stump),
  qemu: let virCommand set child process security labels/uid/gid (Laine Stump),
  security: add new virSecurityManagerSetChildProcessLabel API (Laine Stump),
  util: add security label setting to virCommand (Laine Stump),
  build: define SECDRIVER_LIBS in Makefile.am (Laine Stump),
  qemu: replace exec hook with virCommandSetUID/GID in storage_backend (Laine Stump),
  qemu: replace exec hook with virCommandSetUID/GID in qemuCaps* (Laine Stump),
  util: make virSetUIDGID a NOP only when uid or gid is -1 (Laine Stump),
  util: add virCommandSetUID and virCommandSetGID (Laine Stump),
  util: refactor virCommandHook into virExec and virCommandHandshakeChild (Laine Stump),
  util: eliminate extra args from virExec (Laine Stump),
  util: eliminate generic hook from virExecWithHook (Laine Stump),
  Remove qemuDriverLock from almost everywhere (Daniel P. Berrange),
  virsh-volume.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-snapshot.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-secret.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-pool.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-nwfilter.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-nodedev.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-network.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-interface.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-host.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-domain.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh-domain-monitor.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh.c: Switch to c99 initialization of vshCmdInfo (Michal Privoznik),
  virsh: Switch to c99 initialization of vshCmdDef (Michal Privoznik),
  xen: clean up the mess with cpumap (Eric Blake),
  util: use new virendian.h macros (Eric Blake),
  util: add virendian.h macros (Eric Blake),
  Check if classes are derived from object (Guido Günther),
  virsh: Use virNodeDeviceLookupSCSIHostByWWN (Osier Yang),
  nodedev: Implement virNodeDeviceLookupSCSIHostByWWN (Osier Yang),
  remote: Wire up the remote protocol (Osier Yang),
  hypervisor: Revisit Coverity issues regarding cpumap (John Ferlan),
  hypervisor: Remove redundant validity checks, clean up function headers (John Ferlan),
  xend: Remove redundant validity checks, clean up function headers (John Ferlan),
  xm: Remove redundant validity checks, clean up function headers (John Ferlan),
  inotify: Clean up some function headers (John Ferlan),
  xs: Remove redundant validity checks, clean up function headers (John Ferlan),
  virsh-snapshot: Reject --no-metadata together with --print-xml (Peter Krempa),
  virsh-snapshot: Refactor some details in virsh snapshot-create-as (Peter Krempa),
  Pass virQEMUDriverPtr into APIs managed shared disk list (Daniel P. Berrange),
  Serialize execution of security manager APIs (Daniel P. Berrange),
  Turn virSecurityManager into a virObjectLockable (Daniel P. Berrange),
  sheepdog: skip refresh on creation failure (Harry Wei),
  util: refactor iptables command construction into multiple steps (Natanael Copa),
  qemu: support vhost-net for generic ethernet devices (Laine Stump),
  Stop accessing driver->caps directly in QEMU driver (Daniel P. Berrange),
  Rename 'qemuCapsXXX' to 'virQEMUCapsXXX' (Daniel P. Berrange),
  Turn virCapabilities into a virObject (Daniel P. Berrange),
  Fix comment about virCgroupPtr locking rules in QEMU driver (Daniel P. Berrange),
  Fix PKI directory used for QEMU test suite (Daniel P. Berrange),
  virCondDestroy: Lose attribute RETURN_CHECK (Michal Privoznik),
  Drop useless virFileWrapperFdCatchError (Michal Privoznik),
  valgrind: Adjust the suppression file (John Ferlan),
  Add syntax-check to make sure Python files don't contain trailing semicolon (Guido Günther),
  Remove more trailing semicolons in Python files (Guido Günther),
  syntax-check: Don't check non-reentrant functions in docs (Peter Krempa),
  Cosmetics: Remove semicolons (Guido Günther),
  bitmap: add way to find next clear bit (Eric Blake),
  Initialize qemuImageBinary path at startup (Daniel P. Berrange),
  Introduce annotations for virQEMUDriverPtr fields (Daniel P. Berrange),
  Protect USB/PCI device list access in QEMU with dedicated locks (Daniel P. Berrange),
  Convert virPCIDeviceList and virUSBDeviceList into virObjectLockable (Daniel P. Berrange),
  Rename all USB device functions to have a standard name prefix (Daniel P. Berrange),
  Rename all PCI device functions to have a standard name prefix (Daniel P. Berrange),
  Remove pointless 'qemuVersion' field from virQEMUDriverPtr (Daniel P. Berrange),
  Use atomic ops to increment nextvmid (Daniel P. Berrange),
  Make virDomainObjList self-locking via virObjectLockable (Daniel P. Berrange),
  Merge virDomainObjListIsDuplicate into virDomainObjListAdd (Daniel P. Berrange),
  qemu: don't log failure during QMP add-fd probe (Eric Blake),
  Turn virDomainObjList into an opaque virObject (Daniel P. Berrange),
  Rename all domain list APIs to have virDomainObjList prefix (Daniel P. Berrange),
  Introduce a virQEMUDriverConfigPtr object (Daniel P. Berrange),
  Fix missing error constants in libvirt python module (Daniel P. Berrange),
  qemu: Catch stderr of image compression binary (Michal Privoznik),
  qemu: Catch stderr of image decompression binary (Michal Privoznik),
  virFileWrapperFd: Switch to new virCommandDoAsyncIO (Michal Privoznik),
  tests: Create test for virCommandDoAsyncIO (Michal Privoznik),
  Introduce event loop to commandtest (Michal Privoznik),
  virCommand: Introduce virCommandDoAsyncIO (Michal Privoznik),
  conf: Use correct type for device type enum in virDomainDeviceDefFree (Peter Krempa),
  Support shifted magic in storage files (Martin Kletzander),
  virsh-secret: Refactor error paths (Peter Krempa),
  virsh-nwfilter: Update nwfilter commands to use vshCommandOptStringReq (Peter Krempa),
  virsh-snapshot: Update snapshot commands to use vshCommandOptStringReq (Peter Krempa),
  virsh-snapshot: Refactor cmdSnapshotDumpXML (Peter Krempa),
  virsh-nodedev: Refactor error paths, error messages and whitespace (Peter Krempa),
  virsh-nodedev: Update node device commands to use vshCommandOptStringReq (Peter Krempa),
  virsh-interface: Update interface commands to use vshCommandOptStringReq (Peter Krempa),
  virsh-network: Update network commands to use vshCommandOptStringReq (Peter Krempa),
  virsh-host: Update host commands to use vshCommandOptStringReq (Peter Krempa),
  virsh-domain: Update domain commands to use vshCommandOptStringReq (Peter Krempa),
  virsh-domain-monitor: Update domain commands to use vshCommandOptStringReq (Peter Krempa),
  virsh-volume: Update volume commands to use vshCommandOptStringReq (Peter Krempa),
  virsh-pool: Update pool commands to use vshCommandOptStringReq (Peter Krempa),
  virsh: Add helper to request string arguments with error reporting (Peter Krempa),
  virsh-pool: Rename helper function buildPoolXML to vshBuildPoolXML (Peter Krempa),
  virsh-volume: Rename helper function makeCloneXML to vshMakeCloneXML (Peter Krempa),
  virsh-snapshot: Fix coding style and remove dead code (Peter Krempa),
  hyperv: Simplify hypervPrivate pointer handling in hypervOpen (Matthias Bolte),
  esx: Simplify esxPrivate pointer handling in esxOpen (Matthias Bolte),
  maint: update to latest gnulib (Eric Blake),
  Add support for QEMU -add-fd support detection (Stefan Berger),
  qemu: expose qemu 1.3 add-fd monitor command (Eric Blake),
  tests: add a comment about our fake qmp (Eric Blake),
  spec: Avoid using makeinstall relic (Jiri Denemark),
  complete virterror->virerror name change (Serge Hallyn),
  apibuild.py: fix TypeError raised in except clause (Claudio Bley),
  Enforce return check on virAsprintf() calls (John Ferlan),
  snapshot: Mention disk-only snapshots in error message (Peter Krempa)
- Cleanups:
  Revert hack for autodestroy in qemuProcessStop (Daniel P. Berrange),
  Revert "Add support for <option> tag in network config" (Laine Stump),
  security: Remove unnecessary checks for mgr == NULL (John Ferlan),
  vircommand: Remove unnecessary sa_assert (John Ferlan),
  build: fix make check of remote_protocol-structs (Laine Stump),
  spec: Fix minor changelog issues (Jiri Denemark)

### 1.0.2: Jan 30 2013

- Features:
  LXC improvements (Daniel P. Berrange),
  S390 architecture improvement (Viktor Mihajlovski),
  Power architecture improvement (Li Zhang),
  large Coverity report cleanups and associated bug fixes (John Ferlan),
  virTypedParams* APIs to helps with those data structures (Jiri Denemark)
- Documentation:
  aesthetical cleanups (Martin Kletzander),
  fix missed documentation for virterror functions (Claudio Bley),
  util: Fix docs for virBitmapParse (Peter Krempa),
  rng: Have colorful *.rng with editor (Osier Yang),
  safe{read,write}: Document usage with nonblocking FD (Michal Privoznik),
  Generate documentation for virTypedParams* APIs (Jiri Denemark),
  event.c source file was renamed as virevent.c (Jiri Denemark),
  Add some style and color to the HTML documentation (Claudio Bley),
  don't use <i> and <tt> HTML tags (Claudio Bley),
  Assign classes to documentation elements (Claudio Bley),
  remove extra " (Eric Blake),
  maint: typo fix (Eric Blake),
  restrict the set of characters for info keys (Claudio Bley),
  simplify code (Claudio Bley),
  mention git rename detection (Eric Blake),
  add some more hacking tips (Eric Blake),
  fix typo in isa-serial additions (Laine Stump),
  network: fix typos and docs (Guannan Ren),
  maint: fix comment typo (Eric Blake),
  break longer text into paragraphs in HTML (Claudio Bley),
  remove duplicate check in index.add (Claudio Bley),
  Add missing flags to migrate documentation (Guido Günther),
  Add docs and rng schema for new XML tag sgio (Osier Yang),
  Fix the comment grammar (Osier Yang),
  Remove the inexistent function in comments (Osier Yang),
  fix typo in the word affinities (Martin Kletzander),
  Fix documentation for readonly element (Jiri Denemark),
  Replace </br> with <br/> in docs/news.html.in (Peter Krempa)
- Portability:
  Make sure we only abort without libcurl if $with_esx = yes (Guido Günther),
  build: Fix RPM build errors related to libvirt-lxc API (Viktor Mihajlovski),
  build: fix build on BSD (Eric Blake),
  build: further fixes for broken if_bridge.h (Eric Blake),
  securityselinuxhelper.c: Don't try to include xattr.h if not available (John Ferlan),
  build: work around broken kernel header (Eric Blake),
  build: avoid m4_expand for RHEL 5 (Eric Blake),
  build: move file deleting action from %files list to %install (Yufang Zhang),
  build: libvirt-guests files misplaced in specfile (Viktor Mihajlovski),
  build: fix mingw rpm build (Eric Blake),
  build: fix build with optimization enabled (Eric Blake),
  build: make broken -Wlogical-op test be gcc-only (Eric Blake),
  util: FreeBSD: stub out CPU affinity functions (Roman Bogorodskiy),
  nodeinfo: add FreeBSD support (Roman Bogorodskiy),
  build: Check for broken GCC -Wlogical-op in configure (Viktor Mihajlovski)
- Bug Fixes:
  conf: Don't format cputune element when not needed (Martin Kletzander),
  conf: Fix cpumask leak in virDomainDefFree (Ján Tomko),
  qemu: Destroy domain on decompression binary error (Michal Privoznik),
  rpc: Fix crash on error paths of message dispatching (Peter Krempa),
  vbox: Address false positive for NULL dereference (John Ferlan),
  libxl: Fix removing non-persistent domain after save (Jim Fehlig),
  libxl: Fix race between destruction of objects (Jim Fehlig),
  libxl: Fix races in libxl event code (Jim Fehlig),
  libxl: Fix handling of timeouts (Jim Fehlig),
  conf: avoid NULL deref for pmsuspended domain state (Eric Blake),
  qemu_monitor: Fix tray-open attribute in query-block (Michal Privoznik),
  Fix bogus reporting of KVM support for non-native emulators (Daniel P. Berrange),
  Move QEMU capabilities initialization later in QEMU startup (Daniel P. Berrange),
  Fix performance & reliability of QMP probing (Daniel P. Berrange),
  qemu: escape ipv6 for rbd network disk hosts (Josh Durgin),
  snapshot: fix state after external snapshot of S3 domain (Eric Blake),
  python: Fix bindings for virDomainSnapshotGet{Domain,Connect} (Jiri Denemark),
  Fix crash free'ing securityDriverNames in QEMU driver (Daniel P. Berrange),
  Fix leak of securityDriverNames (Daniel P. Berrange),
  Avoid use of free'd memory in auto destroy callback (Daniel P. Berrange),
  Ensure nodeinfo struct is initialized to zero (Daniel P. Berrange),
  apparmor: Avoid freeing uninitialized pointer (Jiri Denemark),
  xen: Actually fix the uninitialized variable (Peter Krempa),
  xen: Initialize variable before using (Peter Krempa),
  util: Need to add virCommandFree() (John Ferlan),
  storage: Need to add virCommandFree() (John Ferlan),
  security: Need to add virCommandFree() (John Ferlan),
  parallels: Resolve some resource leaks (John Ferlan),
  qemu: Re-add driver unlock to qemuDomainSendKey (Viktor Mihajlovski),
  conf: Fix usage of virBitmapParse (Peter Krempa),
  virbitmaptest: Resolve Coverity errors (John Ferlan),
  lxc_process: Avoid passing NULL iface->iname (John Ferlan),
  lxc_driver: Need to check for vm before calling virDomainUnlock(vm) (John Ferlan),
  tests: Remove VIR_FREE() on static/stack buffer (der.data) (John Ferlan),
  Fix nwfilter driver reload/shutdown handling when unprivileged (Daniel P. Berrange),
  conf: Check if number of vCPUs fits in the storage variable (Peter Krempa),
  tests: Need to initialize 'test' properly on error path (John Ferlan),
  virkeepalive: Remove erroneous VIR_FREE(msg) (John Ferlan),
  security: Need to initialize 'sens' (John Ferlan),
  interface: Need to initialize 'ifaces_list' (John Ferlan),
  storage: Need to initialize 'zerobuf' (John Ferlan),
  virsh: Need to intialize 'str' (John Ferlan),
  lxc: Need to initialize 'dst' (John Ferlan),
  virfile: Need to initialize 'looppath' (John Ferlan),
  commandtest: Need to initialize 'errbuf' (John Ferlan),
  virnetdev: Need to initialize 'pciConfigAddr' (John Ferlan),
  virnetsockettest: Need to initialize 'path' (John Ferlan),
  virnetserver: Need to initialize 'sigdata' (John Ferlan),
  conf: Need to initialize variables before VIR_FREE (John Ferlan),
  uml: Avoid resource leak of event in umlInofityEvent (John Ferlan),
  selinux: Resolve resource leak using the default disk label (John Ferlan),
  util: Need to check child JSON allocation before use (John Ferlan),
  parallels: Need to handle virJSONValueObjectGetString error (John Ferlan),
  qemu: Reject attempts to create snapshots with names containing '/' (Peter Krempa),
  qemu: Don't return success if creation of snapshot save file fails (Peter Krempa),
  Fix race condition when destroying guests (Daniel P. Berrange),
  storage: Fix lvcreate parameter for backingStore. (Atsushi Kumagai),
  virobject: Remove the bogus ! from call to virObjectInitialize() (John Ferlan),
  qemu: Check valid activeDev before calling pciDeviceSetUsedBy (John Ferlan),
  Followup fix for integer wraparound in port allocator (Daniel P. Berrange),
  qemu: Double mutex unlock in qemuDomainModifyDeviceFlags (Viktor Mihajlovski),
  fixed xt_physdev warning when defining ip(6)tables rules (Reinier Schoof),
  conf: don't fail to parse <boot> when parsing a single device (Laine Stump),
  Fix inheritance of virNetClient (Daniel P. Berrange),
  Avoid integer wrap on remotePortMax in QEMU driver (Daniel P. Berrange),
  python: Avoid freeing uninitialized new_params pointer (Jiri Denemark),
  Fix typo in variable name (Guido Günther),
  libxl: Fix cleanup on domain start error (Jim Fehlig),
  libxl: Check for libxl_ctx_alloc failure (Jim Fehlig),
  libxl: Don't free domain death event (Jim Fehlig),
  locking: Resolve resource leaks on non error path (John Ferlan),
  conf: fix leak in virDomainVcpuPinAdd (Ján Tomko),
  conf: fix class_id bitmap leak in virNetworkObj (Ján Tomko),
  qemu: fix QEMU_CAPS_NO_ACPI detection (Ján Tomko),
  openvz: Need to check 'vm' first before dereferencing 'def' (John Ferlan),
  interface: Need to check ifacedef->mac not just ifacedef after strdup() (John Ferlan),
  qemu: Don't update count of vCPUs if hot-unplug has failed (Peter Krempa),
  libvirt: lxc: don't mkdir when selinux is disabled (Gao feng),
  xen: Resolve resource leak with 'cpuset' (John Ferlan),
  interface: Resolve resource leak wth 'tmp_iface_objs' (John Ferlan),
  storage: Resource resource leak using 'tmp_vols' (John Ferlan),
  test: Resource resource leak with 'tmp_vols' (John Ferlan),
  rpc: Avoid resource leak of 'socks' if any object append fails (John Ferlan),
  util: Resolve resource leak for 'res' in virSetInherit error path. (John Ferlan),
  interface: Need to initialize 'add_to_list' (John Ferlan),
  lxc: Initialize dst due to potential cleanup usage before setting (John Ferlan),
  openvz: Need to initialize 'ret' for kb_per_pages error path (John Ferlan),
  parallels: Resolve issues with uninitialized 'ret' value (John Ferlan),
  storage: Need to also VIR_FREE(reg) (John Ferlan),
  Fix typo LIBCURL_{CFLAGS,LIBS} to CURL_{CFLAGS,LIBS} (Daniel P. Berrange),
  Fix build due to previous LXC patch (Daniel P. Berrange),
  build: fix incomplete WITH_SASL conversion (Eric Blake),
  network: bridge: Fix regression when defining persistent networks (Peter Krempa),
  storage: Resolve resource leak using 'vol' buffer (John Ferlan),
  phyp: Resolve some file descriptor leaks (John Ferlan),
  qemu_agent: Remove agent reference only when disposing it (Michal Privoznik),
  libvirt: lxc: fix incorrect parameter of lxcContainerMountProcFuse (Gao feng),
  util: Check for NULL 'dev' on input to usbFreeDevice (John Ferlan),
  maint: avoid potential promotion issues with [ug]id_t (Eric Blake),
  Resolve COPY_PASTE error found by Coverity (John Ferlan),
  storage: fix leak in virStorageBackendLogicalMakeVol (Ján Tomko),
  cpu: Avoid NULL dereference (John Ferlan),
  lxc: Avoid possible NULL dereference on *root prior to opendir(). (John Ferlan),
  remote: Avoid calling virAuthConfigLookup() if 'credname' is NULL. (John Ferlan),
  vmware: Avoid NULL dereference for 'caps' (John Ferlan),
  xen: Avoid possible NULL dereference (John Ferlan),
  Fix virLXCPrepareHostDevices method (Daniel P. Berrange),
  Only initialize capabilities after setting dir permissions (Daniel P. Berrange),
  build: install libvirt sysctl file correctly (Eric Blake),
  snapshot: qemu: Fix segfault and vanishing snapshots when redefining (Peter Krempa),
  qemu: Detect VGA_QXL capability correctly (Michal Privoznik),
  qemu: fix a segfault in qemuProcessWaitForMonitor (Ján Tomko),
  parallels: check and handle error for virAsprintf() calls (John Ferlan),
  udev: check and handle error for virAsprintf() calls (John Ferlan),
  util: fix botched check for new netlink request filters (Laine Stump),
  blockjob: fix memleak that prevented block pivot (Eric Blake),
  util: fix functions that retrieve SRIOV VF info (Laine Stump),
  Fix parsing of arch from domain XML (Daniel P. Berrange),
  Fix CPU baseline to not hardcode arch (Daniel P. Berrange),
  Fix SELinux security label test (Daniel P. Berrange),
  spec: Fix script warning when uninstalling libvirt-client (Cole Robinson),
  network: don't require private addresses if dnsmasq uses SO_BINDTODEVICE (Laine Stump),
  `apparmor: Fix build (Jiri Denemark),
  S390: Fix virSysinfoRead memory corruption (Viktor Mihajlovski)
- Improvements:
  Ignore '.trs' files (Martin Kletzander),
  build: Regenerate man pages on version bump (Jiri Denemark),
  rng: Change the datatype for volume name for common use (Osier Yang),
  rng: Remove the duplicate definition (Osier Yang),
  qemu_hotplug: Rework media changing process (Michal Privoznik),
  maint: one missed syms file (Eric Blake),
  vbox: Adjust the UTF FREE macros (John Ferlan),
  virsh: Add --print-xml flag for attach-disk command (Peter Krempa),
  libxl: Domain event handler improvements (Jim Fehlig),
  libxl: Explicitly remove timeouts (Jim Fehlig),
  maint: make it easier to sort syms files (Eric Blake),
  qemuDomainSendKey: Relax the qemu driver locking (Michal Privoznik),
  node_memory: Add '\n' to help message (Satoru Moriya),
  locking: use virStrcpyStatic instead of memcpy (John Ferlan),
  Make python objects inherit from 'object' base class (Daniel P. Berrange),
  selinux: Properly indent preprocessor directives (Jiri Denemark),
  selinux: Only create the selabel_handle once. (Richard W.M. Jones),
  parallels_utils: Check return status properly from virCommandRun() (John Ferlan),
  test: Add support for thread and core information for the test driver (Peter Krempa),
  capabilities: Add additional data to the NUMA topology info (Peter Krempa),
  capabilities: Switch CPU data in NUMA topology to a struct (Peter Krempa),
  conf: Split out NUMA topology formatting to simplify access to data (Peter Krempa),
  schemas: Add schemas for more CPU topology information in the caps XML (Peter Krempa),
  schema: Make the cpuset type reusable across schema files (Peter Krempa),
  S390: Enhance memballoon handling for virtio-s390 (Viktor Mihajlovski),
  qemu_agent: Ignore expected EOFs (Michal Privoznik),
  nodeinfo: Use sa_assert() instead of Coverity error tag (John Ferlan),
  build: allow virObject to have no parent (Eric Blake),
  qemu: Support ram bar size for qxl devices (Alon Levy),
  viralloc: Adjust definition of VIR_FREE() for Coverity (John Ferlan),
  conf: Improve error messages if parsing of vCPU count fails (Peter Krempa),
  virsh-domain: Refactor error paths for cmdCPUStats (Peter Krempa),
  fix typos in comments for VIR_DOMAIN_PROCESS_SIGNAL_{PWR,SYS} (Claudio Bley),
  storage: Add coverity[dead_error_condition] to avoid error (John Ferlan),
  network: Add coverity[leaked_handle] to ignore error (John Ferlan),
  remote: Avoid coverity[leaked_storage] message. (John Ferlan),
  qemu: Add coverity[negative_returns] tag (John Ferlan),
  rpc: Add coverity[dead_error_begin] tag (John Ferlan),
  xen: Add coverity[ptr_arith] and [sign_extension] tags (John Ferlan),
  nodeinfo: Add coverity[dead_error_begin] and [returned_null] tags (John Ferlan),
  lxc: Add coverity[dead_error_begin] tag in switch stmts (John Ferlan),
  xend: Address some Coverity false positives (John Ferlan),
  security: Use virStrcpy to move the label (John Ferlan),
  qemu: Forbid snapshot names starting with '.' (Peter Krempa),
  spec: indent %if to make it easier to see conditions (Eric Blake),
  Log flags passed to qemuMigrationPrepare{Tunnel,Direct} APIs (Michal Privoznik),
  Introduce virTypedParamsClear public API (Jiri Denemark),
  virsh: Use virTypedParams* APIs in cpu-stats (Jiri Denemark),
  virsh: Use virTypedParams* APIs in node-memory-tune (Jiri Denemark),
  virsh: Use virTypedParams* APIs in numatune (Jiri Denemark),
  virsh: Use virTypedParams* APIs in memtune (Jiri Denemark),
  virsh: Use virTypedParams* APIs in domblkstat (Jiri Denemark),
  virsh: Use virTypedParams* APIs in schedinfo (Jiri Denemark),
  virsh: Use virTypedParams* APIs in domiftune (Jiri Denemark),
  virsh: Use virTypedParams* APIs in blkiotune (Jiri Denemark),
  virsh: Use virTypedParams* APIs in blkdeviotune (Jiri Denemark),
  Add virTypedParams* APIs (Jiri Denemark),
  qemu: Simplify condition with already extracted flag (Peter Krempa),
  network: use bandwidth from portgroup when appropriate (Laine Stump),
  network: Resolve some issues around vlan copying (John Ferlan),
  lock_daemon: Simplify error handling (Peter Krempa),
  virsh-volume.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-snapshot.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-secret.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-pool.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-nwfilter.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-nodedev.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-network.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-interface.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-host.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-domain-monitor.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh-domain.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  virsh.c: Switch to C99 initialization of vshCmdOptDef (Michal Privoznik),
  libvirt.c: fix typo in comment (Claudio Bley),
  Move comments after enum members (Claudio Bley),
  include virterror_internal.h in threads.h (Hu Tao),
  include util.h in cgroup.h (Hu Tao),
  call virstateCleanup to do the cleanup before libvirtd exits (Hu Tao),
  libxl: Use consistent parameter naming scheme (Jim Fehlig),
  libxl: Use consistent style for function definitions (Jim Fehlig),
  Convert libxl driver over to use virPortAllocator APIs (Daniel P. Berrange),
  Convert QEMU driver over to use virPortAllocator APIs (Daniel P. Berrange),
  Add a port allocator class (Daniel P. Berrange),
  Convert all rpc classes over to virObjectLockable (Daniel P. Berrange),
  Convert virDomainObj, qemuAgent, qemuMonitor, lxcMonitor to virObjectLockable (Daniel P. Berrange),
  util: Check for negative indent in virBufferAdd (John Ferlan),
  tools: Check return status on virBufferTrim() (John Ferlan),
  rpc: Check and message setsockopt() (John Ferlan),
  xen: Ignore return status for TCP_NODELAY (John Ferlan),
  Add a virObjectLockable class holding a mutex (Daniel P. Berrange),
  Allow for multi-level inheritance of virObject classes (Daniel P. Berrange),
  Add 'lxc-enter-namespace' command to virsh (Daniel P. Berrange),
  build: add new file, for lxc_protocol checking (Eric Blake),
  Add implementation of virDomainLxcOpenNamespace to LXC driver (Daniel P. Berrange),
  Implement the RPC protocol for the libvirt-lxc.la library (Daniel P. Berrange),
  .gitignore: Sort alphabetically (Michal Privoznik),
  Add missing stubs to securityselinuxhelper.c (Daniel P. Berrange),
  Introduce an LXC specific public API & library (Daniel P. Berrange),
  Add a test suite for validating SELinux labelling (Daniel P. Berrange),
  Rename HAVE_POLKIT to WITH_POLKIT (Daniel P. Berrange),
  Remove unused XMLRPC_REQUIRED var (Daniel P. Berrange),
  Convert openwsman check to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Convert ssh2 check to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Rename HAVE_LIBSSH2 to WITH_SSH2 (Daniel P. Berrange),
  Convert curl check over to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Rename HAVE_LIBCURL to WITH_CURL (Daniel P. Berrange),
  Convert fuse check over to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Rename HAVE_FUSE to WITH_FUSE (Daniel P. Berrange),
  Rename HAVE_GNUTLS to WITH_GNUTLS (Daniel P. Berrange),
  Convert blkid check over to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Convert HAVE_LIBBLKID to WITH_BLKID (Daniel P. Berrange),
  Convert HAL check to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Convert HAVE_HAL to WITH_HAL (Daniel P. Berrange),
  Convert udev/pciaccess checks to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Convert HAVE_UDEV to WITH_UDEV (Daniel P. Berrange),
  Convert avahi check to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Convert HAVE_AVAHI to WITH_AVAHI (Daniel P. Berrange),
  Convert DBus check to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Convert HAVE_DBUS to WITH_DBUS (Daniel P. Berrange),
  Convert netcf check to use LIBVIRT_CHECK_PKG (Daniel P. Berrange),
  Convert cap-ng check to use LIBVIRT_CHECK_LIB (Daniel P. Berrange),
  Convert HAVE_CAPNG to WITH_CAPNG (Daniel P. Berrange),
  Convert numactl checks to use LIBVIRT_CHECK_LIB (Daniel P. Berrange),
  Convert HAVE_NUMACTL to WITH_NUMACTL (Daniel P. Berrange),
  Convert apparmor check to use LIBVIRT_CHECK_LIB (Daniel P. Berrange),
  Convert selinux check to use LIBVIRT_CHECK_LIB (Daniel P. Berrange),
  Convert HAVE_SELINUX to WITH_SELINUX (Daniel P. Berrange),
  qemu: Fix grouping of capabilities strings (Peter Krempa),
  network: Report real error if addition of firewall rules fails (Peter Krempa),
  virsh: Reformat output of virsh net-list (Peter Krempa),
  Convert audit check to use LIBVIRT_CHECK_LIB (Daniel P. Berrange),
  Convert HAVE_AUDIT to WITH_AUDIT (Daniel P. Berrange),
  Convert sasl check to use LIBVIRT_CHECK_LIB_ALT (Daniel P. Berrange),
  Convert HAVE_SASL to WITH_SASL (Daniel P. Berrange),
  Convert sanlock check to use LIBVIRT_CHECK_LIB (Daniel P. Berrange),
  Convert HAVE_SANLOCK to WITH_SANLOCK (Daniel P. Berrange),
  Convert yajl check to use LIBVIRT_CHECK_LIB_ALT (Daniel P. Berrange),
  Convert HAVE_YAJL into WITH_YAJL (Daniel P. Berrange),
  Add some autoconf helper macros for checking for libraries (Daniel P. Berrange),
  build: require avahi instead of avahi-libs on rhel5. (Yufang Zhang),
  util: reduce syscalls for virGetDeviceID (Eric Blake),
  pass stub driver name instead of pciFindStubDriver (Chunyan Liu),
  qemu: add usb-net caps flag (Guannan Ren),
  qemu: add usb-serial support (Guannan Ren),
  qemu: add usb-serial caps flag (Guannan Ren),
  maint: distribute libvirtd.service.in (Eric Blake),
  Add RESUME event listener to qemu monitor. (Andres Lagar-Cavilla),
  nwfilter: Remove unprivileged code path to set base (John Ferlan),
  Make TLS support conditional (Daniel P. Berrange),
  qemu: Relax hard RSS limit (Michal Privoznik),
  S390: Enable SCLP Console in QEMU driver (J.B. Joret),
  S390: Add SCLP console front end support (J.B. Joret),
  Rename lxc_protocol.x to lxc_monitor_protocol.x (Daniel P. Berrange),
  Add internal APIs for dealing with namespaces (Daniel P. Berrange),
  Add a way to return FDs to the RPC caller (Daniel P. Berrange),
  Fix receiving of file descriptors from server (Daniel P. Berrange),
  Move qemu-XXX commands from virsh-host.c to virsh-domain.c (Daniel P. Berrange),
  Ensure we always setup a private mount namespace for LXC controller (Daniel P. Berrange),
  Speed up fallback to legacy non-QMP probing (Daniel P. Berrange),
  build: Add libxenctrl to LIBXL_LIBS (Jim Fehlig),
  build: .service files don't need to be executable (Eric Blake),
  build: properly substitute virtlockd.socket (Eric Blake),
  build: use common .in replacement mechanism (Eric Blake),
  qemu: Check if the shared disk's cdbfilter conflicts with others (Osier Yang),
  qemu: set unpriv_sgio when starting domain and attaching disk (Osier Yang),
  conf: Parse and format the new XML (Osier Yang),
  qemu: Add a hash table for the shared disks (Osier Yang),
  util: Prepare helpers for unpriv_sgio setting (Osier Yang),
  snapshot: qemu: Allow redefinition of external snapshots (Peter Krempa),
  snapshot: qemu: Separate logic blocks with newlines (Peter Krempa),
  snapshot: conf: Make virDomainSnapshotIsExternal more reusable (Peter Krempa),
  qemu: Implement virDomainOpenChannel API (John Eckersberg),
  conf: Add unix socket support to virChrdevOpen (John Eckersberg),
  conf: Rename console-specific identifiers to be more generic (John Eckersberg),
  conf: Rename virconsole.* to virchrdev.* (John Eckersberg),
  api: Add API to tunnel a guest channel via stream (John Eckersberg),
  network: fix check for ambiguous lookup (Eric Blake),
  Check and handle select() errors from waitsocket(). (John Ferlan),
  tests: check and handle error for virAsprintf() calls (John Ferlan),
  Check return on mkdir for LOCKSPACE_DIR (John Ferlan),
  vmware: silence Coverity warning (John Ferlan),
  Install virtlockd.{socket,service} non executable (Guido Günther),
  qemu: Don't parse log output when starting up a domain (Michal Privoznik),
  build: use autobuild module to make build logs nicer (Eric Blake),
  maint: update to latest gnulib (Eric Blake),
  sanlock: Chown lease files as well (Michal Privoznik),
  python: Adapt to virevent rename (Michal Privoznik),
  qemu: Convert some APIs to use qemuDomObjFromDomain (Michal Privoznik),
  qemu: Relax locking in DomainHasManagedSaveImage and DomainMonitorCommand (Michal Privoznik),
  S390: Re-enable capability probing for virtio devices. (Viktor Mihajlovski),
  Sort util files in Makefile.am alphabetically (Daniel P. Berrange),
  Rename virterror.c virterror_internal.h to virerror.{c,h} (Daniel P. Berrange),
  Rename xml.{c,h} to virxml.{c,h} (Daniel P. Berrange),
  Rename uuid.{c,h} to viruuid.{c,h} (Daniel P. Berrange),
  Rename util.{c,h} to virutil.{c,h} (Daniel P. Berrange),
  Rename threads.{c,h} to virthread.{c,h} (Daniel P. Berrange),
  Rename threadpool.{c,h} to virthreadpool.{c,h} (Daniel P. Berrange),
  Rename sysinfo.{c,h} to virsysinfo.{c,h} (Daniel P. Berrange),
  Rename storage_file.{c,h} to virstoragefile.{c,h} (Daniel P. Berrange),
  Rename stats_linux.{c,h} to virstatslinux.{c,h} (Daniel P. Berrange),
  Rename sexpr.{c,h} to virsexpr.{c,h} (Daniel P. Berrange),
  Merge processinfo.{c,h} into virprocess.{c,h} (Daniel P. Berrange),
  Rename pci.{c,h} to virpci.{c,h} (Daniel P. Berrange),
  Rename memory.{c,h} to viralloc.{c,h} (Daniel P. Berrange),
  Rename logging.{c,h} to virlog.{c,h} (Daniel P. Berrange),
  Rename json.{c,h} to virjson.{c,h} (Daniel P. Berrange),
  Rename iptables.{c,h} to viriptables.{c,h} (Daniel P. Berrange),
  Rename hostusb.{c,h} to virusb.{c,h} (Daniel P. Berrange),
  Rename hooks.{c,h} to virhook.{c,h} (Daniel P. Berrange),
  Rename event_poll.{c,h} to vireventpoll.{c,h} (Daniel P. Berrange),
  Rename event.{c,h} to virevent.{c,h} (Daniel P. Berrange),
  Rename ebtables.{c,h} to virebtables.{c,h} (Daniel P. Berrange),
  Rename dnsmasq.{c,h} to virdnsmasq.{c,h} (Daniel P. Berrange),
  Rename conf.{c,h} to virconf.{c,h} (Daniel P. Berrange),
  Rename command.{c,h} to vircommand.{c,h} (Daniel P. Berrange),
  Rename buf.{c,h} to virbuffer.{c,h} (Daniel P. Berrange),
  Rename bitmap.{c,h} to virbitmap.{c,h} (Daniel P. Berrange),
  Rename cgroup.{h,c} to vircgroup.{h,c} (Daniel P. Berrange),
  Support all backend serial devices for pSeries guest (Li Zhang),
  Remove QEMU_CAPS_NO_ACPI capability for non-x86 platform (Li Zhang),
  Set std VGA model as default model for ppc64. (Li Zhang),
  Add sysinfo data and enable virSysinfoRead test case for POWER (Li Zhang),
  util: add missing error log messages when failing to get netlink VFINFO (Laine Stump),
  security: fix #endif comment in security_stack.h (Ján Tomko),
  build: use strchr now that we can work around broken gcc (Eric Blake),
  Fix arch datatype in vahControl in virt-aa-helper.c (Daniel P. Berrange),
  Change string form of VIR_ARCH_ITANIUM back to ia64 (Daniel P. Berrange),
  conf: eliminate redundant use of VIR_ALLOC (Martin Kletzander),
  Fix libxl driver for virArch changes (Daniel P. Berrange),
  Fix test cases for virArch changes (Daniel P. Berrange),
  Fix XenAPI driver for virArch changes (Daniel P. Berrange),
  Export all symbols from virarch.{c,h} to drivers/tests/etc (Daniel P. Berrange),
  Convert QEMU capabilities code to use virArch (Daniel P. Berrange),
  spec: Do not install *.py[co] in python examples (Jiri Denemark),
  Convert CPU APIs to use virArch (Daniel P. Berrange),
  Convert capabilities / domain_conf to use virArch (Daniel P. Berrange),
  Convert QEMU command line builder to virArch APIs (Daniel P. Berrange),
  Convert nodeGetInfo to virArch APIs (Daniel P. Berrange),
  Introduce a set of APIs for managing architectures (Daniel P. Berrange),
  build: Fix AUTHORS generation (Jiri Denemark),
  network: fix indentation of networkDnsmasqConfContents (Laine Stump),
  .gitignore: add tests/sysinfotest (Cole Robinson),
  hostusb: Move USB_DEVFS define to hostusb.h to fix the build (Cole Robinson),
  daemon: Preface polkit error output with 'polkit:' (Cole Robinson),
  Add support for hotplug/unplug of host misc devices in LXC (Daniel P. Berrange),
  Add support for hotplug/unplug of host storage devices in LXC (Daniel P. Berrange),
  Add support for hotplug/unplug of USB host devices in LXC (Daniel P. Berrange),
  Add support for hotplug/unplug of NIC devices in LXC (Daniel P. Berrange),
  Add support for hotplug/unplug of disk devices in LXC (Daniel P. Berrange),
  Add support for attach/detach/update hostdev devices in config for LXC (Daniel P. Berrange),
  Add support for attach/detach/update disk devices in config for LXC (Daniel P. Berrange),
  Add support for attach/detach/update net devices in config for LXC (Daniel P. Berrange),
  Add basic driver API framework for device attach/detach support in LXC (Daniel P. Berrange),
  Add support for misc host device passthrough with LXC (Daniel P. Berrange),
  Add support for storage host device passthrough with LXC (Daniel P. Berrange),
  Add support for USB host device passthrough with LXC (Daniel P. Berrange),
  Add support for disks with LXC (Daniel P. Berrange),
  Add support for SELinux labelling of hostdev storage/misc devices (Daniel P. Berrange),
  Refactor SELinux security driver hostdev labelling (Daniel P. Berrange),
  Allow passing a vroot into security manager hostdev labelling (Daniel P. Berrange),
  Skip bulk relabelling of resources in SELinux driver when used with LXC (Daniel P. Berrange),
  Refactor LXC NIC creation to allow reuse by hotplug code (Daniel P. Berrange),
  Add support for <hostdev mode="capabilities"> (Daniel P. Berrange),
  tests: Add tests for sysinfo (Viktor Mihajlovski),
  conf: cpu: Break some long lines (Peter Krempa),
  conf: cpu: Refactor parsing of vendor_id and fallback attributes (Peter Krempa),
  conf: cpu: Fix memory leak when specifying cpu vendor_id manually (Peter Krempa),
  conf: cpu: Fix parsing of vendor_id (Ken ICHIKAWA),
  Support custom 'svirt_tcg_t' context for TCG based guests (Daniel P. Berrange),
  tests: add one -device video device testcase (Guannan Ren),
  qemu: use newer -device video device in qemu commandline (Guannan Ren),
  conf: add optional attribte primary to video <model> element (Guannan Ren),
  qemu: add qemu vga devices caps and one cap to mark them usable (Guannan Ren)
- Cleanups:
  virlog: remove old code comment (Doug Goldstein),
  rpc: Revert Coverity tag message (John Ferlan),
  rpc: Remove unnecessary calls (John Ferlan),
  network: Remove dead code getting, but not using ipdef (John Ferlan),
  esx: No need to check for objectSpec (John Ferlan),
  parallels: Remove unused JSON fetch of "OS" (John Ferlan),
  virsh: Remove unused setting of 'br_node' and 'if_node' (John Ferlan),
  util: Remove the unused setting of 'res' for virHashLookup return (John Ferlan),
  locking: Remove unnecessary setting of lockspace (John Ferlan),
  maint: don't distribute generated .def files (Eric Blake),
  spec: remove redundant %if (Eric Blake),
  libvirt.h.in: Fix indentation (Michal Privoznik),
  Fix wrong indentation for virDomainState (Claudio Bley),
  tests: Remove remnants of removing the fake emulator output (John Ferlan),
  phyp: Remove deadcode referencing exit_status (John Ferlan),
  build: avoid compiler warning (Eric Blake),
  maint: formatting cleanups in buf.c (Eric Blake),
  conf: minor indentation cleanups (Martin Kletzander)